2008-08-10  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Reviewed (and updated) by Alp Toker.

        https://bugs.webkit.org/show_bug.cgi?id=16620
        [GTK] Autotools make dist and make check support

        Get make dist working.

        Note that not all possible configurations have been tested yet.

        * GNUmakefile.am:

2008-08-09  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Sam Weinig.

        Added same heap debug checks to more code paths.

        * kjs/JSActivation.cpp:
        (KJS::JSActivation::put):
        (KJS::JSActivation::putWithAttributes):
        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::putWithAttributes):
        * kjs/JSObject.h:
        (KJS::JSObject::putDirect):
        * kjs/JSVariableObject.h:
        (KJS::JSVariableObject::symbolTablePut):
        (KJS::JSVariableObject::symbolTablePutWithAttributes):

2008-08-09  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Fix some style issues in the sampling tool.

        * VM/SamplingTool.cpp:
        (KJS::sleepForMicroseconds):
        (KJS::SamplingTool::dump):

2008-08-09  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Revision 35651, despite being a rather trivial change, introduced a
        large regression on the regexp-dna SunSpider test. This regression
        stemmed from an increase in the size of CodeBlock::dump(). There is
        no reason for this method (and several related methods) to be compiled
        in non-debug builds with the sampling tool disabled. This patch
        conditionally compiles them, reversing the regression on SunSpider.

        * JavaScriptCore.exp:
        * VM/CodeBlock.cpp:
        * VM/CodeBlock.h:
        * VM/Machine.cpp:

2008-08-08  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Bug 20330: JSCore crash loading any filehurricane media page
        <https://bugs.webkit.org/show_bug.cgi?id=20330>

        Fix a typo in the constant loading patch. Also, add a case for
        op_unexpected_load to CodeBlock::dump().

        * VM/CodeBlock.cpp:
        (KJS::CodeBlock::dump):
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::addUnexpectedConstant):

2008-08-08  Matt Lilek  <webkit@mattlilek.com>

        Not reviewed, build fix.

        * JavaScriptCore.exp:

2008-08-08  Oliver Hunt  <oliver@apple.com>

        Reviewed by Cameron Zwarich.

        Improve performance of arithmetic operators

        Added a fast (non-virtual) mechanism to determine if a non-immediate JSValue*
        is a JSNumberCell.  We then use this to allow improved specialisation in many
        arithmetic operators.  SunSpider reports a 2.5% progression overall, with greater
        than 10% progressions on a number of arithmetic heavy tests.

        * VM/Machine.cpp:
        (KJS::fastIsNumber):
        (KJS::fastToInt32):
        (KJS::fastToUInt32):
        (KJS::jsLess):
        (KJS::jsLessEq):
        (KJS::jsAdd):
        (KJS::Machine::privateExecute):
        * kjs/JSNumberCell.h:
        (KJS::JSNumberCell::fastToInt32):
        (KJS::JSNumberCell::fastToUInt32):
        * kjs/collector.cpp:
        (KJS::allocateBlock):
        (KJS::Heap::heapAllocate):
        * kjs/collector.h:
        (KJS::Heap::fastIsNumber):

2008-08-06  Adam Roben  <aroben@apple.com>

        Try to fix the Windows build bots

        * API/JSBase.cpp: Touch this to force JSC to rebuild and re-copy the
        WTF headers.

2008-08-06  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Revert change 35595.

        * wtf/RetainPtr.h:

2008-08-06  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Fix non-Mac build.

        * wtf/RetainPtr.h: CoreFoundation only for PLATFORM(MAC)

2008-08-06  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Fix non-Mac build.

        * wtf/RetainPtr.h: CoreFoundation only for PLATFORM(MAC)

2008-08-06  Csaba Osztrogonac  <oszi@inf.u-szeged.hu>

        Reviewed by Darin. Landed by Cameron.

        Bug 20272: typo in JavaScriptCore
        <https://bugs.webkit.org/show_bug.cgi?id=20272>

        Correct the documentation for op_not. (typo)
        Fix #undef. (typo)

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):

2008-08-06  Cameron Zwarich  <cwzwarich@webkit.org>

        Reviewed by Maciej.

        Bug 20286: Load constants all at once instead of using op_load
        <https://bugs.webkit.org/show_bug.cgi?id=20286>

        Load constants all at once into temporary registers instead of using
        individual instances of op_load.

        This is a 2.6% speedup on SunSpider.

        * JavaScriptCore.exp:
        * VM/CodeBlock.cpp:
        (KJS::CodeBlock::dump):
        (KJS::CodeBlock::mark):
        * VM/CodeBlock.h:
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::CodeGenerator):
        (KJS::CodeGenerator::newTemporary):
        (KJS::CodeGenerator::addConstant):
        (KJS::CodeGenerator::addUnexpectedConstant):
        (KJS::CodeGenerator::emitLoad):
        (KJS::CodeGenerator::emitUnexpectedLoad):
        (KJS::CodeGenerator::emitNewError):
        * VM/CodeGenerator.h:
        * VM/Machine.cpp:
        (KJS::slideRegisterWindowForCall):
        (KJS::Machine::unwindCallFrame):
        (KJS::Machine::throwException):
        (KJS::Machine::execute):
        (KJS::Machine::privateExecute):
        * VM/Machine.h:
        * VM/Opcode.h:
        * VM/RegisterID.h:
        (KJS::RegisterID::RegisterID):
        (KJS::RegisterID::makeConstant):
        (KJS::RegisterID::isTemporary):
        * kjs/NodeInfo.h:
        * kjs/Parser.cpp:
        (KJS::Parser::didFinishParsing):
        * kjs/Parser.h:
        (KJS::Parser::parse):
        * kjs/grammar.y:
        * kjs/nodes.cpp:
        (KJS::NullNode::emitCode):
        (KJS::BooleanNode::emitCode):
        (KJS::NumberNode::emitCode):
        (KJS::StringNode::emitCode):
        (KJS::ArrayNode::emitCode):
        (KJS::DeleteResolveNode::emitCode):
        (KJS::DeleteValueNode::emitCode):
        (KJS::VoidNode::emitCode):
        (KJS::ConstDeclNode::emitCodeSingle):
        (KJS::ReturnNode::emitCode):
        (KJS::ScopeNode::ScopeNode):
        (KJS::ProgramNode::ProgramNode):
        (KJS::ProgramNode::create):
        (KJS::EvalNode::EvalNode):
        (KJS::EvalNode::create):
        (KJS::FunctionBodyNode::FunctionBodyNode):
        (KJS::FunctionBodyNode::create):
        (KJS::FunctionBodyNode::emitCode):
        * kjs/nodes.h:
        (KJS::ScopeNode::neededConstants):

2008-08-05  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Cameron.

        - add fast path for immediates to % operator, as we have for many other math ops
        
        This fixes handling for a 0 divisor relative to the last patch. Only an 0.2% speedup on SunSpider but
        still a 1.4x win on Oliver's prime test.
        
        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):

2008-08-05  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Darin.

        Bug 20293: Crash in JavaScript codegen for eval("const a;")
        <https://bugs.webkit.org/show_bug.cgi?id=20293>

        Correctly handle constant declarations in eval code with no initializer.

        * kjs/nodes.cpp:
        (KJS::ConstDeclNode::emitCodeSingle):

2008-08-05  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Roll out r35555 because of correctness issues.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):

2008-08-05  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Geoff.
        
        - add fast path for immediates to % operator, as we have for many other math ops
        
        0.6% speedup on SunSpider. 1.4x speedup on a prime testing torture test that Oliver whipped up.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):

2008-07-31  Oliver Hunt  <oliver@apple.com>

        Reviewed by Cameron Zwarich.

        Bug 19359: JavaScriptCore behaves differently from FF2/3 and IE when handling context in catch statement
        <https://bugs.webkit.org/show_bug.cgi?id=19359>

        Make our catch behave like Firefox and IE, we do this by using a StaticScopeObject
        instead of a generic JSObject for the scope node.  We still don't make use of the
        fact that we have a static scope inside the catch block, so the internal performance
        of the catch block is not improved, even though technically it would be possible to
        do so.

        * VM/CodeBlock.cpp:
        (KJS::CodeBlock::dump):
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitPushNewScope):
        * VM/CodeGenerator.h:
        * VM/Machine.cpp:
        (KJS::createExceptionScope):
        (KJS::Machine::privateExecute):
        * VM/Machine.h:
        * VM/Opcode.h:
        * kjs/JSStaticScopeObject.cpp:
        (KJS::JSStaticScopeObject::toThisObject):
        (KJS::JSStaticScopeObject::put):
        * kjs/JSStaticScopeObject.h:
        * kjs/nodes.cpp:
        (KJS::TryNode::emitCode):

2008-08-02  Rob Gowin  <robg@gowin.net>

        Reviewed by Eric Seidel.

        Added JavaScriptCore/API/WebKitAvailability to list of files in
        javascriptcore_h_api.

        * GNUmakefile.am:

2008-08-01  Alexey Proskuryakov  <ap@webkit.org>

        Rubber-stamped by Maciej.

        Remove JSGlobalData::DataInstance. It was only needed when we had per-thread JSGlobalData
        instances.

        * kjs/JSGlobalData.h:

2008-07-31  Kevin Ollivier <kevino@theolliviers.com>

        Second attempt at Windows/wx build fix. Instead of avoiding inclusion of windows.h,
        use defines, etc. to avoid conflicts in each affected file. Also, change PLATFORM(WIN)
        to PLATFORM(WIN_OS) so that other ports using Windows headers get the right impls.

        * VM/SamplingTool.cpp:
        * wtf/Threading.h:

2008-07-31  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam.

        Fix Windows build.
        
        * kjs/collector.h:
        * wtf/FastMalloc.cpp:

2008-07-31  Csaba Osztrogonac  <oszi@inf.u-szeged.hu>

        Reviewed by Simon.

        Bug 20170: [Qt] missing namespace defines in JavaScriptCore.pro
        <https://bugs.webkit.org/show_bug.cgi?id=20170>

        * JavaScriptCore.pro: Added missing define.

2008-07-31  Alexey Proskuryakov  <ap@webkit.org>

        Rubber-stamped by Maciej.

        Eliminate JSLock (it was already disabled, removing the stub implementaion and all
        call sites now).

        * API/JSBase.cpp:
        (JSEvaluateScript):
        (JSCheckScriptSyntax):
        (JSGarbageCollect):
        * API/JSCallbackConstructor.cpp:
        (KJS::constructJSCallback):
        * API/JSCallbackFunction.cpp:
        (KJS::JSCallbackFunction::call):
        * API/JSCallbackObjectFunctions.h:
        (KJS::::init):
        (KJS::::getOwnPropertySlot):
        (KJS::::put):
        (KJS::::deleteProperty):
        (KJS::::construct):
        (KJS::::hasInstance):
        (KJS::::call):
        (KJS::::getPropertyNames):
        (KJS::::toNumber):
        (KJS::::toString):
        (KJS::::staticValueGetter):
        (KJS::::callbackGetter):
        * API/JSContextRef.cpp:
        (JSGlobalContextCreateInGroup):
        (JSGlobalContextRetain):
        (JSGlobalContextRelease):
        * API/JSObjectRef.cpp:
        (JSObjectMake):
        (JSObjectMakeFunctionWithCallback):
        (JSObjectMakeConstructor):
        (JSObjectMakeFunction):
        (JSObjectHasProperty):
        (JSObjectGetProperty):
        (JSObjectSetProperty):
        (JSObjectGetPropertyAtIndex):
        (JSObjectSetPropertyAtIndex):
        (JSObjectDeleteProperty):
        (JSObjectCallAsFunction):
        (JSObjectCallAsConstructor):
        (JSObjectCopyPropertyNames):
        (JSPropertyNameArrayRelease):
        (JSPropertyNameAccumulatorAddName):
        * API/JSStringRef.cpp:
        (JSStringRelease):
        * API/JSValueRef.cpp:
        (JSValueIsEqual):
        (JSValueIsInstanceOfConstructor):
        (JSValueMakeNumber):
        (JSValueMakeString):
        (JSValueToNumber):
        (JSValueToStringCopy):
        (JSValueToObject):
        (JSValueProtect):
        (JSValueUnprotect):
        * ForwardingHeaders/JavaScriptCore/JSLock.h: Removed.
        * GNUmakefile.am:
        * JavaScriptCore.exp:
        * JavaScriptCore.order:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * kjs/AllInOneFile.cpp:
        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::JSGlobalData):
        * kjs/JSGlobalData.h:
        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::~JSGlobalObject):
        (KJS::JSGlobalObject::init):
        * kjs/JSLock.cpp: Removed.
        * kjs/JSLock.h: Removed.
        * kjs/Shell.cpp:
        (functionGC):
        (jscmain):
        * kjs/collector.cpp:
        (KJS::Heap::~Heap):
        (KJS::Heap::heapAllocate):
        (KJS::Heap::setGCProtectNeedsLocking):
        (KJS::Heap::protect):
        (KJS::Heap::unprotect):
        (KJS::Heap::collect):
        * kjs/identifier.cpp:
        * kjs/interpreter.cpp:
        (KJS::Interpreter::checkSyntax):
        (KJS::Interpreter::evaluate):

2008-07-31  Alexey Proskuryakov  <ap@webkit.org>

        Rubber-stamped by Oliver Hunt.

        Fix the Mac project to not display "test/" as part of file name for tests.

        * JavaScriptCore.xcodeproj/project.pbxproj:

2008-07-31  Eric Seidel  <eric@webkit.org>

        Reviewed by Alexey Proskuryakov.
        
        Rename USE(MULTIPLE_THREADS) to ENABLE(JSC_MULTIPLE_THREADS)
        to better match the use/enable pattern (and better describe
        the usage of the feature in question.)
        
        I also fixed a couple other ENABLE_ macros to be pre-processor
        definition override-able to match the rest of the ENABLE_ macros
        since it seems to be our convention that build systems can set
        ENABLE_ macros in Makefiles.

        * kjs/InitializeThreading.cpp:
        (KJS::initializeThreadingOnce):
        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::JSGlobalData):
        (KJS::JSGlobalData::~JSGlobalData):
        * kjs/MathObject.cpp:
        * kjs/collector.cpp:
        (KJS::Heap::Heap):
        (KJS::Heap::~Heap):
        (KJS::allocateBlock):
        (KJS::Heap::markStackObjectsConservatively):
        * kjs/collector.h:
        * kjs/dtoa.cpp:
        (KJS::pow5mult):
        (KJS::rv_alloc):
        (KJS::freedtoa):
        (KJS::dtoa):
        * wtf/FastMalloc.cpp:
        * wtf/Platform.h:
        * wtf/RefCountedLeakCounter.cpp:

2008-07-30  Eric Seidel  <eric@webkit.org>

        Reviewed by Mark Rowe.
        
        Try to clean up our usage of USE(MULTIPLE_THREADS) vs. USE(PTHREADS) a little.
        It looks like JSC assumes that if MULTIPLE_THREADS is defined, then pthreads will always be available
        I'm not sure that's always the case for gtk, certainly not for Windows.  We should eventually go back
        and fix wtf/Threading.h to cover all these cases some day.

        * kjs/JSLock.cpp:
        * kjs/collector.h:
        * wtf/Platform.h:

2008-07-30  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver.
        
        MSVC warns when structs are called classes or vice versa.
        Make all the source refer to JSGlobalData as a class.

        * kjs/CommonIdentifiers.h:
        * kjs/JSGlobalData.h:
        * kjs/Parser.h:
        * kjs/lexer.h:

2008-07-30  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff Garen.

        Add consistency checks to UString to document and enforce its design.

        * kjs/ustring.cpp:
        (KJS::UString::Rep::create):
        (KJS::UString::Rep::destroy):
        (KJS::UString::Rep::checkConsistency):
        (KJS::UString::expandCapacity):
        (KJS::UString::expandPreCapacity):
        (KJS::UString::UString):
        (KJS::UString::spliceSubstringsWithSeparators):
        (KJS::UString::append):
        * kjs/ustring.h:
        (KJS::UString::Rep::checkConsistency):

2008-07-30  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Geoff Garen.

        Fixes for Windows and non-AllInOne file build with SamplingTool, plus review fixes.

        * GNUmakefile.am:              Adding SamplingTool.cpp to build.
        * JavaScriptCore.exp:          Export hooks to init & control SamplingTool.
        * JavaScriptCore.pri:          Adding SamplingTool.cpp to build.
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj: Adding SamplingTool.cpp to build.
        * JavaScriptCore.xcodeproj/project.pbxproj: Adding SamplingTool.cpp to build.
        * JavaScriptCoreSources.bkl:   Adding SamplingTool.cpp to build.
        * VM/Machine.cpp:              MACHINE_SAMPLING_callingNativeFunction renamed MACHINE_SAMPLING_callingHostFunction
        * VM/Machine.h:
        * VM/Opcode.cpp:               SamplingTool moved to SamplingTool.cpp/.h, opcodeNames generated from FOR_EACH_OPCODE_ID.
        * VM/Opcode.h:
        * VM/SamplingTool.cpp:         Added .cpp/.h for SamplingTool.
        * VM/SamplingTool.h:
        * kjs/Shell.cpp:               Switched SAMPLING_TOOL_ENABLED to ENABLE_SAMPLING_TOOL.
        * wtf/Platform.h:              Added ENABLE_SAMPLING_TOOL config option.
        * kjs/nodes.cpp:               Header include to fix non-AllInOne builds.

2008-07-30  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Alexey Proskuryakov.

        Fix compilation without multi-threading support.

        * kjs/collector.cpp:
        (KJS::Heap::Heap):

2008-07-30  Anders Carlsson  <andersca@apple.com>
        
        Add WebKitAvailability.h forwarding header.
        
        * ForwardingHeaders/JavaScriptCore/WebKitAvailability.h: Added.

2008-07-30  Anders Carlsson  <andersca@apple.com>

        Fix the else.
        
        * API/WebKitAvailability.h:

2008-07-30  Anders Carlsson  <andersca@apple.com>

        * API/WebKitAvailability.h:
        Fix Windows (and other non-Mac builds).
        
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        Add WebKitAvailability.h to the project.

2008-07-30  Anders Carlsson  <andersca@apple.com>

        One step closer towards fixing the Windows build.
        
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreGenerated.make:
        Make sure to copy WebKitAvailability.h

2008-07-29  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Geoff Garen.

        Bug 20209: Atomize constant strings
        <https://bugs.webkit.org/show_bug.cgi?id=20209>

        Prevents significant performance degradation seen when a script contains multiple
        identical strings that are used as keys to identify properties on objects.

        No performance change on SunSpider.

        * kjs/nodes.cpp: Atomize constant strings.

2008-07-30  Oliver Hunt  <oliver@apple.com>

        Reviewed by Alexey Proskuryakov.

        <rdar://problem/6111648> JavaScript exceptions fail if the scope chain includes the global object

        In an attempt to remove the branch I just added to KJS::depth I
        used the existence of a Variable Object at a point in the scope
        chain as an indicator of function or global scope activation.
        However this assumption results in incorrect behaviour if the
        global object is injected into the scope chain with 'with'.

        * VM/Machine.cpp:
        (KJS::depth):

2008-07-30  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff Garen.

        Don't call JSGarbageCollect() on a released context.

        * API/testapi.c: (main):

2008-07-29  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff Garen.

        Implement JSContextGroup APIs to make concurrent execution possible for
        JavaScriptCore clients.

        This changes the behavior of JSGlobalContextCreate(), so that it now uses a private context
        group for each context, making JSlock implicit locking unnecessary.

        * API/JSContextRef.h:
        * API/JSContextRef.cpp:
        (JSContextGroupCreate):
        (JSContextGroupRetain):
        (JSContextGroupRelease):
        (JSGlobalContextCreate):
        (JSGlobalContextCreateInGroup):
        (JSGlobalContextRelease):
        (JSContextGetGroup):
        Added new methods. JSGlobalContextCreate() calls JSGlobalContextCreateInGroup() now.

        * API/APICast.h: (toJS): (toRef): Added converters for JSContextGroupRef.
        * API/JSBase.cpp: (JSGarbageCollect): JSGarbageCollect(0) is now a no-op, and the passed in
        context is actually used.

        * API/JSBase.h: Aded a typedef for JSContextGroupRef. Updated documentation for
        JSGarbageCollect().

        * JavaScriptCore.exp: Removed JSGlobalData::sharedInstance().

        * kjs/JSGlobalData.cpp:
        * kjs/JSGlobalData.h:
        Removed support for JSGlobalData shared instance. JSGlobalData::isSharedInstance member
        variable still remains, to be deleted in a followup patch.

        * kjs/JSLock.cpp: (KJS::JSLock::JSLock): Disabled JSLock, to be deleted in a follow-up patch.
        
        * kjs/collector.cpp:
        (KJS::Heap::markOtherThreadConservatively): Removed an assertion that referenced
        JSGlobalData::sharedInstance.

        * kjs/collector.h: Made Heap destructor public, so that JSContextRelease can use it.

2008-07-29  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff Garen.

        Fix a leak of ThreadRegistrar objects.

        As the heap is usually deleted when registered threads still exist, ThreadSpecific doesn't
        have a chance to clean up per-thread object. Switched to native pthread calls, storing a
        plain pointer that doesn't require cleanup.

        * kjs/collector.cpp:
        (KJS::PlatformThread::PlatformThread):
        (KJS::Heap::Thread::Thread):
        (KJS::Heap::Heap):
        (KJS::Heap::~Heap):
        (KJS::Heap::registerThread):
        (KJS::Heap::unregisterThread):
        * kjs/collector.h:

2008-07-29  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=20169
        Memory allocated with fastMalloc is freed with delete

        * VM/JSPropertyNameIterator.cpp:
        (KJS::JSPropertyNameIterator::invalidate): Free the array properly.
        (KJS::JSPropertyNameIterator::~JSPropertyNameIterator): Delete the array by calling
        invalidate().

2008-07-29  Mark Rowe  <mrowe@apple.com>

        Attempt to fix the Qt build.

        * wtf/ThreadingQt.cpp: Add the extra argument to createThread.

2008-07-29  Adam Roben  <aroben@apple.com>

        Change Vector::find to return an index instead of an iterator

        Indices are more natural than iterators when working with Vector.

        Reviewed by John Sullivan.

        * wtf/Vector.h:
        (WTF::Vector::find): Changed to iterate the Vector manually and return
        the index of the found item, rather than an iterator. When the item
        could not be found, we return WTF::notFound.

2008-07-29  Adam Roben  <aroben@apple.com>

        Windows build fix

        * wtf/ThreadingWin.cpp:
        (WTF::setThreadName): Move a misplaced assertion to here...
        (WTF::createThread): ...from here.

2008-07-29  Adam Roben  <aroben@apple.com>

        Add support for setting thread names on Windows

        These thread names make it much easier to identify particular threads
        in Visual Studio's Threads panel.

        WTF::createThread now takes a const char* representing the thread's
        name. On Windows, we throw a special exception to set this string as
        the thread's name. Other platforms do nothing with this name for now.

        Reviewed by Anders Carlsson.

        * JavaScriptCore.exp: Export the new version of createThread that
        takes 3 arguments (the old one continues to be exported for backward
        compatibility).
        * wtf/Threading.h: Add a threadName argument to createThread.

        * wtf/ThreadingGtk.cpp:
        (WTF::createThread):
        * wtf/ThreadingNone.cpp:
        (WTF::createThread):
        Updated for function signature change.

        * wtf/ThreadingPthreads.cpp:
        (WTF::createThread): Updated for function signature change. We keep
        around the old 2-argument version of createThread for backward
        compatibility.

        * wtf/ThreadingWin.cpp:
        (WTF::setThreadName): Added. This function's implementation came from
        MSDN.
        (WTF::initializeThreading): Set the name of the main thread.
        (WTF::createThread): Call setThreadName. We keep around the old
        2-argument version of createThread for backward compatibility.

2008-07-29  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Oliver Hunt.

        Store UString::Rep::isStatic bit in identifierTable pointer instead of reportedCost for
        slightly nicer code and a 0.5% SunSpider improvement.

        * API/JSClassRef.cpp:
        (OpaqueJSClass::~OpaqueJSClass):
        (OpaqueJSClassContextData::OpaqueJSClassContextData):
        * API/JSStringRef.cpp:
        (JSStringRelease):
        * kjs/PropertyNameArray.cpp:
        (KJS::PropertyNameArray::add):
        * kjs/identifier.cpp:
        (KJS::IdentifierTable::~IdentifierTable):
        (KJS::IdentifierTable::add):
        (KJS::Identifier::addSlowCase):
        (KJS::Identifier::remove):
        * kjs/identifier.h:
        (KJS::Identifier::add):
        * kjs/ustring.cpp:
        (KJS::):
        (KJS::UString::Rep::create):
        (KJS::UString::Rep::destroy):
        * kjs/ustring.h:
        (KJS::UString::Rep::identifierTable):
        (KJS::UString::Rep::setIdentifierTable):
        (KJS::UString::Rep::isStatic):
        (KJS::UString::Rep::setStatic):
        (KJS::UString::cost):

2008-07-28  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Sam Weinig.

        Renamed "ConstructTypeNative" => "ConstructTypeHost".
        
2008-07-26  Mark Rowe  <mrowe@apple.com>

        Speculative fix for the wx build.

        * JavaScriptCoreSources.bkl:  Add JSStaticScopeObject.cpp to the list of source files.

2008-07-25  Oliver Hunt  <oliver@apple.com>

        RS=Cameron Zwarich.

        Whoops, forgot to save style correction.

        * kjs/JSStaticScopeObject.h:

2008-07-25  Oliver Hunt  <oliver@apple.com>

        Reviewed by Cameron Zwarich.

        Bug 19718: Named anonymous functions are slow accessing global variables
        <https://bugs.webkit.org/show_bug.cgi?id=19718>

        To fix this we switch over to an activation-like scope object for
        on which we attach the function name property, and add logic to 
        prevent cross scope assignment to read only properties.

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::findScopedProperty):
        (KJS::CodeGenerator::emitResolve):
        * VM/CodeGenerator.h:
        * kjs/AllInOneFile.cpp:
        * kjs/JSStaticScopeObject.cpp: Added.
        (KJS::JSStaticScopeObject::putWithAttributes):
        (KJS::JSStaticScopeObject::isDynamicScope):
        (KJS::JSStaticScopeObject::~JSStaticScopeObject):
        (KJS::JSStaticScopeObject::getOwnPropertySlot):
        * kjs/JSStaticScopeObject.h: Added.
        (KJS::JSStaticScopeObject::JSStaticScopeObjectData::JSStaticScopeObjectData):
        (KJS::JSStaticScopeObject::JSStaticScopeObject):
        * kjs/nodes.cpp:
        (KJS::FunctionCallResolveNode::emitCode):
        (KJS::PostfixResolveNode::emitCode):
        (KJS::PrefixResolveNode::emitCode):
        (KJS::ReadModifyResolveNode::emitCode):
        (KJS::AssignResolveNode::emitCode):
        (KJS::FuncExprNode::makeFunction):

2008-07-25  kevino  <kevino@theolliviers.com>

        wx build fix for Win.
        
        On wx/Win, including windows.h in Threading.h causes multiply-defined symbol errors
        for libjpeg and wx, and also wx needs to include windows.h itself first for wx
        includes to work right. So until we can find a better solution to this problem,
        on wx, we work around the need to include windows.h here.

        * wtf/Threading.h:

2008-07-25  Adam Roben  <aroben@apple.com>

        Windows build fix

        * JavaScriptCore.vcproj/testapi/testapi.vcproj: Add API/ to the
        include path.

2008-07-25  Simon Hausmann  <hausmann@webkit.org>

        Fix the build of jsc on Qt/Windows, make sure os-win32 is in the
        include search path (added by WebKit.pri).

        * kjs/jsc.pro:

2008-07-25  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Simon Hausmann.

        Move JavaScriptCore API tests into a subdirectory of their own to avoid header name
        conflicts and developer confusion.

        * API/JSNode.c: Removed.
        * API/JSNode.h: Removed.
        * API/JSNodeList.c: Removed.
        * API/JSNodeList.h: Removed.
        * API/Node.c: Removed.
        * API/Node.h: Removed.
        * API/NodeList.c: Removed.
        * API/NodeList.h: Removed.
        * API/minidom.c: Removed.
        * API/minidom.html: Removed.
        * API/minidom.js: Removed.
        * API/testapi.c: Removed.
        * API/testapi.js: Removed.
        * API/tests: Added.
        * API/tests/JSNode.c: Copied from JavaScriptCore/API/JSNode.c.
        * API/tests/JSNode.h: Copied from JavaScriptCore/API/JSNode.h.
        * API/tests/JSNodeList.c: Copied from JavaScriptCore/API/JSNodeList.c.
        * API/tests/JSNodeList.h: Copied from JavaScriptCore/API/JSNodeList.h.
        * API/tests/Node.c: Copied from JavaScriptCore/API/Node.c.
        * API/tests/Node.h: Copied from JavaScriptCore/API/Node.h.
        * API/tests/NodeList.c: Copied from JavaScriptCore/API/NodeList.c.
        * API/tests/NodeList.h: Copied from JavaScriptCore/API/NodeList.h.
        * API/tests/minidom.c: Copied from JavaScriptCore/API/minidom.c.
        * API/tests/minidom.html: Copied from JavaScriptCore/API/minidom.html.
        * API/tests/minidom.js: Copied from JavaScriptCore/API/minidom.js.
        * API/tests/testapi.c: Copied from JavaScriptCore/API/testapi.c.
        * API/tests/testapi.js: Copied from JavaScriptCore/API/testapi.js.
        * GNUmakefile.am:
        * JavaScriptCore.vcproj/testapi/testapi.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:

2008-07-25  Simon Hausmann  <hausmann@webkit.org>

        Prospective WX build fix, add JavaScriptCore/API to the include search
        path.

        * jscore.bkl:

2008-07-25  Simon Hausmann  <hausmann@webkit.org>

        Rubber-stamped by Lars.

        Fix the build on Windows. operator new for ArgList is implemented using fastMalloc()
        but operator delete was not implemented. Unfortunately MSVC decides to call/reference
        the function, so a simple implementation using fastFree() fixes the build.

        * kjs/ArgList.h:
        (KJS::ArgList::operator delete):

2008-07-25  Simon Hausmann  <hausmann@webkit.org>

        Discussed with and rubber-stamped by Lars.

        Fix the build system for the Qt port.

        Recent JavaScriptCore changes require the addition of JavaScriptCore/API to the
        include search path. With a build process that combines JavaScriptCore and
        WebCore in one build process/Makefile the existance of
        JavaScriptCore/API/Node.h and WebCore/dom/Node.h causes include conflicts.

        This commit solves this by introducing a separate build of JavaScriptCore into
        a static library.

        As a result of the split-up a race-condition due to broken dependencies of
        regular source files to header files of generated sources showed up very
        frequently when doing parallel builds (which the buildbot does). This commit at
        the same time tries to address the dependency problem by making the
        addExtraCompiler() function also generate a pseudo extra compiler that
        represents the header file output, so that qmake is aware of the creation of
        the header file for dependency calculation.

        At the same time I removed a lot of cruft from the pro files to ease maintenance.

        * JavaScriptCore.pri:
        * JavaScriptCore.pro: Added.
        * kjs/jsc.pro:

2008-07-24  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Maciej Stachowiak.
        
        Fixed a strict aliasing violation, which caused hash tables with floating
        point keys not to find items that were indeed in the tables
        (intermittently, and only in release builds, of course).
        
        SunSpider reports no change.
        
        This bug doesn't seem to affect any existing code, but it causes obvious
        crashes in some new code I'm working on.

        * wtf/HashFunctions.h:
        (WTF::FloatHash::hash): Use a union when punning between a float / double
        and an unsigned (bucket of bits). With strict aliasing enabled, unions
        are the only safe way to do this kind of type punning.

        * wtf/HashTable.h: When rehashing, ASSERT that the item we just added to
        the table is indeed in the table. In the buggy case described above, this
        ASSERT fires.

2008-07-24  Oliver Hunt  <oliver@apple.com>

        Reviewed by Alexey Proskuryakov.

        Bug 20142: REGRESSION(r35245): /=/ weirdness
        <https://bugs.webkit.org/show_bug.cgi?id=20142>

        When adding all the meta data needed for exception error messages
        I accidentally clobbered the handling of regex beginning with /=.

        * kjs/grammar.y:

2008-07-23  Alp Toker  <alp@nuanti.com>

        Build fix after r35293: Add API/ to the include path.

        * GNUmakefile.am:

2008-07-23  Adam Roben  <aroben@apple.com>

        Windows build fixes

        Build fix after r35293:

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj: Add API/
        to the include path.

        Build fix after r35305:

        * VM/Machine.cpp:
        * VM/Machine.h:
        * VM/Opcode.cpp:
        * VM/Opcode.h:
        Completely compile out all sampler-related code when
        SAMPLING_TOOL_ENABLED is 0. The sampler code can't be compiled 1) on
        non-AllInOne configurations due to circular header dependencies, and
        2) on platforms that don't have a usleep() function, such as Windows.

2008-07-23  Oliver Hunt  <oliver@apple.com>

        Reviewed by Geoff Garen and Sam Weinig.

        Improve switch performance.

        Improve switch performance by converting to a hashmap based jump
        table to avoid the sequence of dispatches that would otherwise be
        needed.  This results in a 9-19x performance win for string switches
        based on ad hoc testing, and a 6x improvement for integer switch
        statements.  SunSpider reports a 1.2% progression.

        * VM/CodeBlock.cpp:
        (KJS::CodeBlock::dump):
        (KJS::SimpleJumpTable::offsetForValue):
        * VM/CodeBlock.h:
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::beginSwitch):
        (KJS::prepareJumpTableForImmediateSwitch):
        (KJS::prepareJumpTableForCharacterSwitch):
        (KJS::prepareJumpTableForStringSwitch):
        (KJS::CodeGenerator::endSwitch):
        * VM/CodeGenerator.h:
        * VM/Machine.cpp:
        (KJS::offsetForStringSwitch):
        (KJS::Machine::privateExecute):
        * VM/Opcode.cpp:
        (KJS::):
        * VM/Opcode.h:
        * kjs/JSImmediate.h:
        * kjs/nodes.cpp:
        (KJS::):
        (KJS::processClauseList):
        (KJS::CaseBlockNode::tryOptimisedSwitch):
        (KJS::CaseBlockNode::emitCodeForBlock):
        * kjs/nodes.h:
        (KJS::SwitchInfo::):

2008-07-23  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Geoff Garen.

        Sampling tool to analyze cost of instruction execution and identify hot regions of JS code.
        Enable Switches by setting SAMPLING_TOOL_ENABLED in Opcode.h.

        * JavaScriptCore.exp: Export symbols for Shell.cpp.
        * VM/Machine.cpp:     Added sampling hooks.
        * VM/Machine.h:       Machine contains a pointer to a sampler, when sampling.
        * VM/Opcode.cpp:      Tool implementation.
        * VM/Opcode.h:        Tool declaration.
        * kjs/Shell.cpp:      Initialize the sampler, if enabled.
        * kjs/nodes.cpp:      Added sampling hooks.

2008-07-23  Gabor Loki  <loki@inf.u-szeged.hu>

        Bug 20097: [Qt] 20% Sunspider slow-down

        <https://bugs.webkit.org/show_bug.cgi?id=20097>

        Reviewed by Simon Hausmann.

        * kjs/jsc.pro: Added missing NDEBUG define for release builds.

2008-07-23  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff Garen.

        JSClassRef is created context-free, but gets infatuated with the first context it sees.

        The implicit API contract is that JSClassRef can be used with any context on any thread.
        This no longer worked, because UStrings in the class were turned into per-context
        identifiers, and the cached JSObject prototype was tied to JSGlobalData, too.

        * API/JSClassRef.h: Made a separate struct for context-dependent parts of OpaqueJSClass.
        * API/JSClassRef.cpp:
        (OpaqueJSClass::OpaqueJSClass): Updated for renames and changed member variable order.
        (OpaqueJSClass::~OpaqueJSClass): Assert that string members are not identifiers.
        (clearReferenceToPrototype): Update for the new reference location.
        (OpaqueJSClassContextData::OpaqueJSClassContextData): Make a deep copy of all strings.
        (OpaqueJSClass::contextData): Added a function that finds the per-context part of
        OpaqueJSClass in JSGlobalData, or creates it if not found.
        (OpaqueJSClass::className): Always make a deep copy. Callers of this function do not have
        a way to access JSGlobalData, so a per-context copy could not be made.
        (OpaqueJSClass::staticValues): Updated for new data location.
        (OpaqueJSClass::staticFunctions): Ditto.
        (OpaqueJSClass::prototype): Changed to take an internal type for consistency.

        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::JSGlobalData):
        (KJS::JSGlobalData::~JSGlobalData):
        * kjs/JSGlobalData.h:
        Keep a HashMap to access per-context JSClass data given a pointr to the shared part.

        * API/JSCallbackObjectFunctions.h:
        (KJS::::className):
        (KJS::::getOwnPropertySlot):
        (KJS::::put):
        (KJS::::deleteProperty):
        (KJS::::getPropertyNames):
        (KJS::::staticValueGetter):
        (KJS::::staticFunctionGetter):j
        Use function accessors instead of accessing OpaqueJSClass members directly.

        * API/JSContextRef.cpp: (JSGlobalContextCreate): Updated for the change in
        OpaqueJSClass::prototype() argument type.

        * API/JSObjectRef.cpp:
        (JSObjectMake): Updated for the change in OpaqueJSClass::prototype() argument type.
        (JSObjectMakeConstructor): Ditto.

2008-07-23  Alexey Proskuryakov  <ap@webkit.org>

        Build fix.

        * kjs/ArgList.h: (KJS::ArgList::operator new): removed an extraneous "ArgList::" inside the
        class definition.

2008-07-22  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt and Sam Weinig.

        Next step toward putting doubles in registers: Prepare the Register class
        and its clients for registers that don't contain JSValue*s.
        
        This means a few things:
        
        1. Register::jsValue() clients, including ArgList clients, must now supply
        an ExecState* when accessing an entry in an ArgList, in case the entry
        will need to create a JSValue* on the fly.
        
        2. Register clients that definitely don't want to create a JSValue* on
        the fly now use different APIs: getJSValue() for clients that know
        the register contains a JSValue*, and v() for clients who just want a
        void*.
        
        3. I had to change some headers around in order to resolve dependency
        problems created by using a Register in the ArgList header.
        
        SunSpider reports no change.
        
2008-07-22  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Alexey Proskuryakov.

        Prevent integer overflow when reallocating storage vector for arrays.

        Sunspider reports 1.005x as fast (no change expected).

        * kjs/JSArray.cpp:

2008-07-21  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/6091287> Revamp the handling of CFBundleShortVersionString to be fixed at the major component of the version number.

        * Configurations/Version.xcconfig:
        * Info.plist:

2008-07-21  Adam Roben  <aroben@apple.com>

        Add Vector::find

        This is a convenience wrapper around std::find.

        Reviewed by Anders Carlsson.

        * wtf/Vector.h:

2008-07-19  Oliver Hunt  <oliver@apple.com>

        Reviewed by Cameron Zwarich.

        Bug 20104: Exception in tables/mozilla_expected_failures/bugs/bug92868_1.html includes the equals operator in the quoted expression
        <https://bugs.webkit.org/show_bug.cgi?id=20104>

        To make this correct we make the dot and bracket assign nodes emit the information to indicate
        the failure range is the dot/bracket accessor.

        * kjs/grammar.y:

2008-07-18  Steve Falkenburg  <sfalken@apple.com>

        Windows build fix.

        * kjs/JSGlobalObjectFunctions.cpp:
        (KJS::isStrWhiteSpace):

2008-07-18  Steve Falkenburg  <sfalken@apple.com>

        Windows build fix.

        * kjs/nodes.h:
        (KJS::ThrowableExpressionData::ThrowableExpressionData):

2008-07-18  Oliver Hunt  <oliver@apple.com>

        Reviewed by Cameron Zwarich.

        Bug 18774: SQUIRRELFISH: print meaningful error messages <https://bugs.webkit.org/show_bug.cgi?id=18774>
        <rdar://problem/5769353> SQUIRRELFISH: JavaScript error messages are missing informative text

        Add support for decent error messages in JavaScript.  This patch achieves this by providing
        ensuring the common errors and exceptions have messages that provide the text of expression
        that trigger the exception.  In addition it attaches a number of properties to the exception
        object detailing where in the source the expression came from.

        * JavaScriptCore.exp:
        * VM/CodeBlock.cpp:
        (KJS::CodeBlock::lineNumberForVPC):
        (KJS::CodeBlock::expressionRangeForVPC): 
            Function to recover the expression range for an instruction
            that triggered an exception.
        * VM/CodeBlock.h:
        (KJS::ExpressionRangeInfo::):
        (KJS::CodeBlock::CodeBlock):
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitCall):
        (KJS::CodeGenerator::emitCallEval):
            Emit call needed to be modified so to place the expression range info internally,
            as the CodeGenerator emits the arguments nodes itself, rather than the various call
            nodes.
        * VM/CodeGenerator.h:
        (KJS::CodeGenerator::emitExpressionInfo):
            Record the expression range info.
        * VM/ExceptionHelpers.cpp:
        (KJS::createErrorMessage):
        (KJS::createInvalidParamError):
        (KJS::createUndefinedVariableError):
        (KJS::createNotAConstructorError):
        (KJS::createNotAFunctionError):
        (KJS::createNotAnObjectErrorStub):
        (KJS::createNotAnObjectError):
            Rewrite all the code for the error messages so that they make use of the newly available
            information.
        * VM/ExceptionHelpers.h:
        * VM/Machine.cpp:
        (KJS::isNotObject):  Now needs vPC and codeBlock
        (KJS::Machine::throwException):
            New logic to handle the NotAnObjectErrorStub and to handle the absurd "no default value" edge case
        (KJS::Machine::privateExecute):
        * VM/Machine.h:
        * kjs/DebuggerCallFrame.cpp:
        (KJS::DebuggerCallFrame::evaluate):
        * kjs/Error.cpp:
        (KJS::Error::create):
        * kjs/Error.h:
        * kjs/JSGlobalObjectFunctions.cpp:
        * kjs/JSImmediate.cpp:
        (KJS::JSImmediate::toObject):
        (KJS::JSImmediate::prototype):
            My changes to the JSNotAnObject constructor needed to be handled here.
        * kjs/JSNotAnObject.h:
        (KJS::JSNotAnObjectErrorStub::JSNotAnObjectErrorStub):
        (KJS::JSNotAnObjectErrorStub::isNull):
        (KJS::JSNotAnObjectErrorStub::isNotAnObjectErrorStub):
            Added a JSNotAnObjectErrorStub class to ease the handling of toObject failure exceptions,
            and potentially allow even more detailed error messages in future.
        * kjs/JSObject.h:
        * kjs/Parser.h:
        (KJS::Parser::parse):
        * kjs/SourceRange.h:
        * kjs/grammar.y:
            Large amounts of position propagation.
        * kjs/lexer.cpp:
        (KJS::Lexer::Lexer):
        (KJS::Lexer::shift):
        (KJS::Lexer::lex):
            The lexer needed a few changes to be able to correctly track token character positions.
        * kjs/lexer.h:
        * kjs/nodes.cpp:
        (KJS::ThrowableExpressionData::emitThrowError):
        (KJS::StatementNode::StatementNode):
        (KJS::ResolveNode::emitCode):
        (KJS::BracketAccessorNode::emitCode):
        (KJS::DotAccessorNode::emitCode):
        (KJS::NewExprNode::emitCode):
        (KJS::EvalFunctionCallNode::emitCode):
        (KJS::FunctionCallValueNode::emitCode):
        (KJS::FunctionCallResolveNode::emitCode):
        (KJS::FunctionCallBracketNode::emitCode):
        (KJS::FunctionCallDotNode::emitCode):
        (KJS::PostfixResolveNode::emitCode):
        (KJS::PostfixBracketNode::emitCode):
        (KJS::PostfixDotNode::emitCode):
        (KJS::DeleteResolveNode::emitCode):
        (KJS::DeleteBracketNode::emitCode):
        (KJS::DeleteDotNode::emitCode):
        (KJS::PrefixResolveNode::emitCode):
        (KJS::PrefixBracketNode::emitCode):
        (KJS::PrefixDotNode::emitCode):
        (KJS::ThrowableBinaryOpNode::emitCode):
        (KJS::ReadModifyResolveNode::emitCode):
        (KJS::AssignResolveNode::emitCode):
        (KJS::AssignDotNode::emitCode):
        (KJS::ReadModifyDotNode::emitCode):
        (KJS::AssignBracketNode::emitCode):
        (KJS::ReadModifyBracketNode::emitCode):
        (KJS::ForInNode::ForInNode):
        (KJS::ForInNode::emitCode):
        (KJS::WithNode::emitCode):
        (KJS::LabelNode::emitCode):
        (KJS::ThrowNode::emitCode):
        (KJS::ProgramNode::ProgramNode):
        (KJS::ProgramNode::create):
        (KJS::EvalNode::generateCode):
        (KJS::FunctionBodyNode::create):
        (KJS::FunctionBodyNode::generateCode):
        (KJS::ProgramNode::generateCode):
            All of these methods were handling the position information.  
            Constructors and create methods were modified to store the information.
            All the emitCall implementations listed needed to be updated to actually
            record the position information we have so carefully collected.
        * kjs/nodes.h:
        (KJS::ThrowableExpressionData::ThrowableExpressionData):
        (KJS::ThrowableExpressionData::setExceptionSourceRange):
        (KJS::ThrowableExpressionData::divot):
        (KJS::ThrowableExpressionData::startOffset):
        (KJS::ThrowableExpressionData::endOffset):
        (KJS::ThrowableSubExpressionData::ThrowableSubExpressionData):
        (KJS::ThrowableSubExpressionData::setSubexpressionInfo):
        (KJS::ThrowablePrefixedSubExpressionData::ThrowablePrefixedSubExpressionData):
        (KJS::ThrowablePrefixedSubExpressionData::setSubexpressionInfo):
            ThrowableExpressionData is just a uniform mechanism for storing the position
            information.
        (KJS::ResolveNode::):
        (KJS::PrePostResolveNode::):
        (KJS::ThrowableBinaryOpNode::):
        (KJS::WithNode::):

2008-07-18  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Cameron Zwarich.
        
        Three renames:
        
        "CallTypeNative" => "CallTypeHost"
        "code" => "byteCode"
        "generatedCode" => "generatedByteCode"

2008-07-18  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Optimized <= for immediate number cases.
        
        SunSpider reports no overall change, but a 10% speedup on access-nsieve.

2008-07-18  Mark Rowe  <mrowe@apple.com>

        Rubber-stamped by Sam Weinig.

        Fix some casts added in a previous build fix to match the style used
        throughout WebKit.

        * VM/Machine.cpp:
        (KJS::Machine::initializeCallFrame):
        * VM/Register.h:
        (KJS::Register::Register):

2008-07-18  Landry Breuil  <landry@openbsd.org>

        Bug 19975: [OpenBSD] Patches to enable build of WebKit

        <https://bugs.webkit.org/show_bug.cgi?id=19975>

        Reviewed by David Kilzer.

        Support for OpenBSD, mostly threading and libm tweaks.

        * kjs/collector.cpp: #include <pthread.h>
        (KJS::currentThreadStackBase): use pthread_stackseg_np() to get stack base
        * kjs/config.h: OpenBSD also provides <pthread_np.h>
        * wtf/MathExtras.h: #include <sys/types.h> and <machine/ieee.h>
        (isfinite), (signbit): as long as we don't have those functions provide fallback implementations
        * wtf/Platform.h: Add support for PLATFORM(OPENBSD) and PLATFORM(SPARC64) macro

2008-07-17  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Next step toward putting doubles in registers: Store constant pool
        entries as registers, not JSValue*s.
        
        SunSpider reports no change.

2008-07-17  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by John Sullivan and Oliver Hunt.
        
        A tiny bit of tidying in function call register allocation.
        
        This patch saves one register when invoking a function expression and/or
        a new expression that is stored in a temporary.
        
        Since it's just one register, I can't make a testcase for it.

        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitCall): No need to ref the function we're calling
        or its base. We'd like the call frame to overlap with them, if possible.
        op_call will read the function and its base before writing the call frame,
        so this is safe.

        * kjs/nodes.cpp:
        (KJS::NewExprNode::emitCode): No need to ref the function we're new-ing,
        for the same reasons stated above.
        
        (KJS::FunctionCallValueNode::emitCode): ditto

2008-07-17  Steve Falkenburg  <sfalken@apple.com>

        Build fix.
        
        * kjs/InternalFunction.cpp:

2008-07-17  Sam Weinig  <sam@webkit.org>

        Roll out r35199 as it is causing failures on the PPC build.

2008-07-17  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by David Kilzer.
        
        Fixed https://bugs.webkit.org/show_bug.cgi?id=20067
        Support function.name (Firefox extension)
        
        Pretty straight-forward.

2008-07-17  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Fixed <rdar://problem/6081636> Functions calls use more temporary
        registers than necessary
        
        Holding a reference to the last statement result register caused each
        successive statement to output its result to an even higher register.
        
        Happily, statements don't actually need to return a result register
        at all. I hope to make this clearer in a future cleanup patch,
        but this change will fix the major bug for now.

        * kjs/nodes.cpp:
        (KJS::statementListEmitCode):

2008-07-17  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Sam Weinig.

        Merge pre&post dot nodes to simplify the parse tree.
        Sunspider results show 0.6% progression (no performance change expected).

        * kjs/grammar.y:
        * kjs/nodes.cpp:
        * kjs/nodes.h:
        * kjs/nodes2string.cpp:

2008-07-17  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Cameron Zwarich.

        Merge pre&post resolve nodes to simplify the parse tree.
        Sunspider results show no performance change.

        * kjs/grammar.y:
        * kjs/nodes.cpp:
        * kjs/nodes.h:
        * kjs/nodes2string.cpp:

2008-07-17  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Cameron Zwarich.

        Merge logical nodes to simplify the parse tree.
        Sunspider results show 0.6% progression (no performance change expected).

        * kjs/grammar.y:
        * kjs/nodes.cpp:
        * kjs/nodes.h:
        * kjs/nodes2string.cpp:

2008-07-17  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Simon.

        Fix MinGW build (broken in r35198) and simplify getLocalTime().

        * kjs/DateMath.cpp:
        (KJS::getLocalTime):

2008-07-17  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Sam Weinig.

        Merge pre&post bracket nodes to simplify the parse tree.
        Sunspider results show no performance change.

        * kjs/grammar.y:
        * kjs/nodes.cpp:
        * kjs/nodes.h:
        * kjs/nodes2string.cpp:

2008-07-17  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Simon.

        Fix the 32-bit gcc builds, conversion from "long int" to Register is
        ambiguous. Explicitly choose the intptr_t constructor.

        * VM/Machine.cpp:
        (KJS::Machine::initializeCallFrame):
        * VM/Register.h:
        (KJS::Register::Register):

2008-07-16  Mark Rowe  <mrowe@apple.com>

        Rubber-stamped by Geoff Garen.

        Fix JavaScript in 64-bit by using a pointer-sized integer
        type in the Register union.  Also includes a rename of
        the intType constant to IntType.

        * VM/Machine.cpp:
        (KJS::Machine::initializeCallFrame):
        * VM/Register.h:
        (KJS::Register::):
        (KJS::Register::Register):

2008-07-17  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        First step toward putting doubles in registers: Turned Register into a
        proper abstraction layer. It is no longer possible to cast a Register
        to a JSValue*, or a Register& to a JSValue*&, or to access the union
        inside a Register directly.
        
        SunSpider reports no change.
        
        In support of this change, I had to make the following mechanical changes
        in a lot of places:
        
        1. Clients now use explicit accessors to read data out of Registers, and
        implicit copy constructors to write data into registers.
        
        So, assignment that used to look like
        
            x.u.jsValue = y;
        
        now looks like
        
            x = y;
            
        And access that used to look like
        
            x = y.u.jsValue;
        
        now looks like
        
            x = y.jsValue();

        2. I made generic flow control specific in opcodes that made their flow
        control generic by treating a Register& as a JSValue*&. This had the
        added benefit of removing some exception checking branches from immediate
        number code.

        3. I beefed up PropertySlot to support storing a Register* in a property
        slot. For now, only JSVariableObject's symbolTableGet and symbolTablePut
        use this functionality, but I expect more clients to use it in the future.
        
        4. I changed ArgList to be a buffer of Registers, not JSValue*'s, and I
        changed ArgList iterator clients to iterate Registers, not JSValue*'s.

2008-07-16  Ada Chan  <adachan@apple.com>

        Fixed build.

        * kjs/JSGlobalObject.cpp:

2008-07-16  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Sam and Geoff.

        <rdar://problem/5958840> Navigating to another page while profiler is
        attached results in slow JavaScript for all time.

        - The UNLIKELY keeps this from being a sunspider performance regression.

        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::~JSGlobalObject): Stop the profiler associated
        with this exec state.

2008-07-16  Sam Weinig  <sam@webkit.org>

        Reviewed by Steve Falkenburg.

        Replace adopting UString constructor in favor of explicit
        static adopt method.

        * API/JSStringRefCF.cpp:
        (JSStringCreateWithCFString):
        * kjs/StringConstructor.cpp:
        (KJS::stringFromCharCode):
        * kjs/StringPrototype.cpp:
        (KJS::stringProtoFuncToLowerCase):
        (KJS::stringProtoFuncToUpperCase):
        (KJS::stringProtoFuncToLocaleLowerCase):
        (KJS::stringProtoFuncToLocaleUpperCase):
        * kjs/ustring.cpp:
        (KJS::UString::adopt):
        * kjs/ustring.h:
        (KJS::UString::UString):
        (KJS::UString::~UString):

2008-07-16  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Simon.

        http://trolltech.com/developer/task-tracker/index_html?method=entry&id=216179
        Fix potential crash (on Qt for Windows port) when performing JavaScript date
        conversion.

        * kjs/DateMath.cpp:
        (KJS::getLocalTime): For the Qt port, prefer to use Windows code, i.e.
        localtime_s() instead of localtime() since the latter might crash (on Windows)
        given a non-sensible, e.g. NaN, argument.

2008-07-16  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Anders and Geoff.

        https://bugs.webkit.org/show_bug.cgi?id=20023
        Failed assertion in PropertyNameArray.cpp

        This is already tested by testapi.

        * API/JSObjectRef.cpp: (JSPropertyNameAccumulatorAddName): Add the string to identifier
        table to appease PropertyNameArray.

2008-07-16  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff.

        Dereference identifiers when deleting a hash table (fixes leaks with private JSGlobalData
        objects).

        * kjs/JSGlobalData.cpp: (KJS::JSGlobalData::~JSGlobalData):
        * kjs/lookup.cpp: (KJS::HashTable::deleteTable):
        * kjs/lookup.h:
        * kjs/lexer.cpp: (KJS::Lexer::~Lexer)
        HashTable cannot have a destructor, because check-for-global-initializers complains about
        having a global constructor then.

2008-07-16  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff.

        Check pthread_key_create return value.

        This check was helpful when debugging a crash in run-webkit-tests --threaded that happened
        because JSGlobalData objects were not deleted, and we were running out of pthread keys soon.
        It also looks useful for production builds.

        * wtf/ThreadSpecific.h: (WTF::::ThreadSpecific):

2008-07-15  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geoff.

        Rename pageGroupIdentifier to profileGroup to keep mention of a
        pageGroup out of JavaScriptCore.

        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::init):
        * kjs/JSGlobalObject.h:
        (KJS::JSGlobalObject::setProfileGroup):
        (KJS::JSGlobalObject::profileGroup):
        * profiler/ProfileGenerator.cpp:
        (KJS::ProfileGenerator::create):
        (KJS::ProfileGenerator::ProfileGenerator):
        * profiler/ProfileGenerator.h:
        (KJS::ProfileGenerator::profileGroup):
        * profiler/Profiler.cpp:
        (KJS::Profiler::startProfiling):
        (KJS::dispatchFunctionToProfiles):
        (KJS::Profiler::willExecute):
        (KJS::Profiler::didExecute):

2008-07-14  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        Fix https://bugs.webkit.org/show_bug.cgi?id=20037
        Bug 20037: GCC 4.2 build broken due to strict aliasing violation.

        * kjs/ustring.cpp:
        (KJS::UString::Rep::computeHash): Add a version of computeHash that takes a char* and explicit length.
        * kjs/ustring.h:
        * profiler/CallIdentifier.h:
        (WTF::): Use new version of computeHash that takes a char* and explicit length to avoid unsafe aliasing.

2008-07-14  David Hyatt  <hyatt@apple.com>

        Fix a crashing bug in ListHashSet's -- operator.  Make sure that end() can be -- by special-casing the null
        position.

        Reviewed by Maciej

        * wtf/ListHashSet.h:
        (WTF::ListHashSetConstIterator::operator--):

2008-07-14  David Hyatt  <hyatt@apple.com>

        Buidl fix.  Make sure the second insertBefore method returns a value.

        * wtf/ListHashSet.h:
        (WTF::::insertBefore):

2008-07-14  Adam Roben  <aroben@apple.com>

        Windows build fix

        * JavaScriptCore.vcproj/jsc/jsc.vcproj: Added include/pthreads to the
        include path.

2008-07-14  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Kevin McCullough.

        Make JSGlobalData refcounted in preparation to adding a way to create contexts that share
        global data.

        * JavaScriptCore.exp:
        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::create):
        * kjs/JSGlobalData.h:
        Made contructor private, and added a static create() method. Made the class inherit from
        RefCounted.

        * kjs/JSGlobalObject.h:
        (KJS::JSGlobalObject::globalData):
        JSGlobalData is now owned by JSGlobalObject (except for the shared one, and the common
        WebCore one, which are never deleted).

        * kjs/Shell.cpp: (main): Create JSGlobalData with create() method.

2008-07-14  Simon Hausmann  <hausmann@webkit.org>

        Fix the single-threaded build.

        * kjs/JSLock.cpp: Removed undeclared registerThread() function.
        * kjs/collector.cpp:
        (KJS::Heap::registerThread): Added dummy implementation.

2008-07-14  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff Garen.

        Eliminate per-thread JavaScript global data instance support and make arbitrary
        global data/global object combinations possible.

        * kjs/collector.cpp:
        (KJS::Heap::Heap): Store a JSGlobalData pointer instead of multiple pointers to its members.
        This allows for going from any JS object to its associated global data, currently used in
        JSGlobalObject constructor to initialize its JSGlobalData pointer.
        (KJS::Heap::registerThread): Changed thread registration data to be per-heap. Previously,
        only the shared heap could be used from multiple threads, so it was the only one that needed
        thread registration, but now this can happen to any heap.
        (KJS::Heap::unregisterThread): Ditto.
        (KJS::Heap::markStackObjectsConservatively): Adapt for the above changes.
        (KJS::Heap::setGCProtectNeedsLocking): Ditto.
        (KJS::Heap::protect): Ditto.
        (KJS::Heap::unprotect): Ditto.
        (KJS::Heap::collect): Ditto.
        (KJS::Heap::globalObjectCount): Use global object list associated with the current heap,
        not the late per-thread one.
        (KJS::Heap::protectedGlobalObjectCount): Ditto.

        * kjs/collector.h:
        (KJS::Heap::ThreadRegistrar): Added a helper object that unregisters a thread when it is
        destroyed.

        * kjs/JSLock.cpp:
        (KJS::JSLock::JSLock):
        * kjs/JSLock.h:
        (KJS::JSLock::JSLock):
        Don't use JSLock to implicitly register threads. I've added registerThread() calls to most
        places that use JSLock - we cannot guarantee absolute safety unless we always mark all
        threads in the process, but these implicit registration calls should cover reasonable usage
        scenarios, I hope.

        * API/JSBase.cpp:
        (JSEvaluateScript): Explicitly register the current thread.
        (JSCheckScriptSyntax): Explicitly register the current thread.
        (JSGarbageCollect): Changed to use the passed in context. Unfortunately, this creates a race
        condition for clients that pass an already released context to JSGarbageCollect - but it is
        unlikely to create real life problems.
        To maintain compatibility, the shared heap is collected if NULL is passed.

        * API/JSContextRef.cpp:
        (JSGlobalContextCreate): Use a new syntax for JSGlobalObject allocation.
        (JSGlobalContextRetain): Register the thread.
        (JSContextGetGlobalObject): Register the thread.

        * API/JSObjectRef.cpp:
        (JSObjectMake):
        (JSObjectMakeFunctionWithCallback):
        (JSObjectMakeConstructor):
        (JSObjectMakeFunction):
        (JSObjectHasProperty):
        (JSObjectGetProperty):
        (JSObjectSetProperty):
        (JSObjectGetPropertyAtIndex):
        (JSObjectSetPropertyAtIndex):
        (JSObjectDeleteProperty):
        (JSObjectCallAsFunction):
        (JSObjectCallAsConstructor):
        (JSObjectCopyPropertyNames):
        (JSPropertyNameAccumulatorAddName):
        * API/JSValueRef.cpp:
        (JSValueIsEqual):
        (JSValueIsInstanceOfConstructor):
        (JSValueMakeNumber):
        (JSValueMakeString):
        (JSValueToNumber):
        (JSValueToStringCopy):
        (JSValueToObject):
        (JSValueProtect):
        (JSValueUnprotect):
        Register the thread.

        * API/JSStringRef.cpp: (JSStringRelease): Changed a comment to not mention per-thread contexts.

        * API/JSStringRefCF.cpp: Removed an unnecessary include of JSLock.h.

        * JavaScriptCore.exp: Export JSGlobalData constructor/destructor, now that anyone can have
        their own instances. Adapt to other changes, too.

        * JavaScriptCore.xcodeproj/project.pbxproj: Made ThreadSpecific.h private, as it is now
        included by collector.h and is thus needed in other projects.

        * kjs/InitializeThreading.cpp: (KJS::initializeThreadingOnce): Don't initialize per-thread
        global data, as it no longer exists.

        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::JSGlobalData):
        (KJS::JSGlobalData::~JSGlobalData):
        * kjs/JSGlobalData.h:
        Removed support for per-thread instance. Made constructor and destructor public.

        * kjs/JSGlobalObject.cpp: (KJS::JSGlobalObject::init): Get to now arbitrary  JSGlobalData
        via the heap.
        (KJS::JSGlobalObject::operator new): Changed ot take JSGlobalDatra pointer.
        * kjs/JSGlobalObject.h:

        * kjs/Shell.cpp:
        (main):
        (jscmain):
        Changed to maintain a custom JSGlobalData pointer instead of a per-thread one.

2008-07-13  Ada Chan  <adachan@apple.com>

        Windows build fix: Add wtf/RefCountedLeakCounter to the project.

        * JavaScriptCore.vcproj/WTF/WTF.vcproj:

2008-07-12  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Gtk, Qt and Wx build fix: Add wtf/RefCountedLeakCounter in the
        build scripts

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCoreSources.bkl:

2008-07-11  Stephanie Lewis  <slewis@apple.com>

        Reviewed by Darin Adler and Oliver Hunt.

        Refactor RefCounting Leak counting code into a common class.

        In order to export the symbols I needed to put the debug defines inside the function names
        
        Before we had a separate channel for each Logging each Leak type.  Since the leak channels were only used in one location, and only at quit for simplicity I combined them all into one leak channel.

        * JavaScriptCore.exp:
        * JavaScriptCore.xcodeproj/project.pbxproj: add new class
        * kjs/nodes.cpp: remove old leak counting code
        * wtf/RefCountedLeakCounter.cpp: Added. create a common leak counting class
        * wtf/RefCountedLeakCounter.h: Added.

2008-07-11  David Hyatt  <hyatt@apple.com>

        Add an insertBefore method to ListHashSet to allow for insertions in the middle of the list (rather than just
        at the end).

        Reviewed by Anders

        * wtf/ListHashSet.h:
        (WTF::::insertBefore):
        (WTF::::insertNodeBefore):

2008-07-11  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Darin Adler.

        Move call function to CallData.cpp and construct to ConstructData.cpp.

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * kjs/AllInOneFile.cpp:
        * kjs/CallData.cpp: Copied from kjs/JSValue.cpp.
        * kjs/ConstructData.cpp: Copied from kjs/JSValue.cpp.
        * kjs/JSValue.cpp:

2008-07-10  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        Define WEBKIT_VERSION_MIN_REQUIRED=WEBKIT_VERSION_LATEST when building WebKit to ensure that no symbols end up with the weak_import attribute.

        * Configurations/Base.xcconfig:

2008-07-10  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        Fix the Tiger build by omitting annotations from methods declared in categories when using old versions of GCC.

        * API/WebKitAvailability.h:

2008-07-10  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        -Minor cleanup. Renamed callTree() to head() and no longer use m_head
        directly but instead keep it private and access via a method().

        * profiler/HeavyProfile.cpp:
        (KJS::HeavyProfile::HeavyProfile):
        (KJS::HeavyProfile::generateHeavyStructure):
        (KJS::HeavyProfile::addNode):
        * profiler/Profile.h:
        (KJS::Profile::head):
        * profiler/ProfileGenerator.cpp:
        (KJS::ProfileGenerator::ProfileGenerator):

2008-07-10  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Mark Rowe.

        Eliminate CollectorHeapIntrospector.

        CollectorHeapIntrospector was added primarily in the hopes to improve leaks tool output,
        a result that it didn't deliver. Also, it helped by labeling JSC heap regions as reported by
        vmmap tool, but at the same time, it made them mislabeled as malloc'd ones - the correct
        way to label mapped regions is to use a VM tag.

        So, it makes more sense to remove it completely than to make it work with multiple heaps.

        * JavaScriptCore.exp:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * kjs/AllInOneFile.cpp:
        * kjs/InitializeThreading.cpp:
        (KJS::initializeThreading):
        * kjs/collector.cpp:
        * kjs/collector.h:
        * kjs/CollectorHeapIntrospector.cpp: Removed.
        * kjs/CollectorHeapIntrospector.h: Removed.

2008-07-09  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        <rdar://problem/5951532> JSProfiler: Implement heavy (or bottom-up)
        view (19228)
        - Implemented the time and call count portionof heavy.  Now all that we
        need is some UI.

        * profiler/CallIdentifier.h: Removed an unused constructor.
        * profiler/HeavyProfile.cpp: 
        (KJS::HeavyProfile::HeavyProfile): Set the initial time of the head
        node so that percentages work correctly.
        (KJS::HeavyProfile::mergeProfiles): Sum the times and call count of
        nodes being merged.
        * profiler/ProfileNode.cpp: Set the intital values of time and call
        count when copying ProfileNodes.
        (KJS::ProfileNode::ProfileNode):

2008-07-10  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Gtk build fix.

        * GNUmakefile.am: Add HeavyProfile.cpp

2008-07-09  Mark Rowe  <mrowe@apple.com>

        Reviewed by Geoff Garen.

        Don't warn about deprecated functions in production builds.

        * Configurations/Base.xcconfig:
        * Configurations/DebugRelease.xcconfig:

2008-07-09  Darin Adler  <darin@apple.com>

        * JavaScriptCore.pri: Fix Qt build by adding HeavyProfile.cpp.

2008-07-09  Kevin Ollivier  <kevino@theolliviers.com>

        wx biuld fix. Add HeavyProfile.cpp to build files.

        * JavaScriptCoreSources.bkl:

2008-07-09  Kevin McCullough  <kmccullough@apple.com>

        - Windows build fix.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:

2008-07-09  Kevin McCullough  <kmccullough@apple.com>

        - Build fix.

        * profiler/HeavyProfile.cpp:
        (KJS::HeavyProfile::mergeProfiles):

2008-07-09  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geoff and Adam.

        <rdar://problem/5951532> JSProfiler: Implement Bottom-Up view (19228)
        - This is the plumbing for bottom-up, but does not include calculating
        time, mostly because I'm still undclear about what the end result should
        look like.
        - This, obviously, does not include the UI to expose this in the
        inspector yet.

        * JavaScriptCore.xcodeproj/project.pbxproj:
        * profiler/CallIdentifier.h:
        (KJS::CallIdentifier::CallIdentifier):
        (WTF::): Added HashTraits for CallIdentifiers to be used by a HashMap.
        * profiler/HeavyProfile.cpp: Added.
        (KJS::HeavyProfile::HeavyProfile):
        (KJS::HeavyProfile::generateHeavyStructure):
        (KJS::HeavyProfile::addNode):
        (KJS::HeavyProfile::mergeProfiles):
        (KJS::HeavyProfile::addAncestorsAsChildren):
        * profiler/HeavyProfile.h: Added.
        (KJS::HeavyProfile::create):
        (KJS::HeavyProfile::heavyProfile):
        (KJS::HeavyProfile::treeProfile):
        * profiler/Profile.cpp: Removed old commented out includes.
        * profiler/Profile.h: The m_head is needed by the HeavyProfile so it
        is now protected as opposed to private.
        * profiler/ProfileNode.cpp:
        (KJS::ProfileNode::ProfileNode): Created a constructor to copy
        ProfileNodes.
        (KJS::ProfileNode::findChild): Added a null check to make HeavyProfile
        children finding easier and avoid a potential crasher.
        * profiler/ProfileNode.h: Mostly moved things around but also added some
        functionality needed by HeavyProfile.
        (KJS::ProfileNode::create):
        (KJS::ProfileNode::functionName):
        (KJS::ProfileNode::url):
        (KJS::ProfileNode::lineNumber):
        (KJS::ProfileNode::head):
        (KJS::ProfileNode::setHead):
        (KJS::ProfileNode::setNextSibling):
        (KJS::ProfileNode::actualTotalTime):
        (KJS::ProfileNode::actualSelfTime):
        * profiler/TreeProfile.cpp: Implemented the ability to get a
        HeavyProfile.
        (KJS::TreeProfile::heavyProfile):
        * profiler/TreeProfile.h:

2008-07-08  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Added support for checking if an object has custom properties in its
        property map. WebCore uses this to optimize marking DOM wrappers.

2008-07-08  Simon Hausmann  <hausmann@webkit.org>

        Prospective Gtk/Wx build fixes, add ProfileGenerator.cpp to the build.

        * GNUmakefile.am:
        * JavaScriptCoreSources.bkl:

2008-07-08  Simon Hausmann  <hausmann@webkit.org>

        Fix the Qt build, add ProfileGenerator.cpp to the build.

        * JavaScriptCore.pri:

2008-07-07  David Kilzer  <ddkilzer@apple.com>

        releaseFastMallocFreeMemory() should always be defined

        Reviewed by Darin.

        * JavaScriptCore.exp: Changed to export C++ binding for
        WTF::releaseFastMallocFreeMemory() instead of C binding for
        releaseFastMallocFreeMemory().
        * wtf/FastMalloc.cpp: Moved definitions of
        releaseFastMallocFreeMemory() to be in the WTF namespace
        regardless whether FORCE_SYSTEM_MALLOC is defined.
        * wtf/FastMalloc.h: Moved releaseFastMallocFreeMemory() from
        extern "C" binding to WTF::releaseFastMallocFreeMemory().

2008-07-07  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Geoff.

        Bug 19926: URL causes crash within a minute
        <https://bugs.webkit.org/show_bug.cgi?id=19926>

        Add a check that lastGlobalObject is non-null in Machine::execute()
        before copying its globals to the current register file.

        In theory, it is possible to make a test case for this, but it will
        take a while to get it right.

        * VM/Machine.cpp:
        (KJS::Machine::execute):

2008-07-07  Darin Adler  <darin@apple.com>

        Rubber stamped by Adele.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute): Fix a typo in a comment.

2008-07-07  Steve Falkenburg  <sfalken@apple.com>

        Build fixes.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.vcproj/testapi/testapi.vcproj:

2008-07-07  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        When the profiler is running it gathers information and creates a
        Profile.  After it finishes the Profile can be sorted and have other
        data refinements run over it.  Both of these were done in the same class
        before.  Now I split the gathering operations into a new class called
        ProfileGenerator.

        * JavaScriptCore.xcodeproj/project.pbxproj:
        * profiler/Profile.cpp: Removed code related to the gather stage of a
        Profile's creation.  
        (KJS::Profile::create):
        (KJS::Profile::Profile):
        * profiler/Profile.h: Ditto.
        (KJS::Profile::title):
        (KJS::Profile::callTree):
        (KJS::Profile::setHead):
        * profiler/ProfileGenerator.cpp: Added. This is the class that will
        handle the stage of creating a Profile.  Once the Profile is finished
        being created, this class goes away.
        (KJS::ProfileGenerator::create):
        (KJS::ProfileGenerator::ProfileGenerator):
        (KJS::ProfileGenerator::title):
        (KJS::ProfileGenerator::willExecute):
        (KJS::ProfileGenerator::didExecute):
        (KJS::ProfileGenerator::stopProfiling):
        (KJS::ProfileGenerator::didFinishAllExecution):
        (KJS::ProfileGenerator::removeProfileStart):
        (KJS::ProfileGenerator::removeProfileEnd):
        * profiler/ProfileGenerator.h: Added.
        (KJS::ProfileGenerator::profile):
        (KJS::ProfileGenerator::originatingGlobalExec):
        (KJS::ProfileGenerator::pageGroupIdentifier):
        (KJS::ProfileGenerator::client):
        (KJS::ProfileGenerator::stoppedProfiling):
        * profiler/Profiler.cpp: Now operates with the ProfileGenerator instead
        of the Profile.
        (KJS::Profiler::startProfiling):
        (KJS::Profiler::stopProfiling):
        (KJS::Profiler::didFinishAllExecution): It is here that the Profile is
        handed off to its client and the Profile Generator is no longer needed.
        (KJS::dispatchFunctionToProfiles):
        (KJS::Profiler::willExecute):
        (KJS::Profiler::didExecute):
        * profiler/Profiler.h: Cleaned up the includes and subsequently the
        forward declarations.  Also use the new ProfileGenerator.
        (KJS::ProfilerClient::~ProfilerClient):
        (KJS::Profiler::currentProfiles):
        * profiler/TreeProfile.cpp: Use Profile's new interface.
        (KJS::TreeProfile::create):
        (KJS::TreeProfile::TreeProfile):
        * profiler/TreeProfile.h:

2008-07-07  Sam Weinig  <sam@webkit.org>

        Reviewed by Cameron Zwarich.

        Third step in broad cleanup effort.

        [ File list elided ]

2008-07-06  Sam Weinig  <sam@webkit.org>

        Reviewed by Cameron Zwarich.

        Second step in broad cleanup effort.

        [ File list elided ]

2008-07-05  Sam Weinig  <sam@webkit.org>

        Reviewed by Cameron Zwarich.

        First step in broad cleanup effort.

        [ File list elided ]

2008-07-05  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Cameron Zwarich.

        Rename list.h/cpp to ArgList.h/cpp.

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * VM/Machine.h:
        * kjs/AllInOneFile.cpp:
        * kjs/ArgList.cpp: Copied from JavaScriptCore/kjs/list.cpp.
        * kjs/ArgList.h: Copied from JavaScriptCore/kjs/list.h.
        * kjs/IndexToNameMap.cpp:
        * kjs/JSGlobalData.cpp:
        * kjs/JSGlobalData.h:
        * kjs/JSObject.h:
        * kjs/collector.cpp:
        * kjs/list.cpp: Removed.
        * kjs/list.h: Removed.

2008-07-05  Sam Weinig  <sam@webkit.org>

        Fix non-AllInOne builds again.

        * kjs/BooleanPrototype.cpp:
        * kjs/ErrorPrototype.cpp:
        * kjs/FunctionPrototype.cpp:
        * kjs/NumberPrototype.cpp:
        * kjs/ObjectPrototype.cpp:

2008-07-05  Sam Weinig  <sam@webkit.org>

        Fix build on case-sensitive build systems.

        * kjs/IndexToNameMap.cpp:

2008-07-05  Sam Weinig  <sam@webkit.org>

        Fix build.

        * kjs/Arguments.cpp:
        * kjs/BooleanPrototype.cpp:
        * kjs/DateConstructor.cpp:
        * kjs/ErrorPrototype.cpp:
        * kjs/FunctionPrototype.cpp:
        * kjs/NumberPrototype.cpp:
        * kjs/ObjectPrototype.cpp:
        * kjs/RegExpPrototype.cpp:
        * kjs/StringConstructor.cpp:
        * kjs/lookup.cpp:

2008-07-05  Sam Weinig  <sam@webkit.org>

        Fix non-AllInOne build.

        * kjs/JSGlobalObject.cpp:

2008-07-05  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Cameron Zwarich.

        Split Arguments, IndexToNameMap, PrototypeFunction, GlobalEvalFunction and 
        the functions on the global object out of JSFunction.h/cpp.

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * VM/Machine.cpp:
        * kjs/AllInOneFile.cpp:
        * kjs/Arguments.cpp: Copied from JavaScriptCore/kjs/JSFunction.cpp.
        * kjs/Arguments.h: Copied from JavaScriptCore/kjs/JSFunction.h.
        * kjs/GlobalEvalFunction.cpp: Copied from JavaScriptCore/kjs/JSFunction.cpp.
        * kjs/GlobalEvalFunction.h: Copied from JavaScriptCore/kjs/JSFunction.h.
        * kjs/IndexToNameMap.cpp: Copied from JavaScriptCore/kjs/JSFunction.cpp.
        * kjs/IndexToNameMap.h: Copied from JavaScriptCore/kjs/JSFunction.h.
        * kjs/JSActivation.cpp:
        * kjs/JSFunction.cpp:
        * kjs/JSFunction.h:
        * kjs/JSGlobalObject.cpp:
        * kjs/JSGlobalObjectFunctions.cpp: Copied from JavaScriptCore/kjs/JSFunction.cpp.
        * kjs/JSGlobalObjectFunctions.h: Copied from JavaScriptCore/kjs/JSFunction.h.
        The functions on the global object should be in JSGlobalObject.cpp, but putting them there
        was a 0.5% regression.

        * kjs/PrototypeFunction.cpp: Copied from JavaScriptCore/kjs/JSFunction.cpp.
        * kjs/PrototypeFunction.h: Copied from JavaScriptCore/kjs/JSFunction.h.
        * kjs/Shell.cpp:
        * kjs/lexer.cpp:
        * kjs/ustring.cpp:

2008-07-04  Sam Weinig  <sam@webkit.org>

        Really fix the mac build.

        * JavaScriptCore.xcodeproj/project.pbxproj:

2008-07-04  Sam Weinig  <sam@webkit.org>

        Fix mac build.

        * JavaScriptCore.xcodeproj/project.pbxproj:

2008-07-04  Sam Weinig  <sam@webkit.org>

        Fix non-AllInOne builds.

        * kjs/Error.cpp:
        * kjs/GetterSetter.cpp:
        * kjs/JSImmediate.cpp:
        * kjs/operations.cpp:

2008-07-04  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Dan Bernstein.

        Split Error and GetterSetter out of JSObject.h.

        * API/JSCallbackObjectFunctions.h:
        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * kjs/AllInOneFile.cpp:
        * kjs/ClassInfo.h: Copied from JavaScriptCore/kjs/JSObject.h.
        * kjs/Error.cpp: Copied from JavaScriptCore/kjs/JSObject.cpp.
        * kjs/Error.h: Copied from JavaScriptCore/kjs/JSObject.h.
        * kjs/GetterSetter.cpp:
        * kjs/GetterSetter.h: Copied from JavaScriptCore/kjs/JSObject.h.
        * kjs/JSObject.cpp:
        * kjs/JSObject.h:
        * kjs/nodes.h:

2008-07-04  Simon Hausmann  <hausmann@webkit.org>

        Fix the Wx build, added TreeProfile.cpp to the build.

        * JavaScriptCoreSources.bkl:

2008-07-03  Mark Rowe  <mrowe@apple.com>

        Reviewed by Oliver Hunt.

        Fix output path of recently-added script phase to reference the correct file.
        This prevents Xcode from running the script phase unnecessarily, which caused
        the generated header to be recreated and lead to AllInOneFile.cpp rebuilding.

        * JavaScriptCore.xcodeproj/project.pbxproj:

2008-07-03  Mark Rowe  <mrowe@apple.com>

        Follow-up to the 64-bit build fix.  Use intptr_t rather than ssize_t as
        the latter is non-standard and does not exist on Windows.

        * kjs/JSLock.cpp:
        (KJS::JSLock::lockCount):
        (KJS::JSLock::lock):
        (KJS::JSLock::unlock):
        (KJS::JSLock::DropAllLocks::DropAllLocks):
        * kjs/JSLock.h:

2008-07-02  Mark Rowe  <mrowe@apple.com>

        Fix the 64-bit build.  pthread_getspecific works with pointer-sized values,
        so use ssize_t rather than int to track the lock count to avoid warnings about
        truncating the result of pthread_getspecific.

        * kjs/JSLock.cpp:
        (KJS::JSLock::lockCount):
        (KJS::JSLock::lock):
        (KJS::JSLock::unlock):
        (KJS::JSLock::DropAllLocks::DropAllLocks):
        * kjs/JSLock.h:

2008-07-03  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Sam Weinig.
        
        Removed checking for the array get/put fast case from the array code.
        Callers who want the fast case should call getIndex and/or setIndex
        instead. (get_by_val and put_by_val already do this.)
        
        SunSpider reports no change overall, but a 1.4% speedup on fannkuch and
        a 3.6% speedup on nsieve.

2008-07-03  Dan Bernstein  <mitz@apple.com>

        - Windows build fix

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj: Added TreeProfile.{h,cpp}.

2008-07-03  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - Windows build fix

        * VM/Machine.cpp:
        (KJS::Machine::Machine):

2008-07-03  Simon Hausmann  <hausmann@webkit.org>

        Reviewed by Alexey Proskuryakov.

        Fix the non-threaded build.

        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::threadInstanceInternal):

2008-07-03  Simon Hausmann  <hausmann@webkit.org>

        Fix the Qt build, added TreeProfile to the build.

        * JavaScriptCore.pri:

2008-07-02  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff.

        Don't create unnecessary JSGlobalData instances.

        * kjs/JSGlobalData.h:
        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::threadInstanceExists):
        (KJS::JSGlobalData::sharedInstanceExists):
        (KJS::JSGlobalData::threadInstance):
        (KJS::JSGlobalData::sharedInstance):
        (KJS::JSGlobalData::threadInstanceInternal):
        (KJS::JSGlobalData::sharedInstanceInternal):
        Added methods to query instance existence.

        * kjs/InitializeThreading.cpp:
        (KJS::initializeThreadingOnce):
        Initialize thread instance static in a new way.

        * API/JSBase.cpp:
        (JSGarbageCollect):
        * kjs/collector.cpp:
        (KJS::Heap::collect):
        Check for instance existence before accessing it.

2008-07-02  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Cameron Zwarich.
        
        Fixed https://bugs.webkit.org/show_bug.cgi?id=19862
        REGRESSION (r34907): Gmail crashes in JavaScriptCore code while editing drafts
        
        I was never able to reproduce this issue, but Cameron could, and he says
        that this patch fixes it.
        
        The crash seems tied to a timer or event handler callback. In such a case,
        the sole reference to the global object may be in the current call frame,
        so we can't depend on the global object to mark the call frame area in
        the register file.
        
        The new GC marking rule is: the global object is not responsible for
        marking the whole register file -- it's just responsible for the globals
        section it's tied to. The heap is responsible for marking the call frame area.

2008-07-02  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        Add the ability to trace JavaScriptCore garabge collections using dtrace.

        * JavaScriptCore.xcodeproj/project.pbxproj: Generate the dtrace probe header
        file when building on a new enough version of Mac OS X.
        * JavaScriptCorePrefix.h: Add our standard Mac OS X version detection macros.
        * kjs/Tracing.d: Declare three dtrace probes.
        * kjs/Tracing.h: Include the generated dtrace macros if dtrace is available,
        otherwise provide versions that do nothing.
        * kjs/collector.cpp:
        (KJS::Heap::collect): Fire dtrace probes when starting a collection, after the
        mark phase has completed, and when the collection is complete.
        * wtf/Platform.h: Define HAVE_DTRACE when building on a new enough version of Mac OS X.

2008-07-02  Geoffrey Garen  <ggaren@apple.com>

        Rubber stamped by Oliver Hunt.
        
        Reduced the max register file size from 8MB to 2MB.

        We still allow about 20,000 levels of recursion.

2008-07-02  Alp Toker  <alp@nuanti.com>

        Build fix for r34960. Add TreeProfile.cpp to build.

        * GNUmakefile.am:

2008-07-02  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.

        Optimized a[n] get for cases when a is an array or a string. When a is
        an array, we optimize both get and put. When a is a string, we only
        optimize get, since you can't put to a string.
        
        SunSpider says 3.4% faster.

2008-07-02  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        -Small cleanup in preparation for implementing Bottom-up.

        * profiler/CallIdentifier.h: Rename debug function to make it clear of
        its output and intention to be debug only.
        (KJS::CallIdentifier::operator const char* ): Implement in terms of
        c_str.
        (KJS::CallIdentifier::c_str):
        * profiler/ProfileNode.cpp: Impelment findChild() which will be needed
        by the bottom-up implementation.
        (KJS::ProfileNode::findChild):
        * profiler/ProfileNode.h: Added comments to make the collections of
        functions more clear.
        (KJS::ProfileNode::operator==):
        (KJS::ProfileNode::c_str):

2008-07-02  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Darin.

        Bug 19776: Number.toExponential() is incorrect for numbers between 0.1 and 1
        <https://bugs.webkit.org/show_bug.cgi?id=19776>

        Perform the sign check for the exponent on the actual exponent value,
        which is 1 less than the value of decimalPoint, instead of on the value
        of decimalPoint itself.

        * kjs/NumberPrototype.cpp:
        (KJS::exponentialPartToString):

2008-07-02  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        <rdar://problem/5951532> JSProfiler: Implement Bottom-Up view (19228)
        - Subclass TreeProfile as I prepare for a HeavyProfile to be comming
        later.

        * JavaScriptCore.xcodeproj/project.pbxproj:
        * profiler/Profile.cpp: By default we create a TreeProfile.
        (KJS::Profile::create):
        * profiler/Profile.h: Changes to the Profile class to make it amenable
        to be inherited from.
        (KJS::Profile::~Profile):
        * profiler/TreeProfile.cpp: Added.
        (KJS::TreeProfile::create):
        (KJS::TreeProfile::TreeProfile):
        (KJS::TreeProfile::heavyProfile):
        * profiler/TreeProfile.h: Added.
        (KJS::TreeProfile::treeProfile):

2008-07-02  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Dan.

        Broke CallIdentifier out into its own file. I did this because it's
        going to grow a lot soon and I wanted this to be a separate patch.

        * JavaScriptCore.xcodeproj/project.pbxproj:
        * profiler/CallIdentifier.h: Added.
        (KJS::CallIdentifier::CallIdentifier):
        (KJS::CallIdentifier::operator==):
        (KJS::CallIdentifier::operator!=):
        (KJS::CallIdentifier::operator const char* ):
        (KJS::CallIdentifier::toString):
        * profiler/ProfileNode.h:

2008-07-02  Simon Hausmann  <hausmann@webkit.org>

        Build fix. Implemented missing functions for single-threaded build.

        * kjs/JSLock.cpp:
        (KJS::JSLock::JSLock):
        (KJS::JSLock::lock):
        (KJS::JSLock::unlock):
        (KJS::JSLock::DropAllLocks::DropAllLocks):

2008-07-02  Alexey Proskuryakov  <ap@webkit.org>

        Another non-AllInOne build fix.

        * kjs/JSGlobalObject.cpp: Include JSLock.h here, too.

2008-07-02  Alexey Proskuryakov  <ap@webkit.org>

        Non-AllInOne build fix.

        * kjs/interpreter.cpp: Include JSLock.h.

2008-06-30  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        Disable JSLock for per-thread contexts.

        No change on SunSpider.

        * kjs/JSGlobalData.h:
        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::JSGlobalData):
        (KJS::JSGlobalData::sharedInstance):
        Added isSharedInstance as a better way to tell whether the instance is shared (legacy).

        * kjs/JSLock.cpp:
        (KJS::createJSLockCount):
        (KJS::JSLock::lockCount):
        (KJS::setLockCount):
        (KJS::JSLock::JSLock):
        (KJS::JSLock::lock):
        (KJS::JSLock::unlock):
        (KJS::JSLock::currentThreadIsHoldingLock):
        (KJS::JSLock::DropAllLocks::DropAllLocks):
        (KJS::JSLock::DropAllLocks::~DropAllLocks):
        * kjs/JSLock.h:
        (KJS::JSLock::JSLock):
        (KJS::JSLock::~JSLock):
        Made JSLock and JSLock::DropAllLocks constructors take a parameter to decide whether to
        actually lock a mutex, or only to increment recursion count. We cannot turn it into no-op
        if we want to keep existing assertions working.
        Made recursion count per-thread, now that locks may not lock.

        * API/JSBase.cpp:
        (JSEvaluateScript): Take JSLock after casting JSContextRef to ExecState* (which doesn't need
        locking in any case), so that a decision whether to actually lock can be made.
        (JSCheckScriptSyntax): Ditto.
        (JSGarbageCollect): Only lock while collecting the shared heap, not the per-thread one.

        * API/JSObjectRef.cpp:
        (JSClassCreate): Don't lock, as there is no reason to.
        (JSClassRetain): Ditto.
        (JSClassRelease): Ditto.
        (JSPropertyNameArrayRetain): Ditto.
        (JSPropertyNameArrayRelease): Only lock while deleting the array, as that may touch
        identifier table.
        (JSPropertyNameAccumulatorAddName): Adding a string also involves an identifier table
        lookup, and possibly modification.

        * API/JSStringRef.cpp:
        (JSStringCreateWithCharacters):
        (JSStringCreateWithUTF8CString):
        (JSStringRetain):
        (JSStringRelease):
        (JSStringGetUTF8CString):
        (JSStringIsEqual):
        * API/JSStringRefCF.cpp:
        (JSStringCreateWithCFString):
        JSStringRef operations other than releasing do not need locking.

        * VM/Machine.cpp: Don't include unused JSLock.h.

        * kjs/CollectorHeapIntrospector.cpp: (KJS::CollectorHeapIntrospector::statistics):
        Don't take the lock for real, as heap introspection pauses the process anyway. It seems that
        the existing code could cause deadlocks.

        * kjs/Shell.cpp:
        (functionGC):
        (main):
        (jscmain):
        The test tool uses a per-thread context, so no real locking is required.

        * kjs/collector.h:
        (KJS::Heap::setGCProtectNeedsLocking): Optionally protect m_protectedValues access with a
        per-heap mutex. This is only needed for WebCore Database code, which violates the "no data
        migration between threads" by using ProtectedPtr on a background thread.
        (KJS::Heap::isShared): Keep a shared flag here, as well.

        * kjs/protect.h:
        (KJS::::ProtectedPtr):
        (KJS::::~ProtectedPtr):
        (KJS::::operator):
        (KJS::operator==):
        (KJS::operator!=):
        ProtectedPtr is ony used from WebCore, so it doesn't need to take JSLock. An assertion in
        Heap::protect/unprotect guards agains possible future unlocked uses of ProtectedPtr in JSC.

        * kjs/collector.cpp:
        (KJS::Heap::Heap): Initialize m_isShared.
        (KJS::Heap::~Heap): No need to lock for real during destruction, but must keep assertions
        in sweep() working.
        (KJS::destroyRegisteredThread): Registered thread list is only accessed for shared heap,
        so locking is always needed here.
        (KJS::Heap::registerThread): Ditto.
        (KJS::Heap::markStackObjectsConservatively): Use m_isShared instead of comparing to a shared
        instance for a small speedup.
        (KJS::Heap::setGCProtectNeedsLocking): Create m_protectedValuesMutex. There is currently no
        way to undo this - and ideally, Database code will be fixed to lo longer require this quirk.
        (KJS::Heap::protect): Take m_protectedValuesMutex (if it exists) while accessing
        m_protectedValues.
        (KJS::Heap::unprotect): Ditto.
        (KJS::Heap::markProtectedObjects): Ditto.
        (KJS::Heap::protectedGlobalObjectCount): Ditto.
        (KJS::Heap::protectedObjectCount): Ditto.
        (KJS::Heap::protectedObjectTypeCounts): Ditto.

        * kjs/ustring.cpp:
        * kjs/ustring.h:
        Don't include JSLock.h, which is no longer used here. As a result, an explicit include had
        to be added to many files in JavaScriptGlue, WebCore and WebKit.

        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::init):
        * API/JSCallbackConstructor.cpp:
        (KJS::constructJSCallback):
        * API/JSCallbackFunction.cpp:
        (KJS::JSCallbackFunction::call):
        * API/JSCallbackObjectFunctions.h:
        (KJS::::init):
        (KJS::::getOwnPropertySlot):
        (KJS::::put):
        (KJS::::deleteProperty):
        (KJS::::construct):
        (KJS::::hasInstance):
        (KJS::::call):
        (KJS::::getPropertyNames):
        (KJS::::toNumber):
        (KJS::::toString):
        (KJS::::staticValueGetter):
        (KJS::::callbackGetter):
        * API/JSContextRef.cpp:
        (JSGlobalContextCreate):
        (JSGlobalContextRetain):
        (JSGlobalContextRelease):
        * API/JSValueRef.cpp:
        (JSValueIsEqual):
        (JSValueIsStrictEqual):
        (JSValueIsInstanceOfConstructor):
        (JSValueMakeNumber):
        (JSValueMakeString):
        (JSValueToNumber):
        (JSValueToStringCopy):
        (JSValueToObject):
        (JSValueProtect):
        (JSValueUnprotect):
        * JavaScriptCore.exp:
        * kjs/PropertyNameArray.h:
        (KJS::PropertyNameArray::globalData):
        * kjs/interpreter.cpp:
        (KJS::Interpreter::checkSyntax):
        (KJS::Interpreter::evaluate):
        Pass a parameter to JSLock/JSLock::DropAllLocks to decide whether the lock needs to be taken.

2008-07-01  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        https://bugs.webkit.org/show_bug.cgi?id=19834
        Failed assertion in JavaScriptCore/VM/SegmentedVector.h:82

        Creating a global object with a custom prototype resets it twice (wasteful!).
        So, addStaticGlobals() was called twice, but JSGlobalObject::reset() didn't reset
        the register array.        

        * kjs/JSGlobalObject.cpp: (KJS::JSGlobalObject::reset): Call setRegisterArray(0, 0).

        * kjs/JSVariableObject.h: Changed registerArray to OwnArrayPtr. Also, added private copy
        constructor and operator= to ensure that no one attempts to copy this object (for whatever
        reason, I couldn't make Noncopyable work).

        * kjs/JSGlobalObject.h: (KJS::JSGlobalObject::addStaticGlobals): Allocate registerArray
        with new[].

        * kjs/JSVariableObject.cpp:
        (KJS::JSVariableObject::copyRegisterArray): Allocate registerArray with new[].
        (KJS::JSVariableObject::setRegisterArray): Avoid hitting an assertion in OwnArrayPtr when
        "changing" the value from 0 to 0.

2008-07-01  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Removed and/or reordered exception checks in array-style a[n] access.
        
        SunSpider says 1.4% faster.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute): No need to check for exceptions before
        calling toString, toNumber and/or get. If the call ends up being observable
        through toString, valueOf, or a getter, we short-circuit it there, instead.
        In the op_del_by_val case, I removed the incorrect comment without actually
        removing the code, since I didn't want to tempt the GCC fates!

        * kjs/JSObject.cpp:
        (KJS::callDefaultValueFunction): Added exception check to prevent
        toString and valueOf functions from observing execution after an exception
        has been thrown. This removes some of the burden of exception checking
        from the machine.

        (KJS::JSObject::defaultValue): Removed redundant exception check here.

        * kjs/PropertySlot.cpp:
        (KJS::PropertySlot::functionGetter): Added exception check to prevent
        getter functions from observing execution after an exception has been
        thrown. This removes some of the burden of exception checking from the
        machine.

2008-07-01  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Optimized a[n] get and put for cases where n is an immediate unsigned
        value.
        
        SunSpider says 3.5% faster.

2008-07-01  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Darin.

        Bug 19844: JavaScript Switch statement modifies "this"
        <https://bugs.webkit.org/show_bug.cgi?id=19844>

        Use a temporary when generating code for switch clauses to avoid
        overwriting 'this' or a local variable.

        * kjs/nodes.cpp:
        (KJS::CaseBlockNode::emitCodeForBlock):

2008-07-01  Christian Dywan  <christian@twotoasts.de>

        Gtk+ build fix.

        * kjs/list.cpp: Include "JSCell.h"

2008-07-01  Kevin McCullough  <kmccullough@apple.com>

        Build fix.

        * JavaScriptCore.xcodeproj/project.pbxproj:

2008-07-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - Mac release build fix

        * JavaScriptCore.exp:

2008-07-01  Sam Weinig  <sam@webkit.org>

        Try and fix mac builds.

        * JavaScriptCore.exp:

2008-07-01  Sam Weinig  <sam@webkit.org>

        Fix non-AllInOne builds.

        * kjs/DateMath.cpp:

2008-07-01  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin Adler.

        Split JSCell and JSNumberCell class declarations out of JSValue.h

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * VM/JSPropertyNameIterator.h:
        * kjs/AllInOneFile.cpp:
        * kjs/JSCell.cpp: Copied from JavaScriptCore/kjs/JSValue.cpp.
        * kjs/JSCell.h: Copied from JavaScriptCore/kjs/JSValue.h.
        (KJS::JSValue::getJSNumber):
        * kjs/JSNumberCell.cpp:
        * kjs/JSNumberCell.h: Copied from JavaScriptCore/kjs/JSValue.h.
        * kjs/JSObject.h:
        * kjs/JSString.cpp:
        (KJS::jsString):
        (KJS::jsOwnedString):
        * kjs/JSString.h:
        (KJS::JSValue::toThisJSString):
        * kjs/JSValue.cpp:
        * kjs/JSValue.h:

2008-07-01  Anders Carlsson  <andersca@apple.com>

        Build fixes.
        
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * kjs/JSGlobalObject.h:
        (KJS::JSGlobalObject::addStaticGlobals):

2008-07-01  Simon Hausmann  <hausmann@webkit.org>

        Build fix, include OwnPtr.h.

        * kjs/RegExpConstructor.h:

2008-06-30  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Fixed a global object leak caused by the switch to one register file.
        
        Don't unconditionally mark the register file, since that logically
        makes all global variables GC roots, even when their global object is
        no longer reachable.
        
        Instead, make the global object associated with the register file
        responsible for marking the register file.

2008-06-30  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Removed the "registerBase" abstraction. Since the register file never
        reallocates, we can keep direct pointers into it, instead of
        <registerBase, offset> tuples.
        
        SunSpider says 0.8% faster.
        
2008-06-30  Oliver Hunt  <oliver@apple.com>

        Reviewed by NOBODY (build fix).

        Fix build by adding all (hopefully) the missing includes.

        * kjs/BooleanPrototype.cpp:
        * kjs/DateConstructor.cpp:
        * kjs/ErrorPrototype.cpp:
        * kjs/FunctionPrototype.cpp:
        * kjs/NativeErrorConstructor.cpp:
        * kjs/NumberPrototype.cpp:
        * kjs/ObjectPrototype.cpp:
        * kjs/RegExpConstructor.cpp:
        * kjs/StringConstructor.cpp:
        * kjs/StringPrototype.cpp:

2008-06-30  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Bug 19830: REGRESSION (r34883): Google Reader doesn't show up feed list on sidebar
        <https://bugs.webkit.org/show_bug.cgi?id=19830>

        Ensure that we do not eliminate a write to a local register when doing
        peephole optimizations.

        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitJumpIfTrue):
        (KJS::CodeGenerator::emitJumpIfFalse):

2008-06-30  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Darin Alder.

        Split InternalFunction into its own header file.

        * API/JSCallbackFunction.h:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * kjs/ArrayConstructor.h:
        * kjs/BooleanConstructor.h:
        * kjs/DateConstructor.h:
        * kjs/ErrorConstructor.h:
        * kjs/FunctionConstructor.h:
        * kjs/FunctionPrototype.h:
        * kjs/InternalFunction.h: Copied from kjs/JSFunction.h.
        * kjs/JSFunction.h:
        * kjs/NativeErrorConstructor.h:
        * kjs/NumberConstructor.h:
        * kjs/ObjectConstructor.h:
        * kjs/RegExpConstructor.h:
        * kjs/StringConstructor.h:
        * profiler/Profiler.cpp:

2008-06-30  Sam Weinig  <sam@webkit.org>

        Reviewed by Kevin McCullough.

        Remove empty files Instruction.cpp, LabelID.cpp, Register.cpp and RegisterID.cpp.

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * VM/Instruction.cpp: Removed.
        * VM/LabelID.cpp: Removed.
        * VM/Register.cpp: Removed.
        * VM/RegisterID.cpp: Removed.

2008-06-30  Sam Weinig  <sam@webkit.org>

        Rubber-stamped (reluctantly) by Kevin McCullough.

        Rename date_object.h/cpp to DateInstance.h/cpp

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * kjs/AllInOneFile.cpp:
        * kjs/DateConstructor.cpp:
        * kjs/DateInstance.cpp: Copied from kjs/date_object.cpp.
        * kjs/DateInstance.h: Copied from kjs/date_object.h.
        * kjs/DatePrototype.cpp:
        * kjs/DatePrototype.h:
        * kjs/date_object.cpp: Removed.
        * kjs/date_object.h: Removed.

2008-06-30  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Darin Adler.

        Remove internal.cpp and move its contents to there own .cpp files.

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * kjs/AllInOneFile.cpp:
        * kjs/GetterSetter.cpp: Copied from kjs/internal.cpp.
        * kjs/InternalFunction.cpp: Copied from kjs/internal.cpp.
        * kjs/JSNumberCell.cpp: Copied from kjs/internal.cpp.
        * kjs/JSString.cpp: Copied from kjs/internal.cpp.
        * kjs/JSString.h:
        * kjs/LabelStack.cpp: Copied from kjs/internal.cpp.
        * kjs/NumberConstructor.cpp:
        * kjs/NumberObject.cpp:
        (KJS::constructNumber):
        (KJS::constructNumberFromImmediateNumber):
        * kjs/internal.cpp: Removed.

2008-06-30  Adam Roben  <aroben@apple.com>

        Fix <rdar://5954749> Assertion failure due to HashTable's use of
        operator&

        HashTable was passing &value to constructDeletedValue, which in
        classes like WebCore::COMPtr would cause an assertion. We now pass
        value by reference instead of by address so that the HashTraits
        implementations have more flexibility in constructing the deleted
        value.

        Reviewed by Ada Chan.

        * VM/CodeGenerator.h: Updated for changes to HashTraits.
        * wtf/HashTable.h:
        (WTF::::deleteBucket): Changed to pass bucket by reference instead of
        by address.
        (WTF::::checkKey): Ditto.
        * wtf/HashTraits.h:
        (WTF::): Updated HashTraits for HashTable change.

2008-07-01  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Cameron Zwarich.

        Make RegisterFile really unmap memory on destruction.

        This fixes run-webkit-tests --threaded, which ran out of address space in a few seconds.

        * VM/RegisterFile.cpp: (KJS::RegisterFile::~RegisterFile): Unmap all the memory, not just
        1/4 of it.

        * kjs/JSGlobalObject.h: Don't include RegisterFile.h, so that changes to it don't make
        half of WebCore rebuild.

        * VM/Machine.h: Don't forward declare RegisterFile, as RegisterFile.h is included already.

        * VM/RegisterFile.h: (KJS::RegisterFile::RegisterFile): Assert that the allocation succeeded.

2008-06-30  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Rubber-stamped by Oliver.

        Correct the documentation for op_put_by_index.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):

2008-06-29  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Bug 19821: Merge the instruction pair (less, jfalse)
        <https://bugs.webkit.org/show_bug.cgi?id=19821>
        
        This is a 2.4% win on SunSpider. I needed to add an ALWAYS_INLINE
        intrinisc to CodeGenerator::rewindBinaryOp() to avoid a massive
        regression in regexp-dna.

        * VM/CodeBlock.cpp:
        (KJS::CodeBlock::dump):
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::rewindBinaryOp):
        (KJS::CodeGenerator::emitJumpIfFalse):
        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):
        * VM/Opcode.cpp:
        (KJS::):
        * VM/Opcode.h:

2008-06-29  Sam Weinig  <sam@webkit.org>

        Fix non-AllInOne builds.

        * kjs/JSObject.cpp:
        * kjs/JSValue.cpp:

2008-06-29  Sam Weinig  <sam@webkit.org>

        Build fix for Qt.

        * kjs/DateMath.cpp:
        * kjs/DatePrototype.cpp:

2008-06-29  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Cameron Zwarich.

        Splits ErrorConstructor, ErrorPrototype,  NativeErrorConstructor and
        NativeErrorPrototype out of error_object.h/cpp and renames it ErrorInstance.

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * kjs/AllInOneFile.cpp:
        * kjs/ArrayConstructor.cpp:
        * kjs/ArrayPrototype.cpp:
        * kjs/BooleanPrototype.cpp:
        * kjs/DatePrototype.cpp:
        * kjs/ErrorConstructor.cpp: Copied from kjs/error_object.cpp.
        * kjs/ErrorConstructor.h: Copied from kjs/error_object.h.
        * kjs/ErrorInstance.cpp: Copied from kjs/error_object.cpp.
        * kjs/ErrorInstance.h: Copied from kjs/error_object.h.
        * kjs/ErrorPrototype.cpp: Copied from kjs/error_object.cpp.
        * kjs/ErrorPrototype.h: Copied from kjs/error_object.h.
        * kjs/JSGlobalObject.cpp:
        * kjs/JSObject.cpp:
        * kjs/JSValue.cpp:
        * kjs/NativeErrorConstructor.cpp: Copied from kjs/error_object.cpp.
        * kjs/NativeErrorConstructor.h: Copied from kjs/error_object.h.
        * kjs/NativeErrorPrototype.cpp: Copied from kjs/error_object.cpp.
        * kjs/NativeErrorPrototype.h: Copied from kjs/error_object.h.
        * kjs/NumberPrototype.cpp:
        * kjs/RegExpConstructor.cpp:
        * kjs/RegExpObject.cpp:
        * kjs/RegExpPrototype.cpp:
        * kjs/StringPrototype.cpp:
        * kjs/error_object.cpp: Removed.
        * kjs/error_object.h: Removed.
        * kjs/internal.cpp:

2008-06-29  Sam Weinig  <sam@webkit.org>

        Fix non-AllInOne build.

        * kjs/DateConstructor.cpp:
        * kjs/DateMath.cpp:
        * kjs/JSObject.cpp:

2008-06-29  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Oliver Hunt.

        Splits DateConstructor and DatePrototype out of date_object.h/cpp
        Moves shared Date code into DateMath.

        * DerivedSources.make:
        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * kjs/AllInOneFile.cpp:
        * kjs/DateConstructor.cpp: Copied from kjs/date_object.cpp.
        * kjs/DateConstructor.h: Copied from kjs/date_object.h.
        * kjs/DateMath.cpp:
        (KJS::ymdhmsToSeconds):
        (KJS::):
        (KJS::skipSpacesAndComments):
        (KJS::findMonth):
        (KJS::parseDate):
        (KJS::timeClip):
        (KJS::formatDate):
        (KJS::formatDateUTCVariant):
        (KJS::formatTime):
        * kjs/DateMath.h:
        (KJS::gmtoffset):
        * kjs/DatePrototype.cpp: Copied from kjs/date_object.cpp.
        * kjs/DatePrototype.h: Copied from kjs/date_object.h.
        * kjs/JSGlobalObject.cpp:
        * kjs/JSObject.cpp:
        * kjs/date_object.cpp:
        * kjs/date_object.h:
        * kjs/internal.cpp:

2008-06-29  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Rubber-stamped by Cameron Zwarich

        Fix Gtk non-AllInOne build

        * GNUmakefile.am: include JSVariableObject.cpp
        * kjs/RegExpConstructor.cpp: include RegExpObject.h
        * kjs/RegExpObject.h: forward declare RegExpPrototype

2008-06-28  Darin Adler  <darin@apple.com>

        Reviewed by Sam and Cameron.

        - fix https://bugs.webkit.org/show_bug.cgi?id=19805
          Array.concat turns missing array elements into "undefined"

        Test: fast/js/array-holes.html

        * JavaScriptCore.exp: No longer export JSArray::getItem.

        * kjs/ArrayPrototype.cpp:
        (KJS::arrayProtoFuncConcat): Changed to use getProperty instead of
        JSArray::getItem -- need to handle properties from the prototype chain
        instead of ignoring them.

        * kjs/JSArray.cpp: Removed getItem.
        * kjs/JSArray.h: Ditto.

2008-06-28  Darin Adler  <darin@apple.com>

        Reviewed by Cameron.

        - https://bugs.webkit.org/show_bug.cgi?id=19804
          optimize access to arrays without "holes"

        SunSpider says 1.8% faster.

        * kjs/JSArray.cpp:
        (KJS::JSArray::JSArray): Initialize m_fastAccessCutoff when creating
        arrays. Also updated for new location of m_vectorLength.
        (KJS::JSArray::getItem): Updated for new location of m_vectorLength.
        (KJS::JSArray::getSlowCase): Added. Broke out the non-hot parts of
        getOwnPropertySlot to make the hot part faster.
        (KJS::JSArray::getOwnPropertySlot): Added a new faster case for
        indices lower than m_fastAccessCutoff. We can do theese with no
        additional checks or branches.
        (KJS::JSArray::put): Added a new faster case for indices lower than
        m_fastAccessCutoff. We can do theese with no additional checks or
        branches. Moved the maxArrayIndex handling out of this function.
        Added code to set m_fastAccessCutoff when the very last hole in
        an array is filled; this is how the cutoff gets set for most arrays.
        (KJS::JSArray::putSlowCase): Moved the rest of the put function logic
        in here, to make the hot part of the put function faster.
        (KJS::JSArray::deleteProperty): Added code to lower m_fastAccessCutoff
        when a delete makes a new hole in the array.
        (KJS::JSArray::getPropertyNames): Updated for new location of
        m_vectorLength.
        (KJS::JSArray::increaseVectorLength): Ditto.
        (KJS::JSArray::setLength): Added code to lower m_fastAccessCutoff
        when setLength makes the array smaller.
        (KJS::JSArray::mark): Updated for new location of m_vectorLength.
        (KJS::JSArray::sort): Ditto. Set m_fastAccessCutoff after moving
        all the holes to the end of the array.
        (KJS::JSArray::compactForSorting): Ditto.
        (KJS::JSArray::checkConsistency): Added consistency checks fro
        m_fastAccessCutoff and updated for the new location of m_vectorLength.

        * kjs/JSArray.h: Added declarations for slow case functions.
        Replaced m_vectorLength with m_fastAccessCutoff.

2008-06-28  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Sam.

        When executing a native call, check for an exception before writing the
        return value.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):

2008-06-28  Mark Rowe  <mrowe@apple.com>

        Build fix.  Flag headers as private or public as is appropriate.
        These settings were accidentally removed during some project file cleanup.

        * JavaScriptCore.xcodeproj/project.pbxproj:

2008-06-28  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Darin Adler.

        Splits RegExpConstructor and RegExpPrototype out of RegExpObject.h/cpp

        * DerivedSources.make:
        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * VM/Machine.cpp:
        * kjs/AllInOneFile.cpp:
        * kjs/JSGlobalObject.cpp:
        * kjs/RegExpConstructor.cpp: Copied from kjs/RegExpObject.cpp.
        * kjs/RegExpConstructor.h: Copied from kjs/RegExpObject.h.
        * kjs/RegExpObject.cpp:
        * kjs/RegExpObject.h:
        * kjs/RegExpPrototype.cpp: Copied from kjs/RegExpObject.cpp.
        * kjs/RegExpPrototype.h: Copied from kjs/RegExpObject.h.
        * kjs/StringPrototype.cpp:
        * kjs/internal.cpp:

2008-06-28  Sam Weinig  <sam@webkit.org>

        Fix non-AllInOne builds.

        * kjs/StringConstructor.cpp:

2008-06-28  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Darin Adler.

        Rename string_object.h/cpp to StringObject.h/cpp and split out StringObjectThatMasqueradesAsUndefined,
        StringConstructor and StringPrototype.

        * DerivedSources.make:
        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * kjs/AllInOneFile.cpp:
        * kjs/JSGlobalObject.cpp:
        * kjs/StringConstructor.cpp: Copied from JavaScriptCore/kjs/string_object.cpp.
        * kjs/StringConstructor.h: Copied from JavaScriptCore/kjs/string_object.h.
        * kjs/StringObject.cpp: Copied from JavaScriptCore/kjs/string_object.cpp.
        * kjs/StringObject.h: Copied from JavaScriptCore/kjs/string_object.h.
        * kjs/StringObjectThatMasqueradesAsUndefined.h: Copied from JavaScriptCore/kjs/string_object.h.
        * kjs/StringPrototype.cpp: Copied from JavaScriptCore/kjs/string_object.cpp.
        * kjs/StringPrototype.h: Copied from JavaScriptCore/kjs/string_object.h.
        * kjs/internal.cpp:
        * kjs/string_object.cpp: Removed.
        * kjs/string_object.h: Removed.

2008-06-28  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Gtk build fix: JSVariableObject is now part of AllInOne

        * GNUmakefile.am:

2008-06-28  Darin Adler  <darin@apple.com>

        Reviewed by Oliver.

        - https://bugs.webkit.org/show_bug.cgi?id=19801
          add a feature so we can tell what regular expressions are taking time

        * pcre/pcre_compile.cpp:
        (jsRegExpCompile): Compile in the string if REGEXP_HISTOGRAM is on.

        * pcre/pcre_exec.cpp:
        (jsRegExpExecute): Add hook to time execution.
        (Histogram::~Histogram): Print a sorted list of what took time.
        (Histogram::add): Accumulate records of what took time.
        (HistogramTimeLogger::~HistogramTimeLogger): Hook that calls
        Histogram::add at the right moment and creates the global histogram
        object.

        * pcre/pcre_internal.h: Define REGEXP_HISTOGRAM.

        * pcre/pcre_tables.cpp: Added missing include of "config.h". Not needed
        any more, but an omissions an earlier version of this patch detected.
        * pcre/pcre_ucp_searchfuncs.cpp: Ditto.
        * pcre/pcre_xclass.cpp: Ditto.

2008-06-28  Sam Weinig  <sam@webkit.org>

        Try and fix the Windows build again.

        * kjs/RegExpObject.cpp:
        * kjs/date_object.cpp:
        * kjs/error_object.cpp:

2008-06-28  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Darin Adler.

        Remove unused StringConstructorFunction class.

        * kjs/string_object.h:

2008-06-28  Sam Weinig  <sam@webkit.org>

        Fix windows build.

        * kjs/ArrayPrototype.cpp:
        * kjs/BooleanPrototype.cpp:
        * kjs/BooleanPrototype.h:
        * kjs/FunctionPrototype.cpp:
        * kjs/JSImmediate.cpp:
        * kjs/JSObject.cpp:
        * kjs/MathObject.cpp:
        * kjs/NumberPrototype.cpp:
        * kjs/NumberPrototype.h:
        * kjs/ObjectConstructor.cpp:
        * kjs/RegExpObject.h:
        * kjs/error_object.h:
        * kjs/string_object.cpp:

2008-06-28  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Oliver Hunt.

        Splits FunctionConstructor out of FunctionPrototype.h/cpp
        Splits NumberConstructor and NumberPrototype out of NumberObject.h/cpp
        Rename object_object.h/cpp to ObjectPrototype.h/cpp and split out ObjectConstructor.

        * API/JSCallbackConstructor.cpp:
        * API/JSClassRef.cpp:
        * API/JSObjectRef.cpp:
        * DerivedSources.make:
        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * VM/Machine.cpp:
        * kjs/AllInOneFile.cpp:
        * kjs/ArrayConstructor.cpp:
        * kjs/ArrayConstructor.h:
        * kjs/FunctionConstructor.cpp: Copied from JavaScriptCore/kjs/FunctionPrototype.cpp.
        * kjs/FunctionConstructor.h: Copied from JavaScriptCore/kjs/FunctionPrototype.h.
        * kjs/FunctionPrototype.cpp:
        * kjs/FunctionPrototype.h:
        * kjs/JSFunction.cpp:
        * kjs/JSGlobalObject.cpp:
        * kjs/JSImmediate.cpp:
        * kjs/MathObject.h:
        * kjs/NumberConstructor.cpp: Copied from JavaScriptCore/kjs/NumberObject.cpp.
        * kjs/NumberConstructor.h: Copied from JavaScriptCore/kjs/NumberObject.h.
        * kjs/NumberObject.cpp:
        * kjs/NumberObject.h:
        * kjs/NumberPrototype.cpp: Copied from JavaScriptCore/kjs/NumberObject.cpp.
        * kjs/NumberPrototype.h: Copied from JavaScriptCore/kjs/NumberObject.h.
        * kjs/ObjectConstructor.cpp: Copied from JavaScriptCore/kjs/object_object.cpp.
        * kjs/ObjectConstructor.h: Copied from JavaScriptCore/kjs/object_object.h.
        * kjs/ObjectPrototype.cpp: Copied from JavaScriptCore/kjs/object_object.cpp.
        * kjs/ObjectPrototype.h: Copied from JavaScriptCore/kjs/object_object.h.
        * kjs/RegExpObject.h:
        * kjs/Shell.cpp:
        * kjs/error_object.h:
        * kjs/internal.cpp:
        * kjs/nodes.cpp:
        * kjs/object_object.cpp: Removed.
        * kjs/object_object.h: Removed.
        * kjs/string_object.h:

2008-06-28  Darin Adler  <darin@apple.com>

        Reviewed by Oliver.

        - fix https://bugs.webkit.org/show_bug.cgi?id=19796
          optimize expressions with ignored results (especially post-increment)

        SunSpider says 0.9% faster.

        * VM/CodeGenerator.h:
        (KJS::CodeGenerator::tempDestination): Create a new temporary for
        ignoredResult() too, just as we would for 0.
        (KJS::CodeGenerator::finalDestination): Use the temporary if the
        register passed in is ignoredResult() too, just as we would for 0.
        (KJS::CodeGenerator::destinationForAssignResult): Return 0 if the
        passed in register is ignoredResult(), just as we would for 0.
        (KJS::CodeGenerator::moveToDestinationIfNeeded): Return 0 if the
        register passed in is ignoredResult(). What matters is that we
        don't want to emit a move. The return value won't be looked at.
        (KJS::CodeGenerator::emitNode): Allow ignoredResult() and pass it
        through to the node's emitCode function.

        * VM/RegisterID.h:
        (KJS::ignoredResult): Added. Special value to indicate the result of
        a node will be ignored and need not be put in any register.

        * kjs/nodes.cpp:
        (KJS::NullNode::emitCode): Do nothing if dst == ignoredResult().
        (KJS::BooleanNode::emitCode): Ditto.
        (KJS::NumberNode::emitCode): Ditto.
        (KJS::StringNode::emitCode): Ditto.
        (KJS::RegExpNode::emitCode): Ditto.
        (KJS::ThisNode::emitCode): Ditto.
        (KJS::ResolveNode::emitCode): Do nothing if dst == ignoredResult() and
        the identifier resolves to a local variable.
        (KJS::ObjectLiteralNode::emitCode): Do nothing if dst == ignoredResult()
        and the object is empty.
        (KJS::PostIncResolveNode::emitCode): If dst == ignoredResult(), then do
        nothing for the local constant case, and do a pre-increment in all the
        other cases.
        (KJS::PostDecResolveNode::emitCode): Ditto.
        (KJS::PostIncBracketNode::emitCode): Ditto.
        (KJS::PostDecBracketNode::emitCode): Ditto.
        (KJS::PostIncDotNode::emitCode): Ditto.
        (KJS::PostDecDotNode::emitCode): Ditto.
        (KJS::DeleteValueNode::emitCode): Pass ignoredResult() when evaluating
        the expression.
        (KJS::VoidNode::emitCode): Ditto.
        (KJS::TypeOfResolveNode::emitCode): If dst == ignoredResult(), do nothing
        if the identifier resolves to a local variable, and don't bother generating
        a typeof opcode in the other case.
        (KJS::TypeOfValueNode::emitCode): Ditto.
        (KJS::PreIncResolveNode::emitCode): Do nothing if dst == ignoredResult() and
        the identifier resolves to a local constant.
        (KJS::PreDecResolveNode::emitCode): Ditto.
        (KJS::AssignResolveNode::emitCode): Turn ignoredResult() into 0 in a couple
        places, because we need to put the result into a register so we can assign
        it. At other sites this is taken care of by functions like finalDestination.
        (KJS::CommaNode::emitCode): Pass ignoredResult() when evaluating the first
        expression.
        (KJS::ForNode::emitCode): Pass ignoredResult() when evaluating the first and
        third expressions.
        (KJS::ForInNode::emitCode): Pass ignoredResult() when evaluating the first
        expression.

2008-06-28  Darin Adler  <darin@apple.com>

        Reviewed by Oliver.

        - https://bugs.webkit.org/show_bug.cgi?id=19787
          create most arrays from values in registers rather than with multiple put operations

        SunSpider says 0.8% faster.

        * VM/CodeBlock.cpp:
        (KJS::CodeBlock::dump): Added argv and argc parameters to new_array.
        * VM/Machine.cpp:
        (KJS::Machine::privateExecute): Ditto.

        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitNewArray): Added.
        * VM/CodeGenerator.h: Added ElementNode* argument to emitNewArray.

        * kjs/nodes.cpp:
        (KJS::ArrayNode::emitCode): Pass the ElementNode to emitNewArray so it can be
        initialized with as many elements as possible. If the array doesn't have any
        holes in it, that's all that's needed. If there are holes, then emit some separate
        put operations for the other values in the array and for the length as needed.

        * kjs/nodes.h: Added some accessors to ElementNode so the code generator can
        iterate through elements and generate code to evaluate them. Now ArrayNode does
        not need to be a friend. Also took out some unused PlacementNewAdoptType
        constructors.

2008-06-28  Darin Adler  <darin@apple.com>

        Reviewed by Oliver.

        * kjs/nodes.h: Remove obsolete PlacementNewAdopt constructors.
        We no longer mutate the AST in place.

2008-06-28  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Reviewed by Oliver Hunt.

        Build fix

        * VM/Machine.cpp: include stdio.h for printf

2008-06-27  Sam Weinig  <sam@webkit.org>

        Reviewed by Oliver Hunt.

        Fix platforms that don't use AllInOne.cpp

        * kjs/BooleanConstructor.h:
        * kjs/BooleanPrototype.h:
        * kjs/FunctionPrototype.cpp:

2008-06-27  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Oliver Hunt.

        Splits ArrayConstructor out of ArrayPrototype.h/cpp
        Splits BooleanConstructor and BooleanPrototype out of BooleanObject.h/cpp

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * VM/Machine.cpp:
        * kjs/AllInOneFile.cpp:
        * kjs/ArrayConstructor.cpp: Copied from kjs/ArrayPrototype.cpp.
        * kjs/ArrayConstructor.h: Copied from kjs/ArrayPrototype.h.
        * kjs/ArrayPrototype.cpp:
        * kjs/ArrayPrototype.h:
        * kjs/BooleanConstructor.cpp: Copied from kjs/BooleanObject.cpp.
        * kjs/BooleanConstructor.h: Copied from kjs/BooleanObject.h.
        * kjs/BooleanObject.cpp:
        * kjs/BooleanObject.h:
        * kjs/BooleanPrototype.cpp: Copied from kjs/BooleanObject.cpp.
        * kjs/BooleanPrototype.h: Copied from kjs/BooleanObject.h.
        * kjs/CommonIdentifiers.h:
        * kjs/FunctionPrototype.cpp:
        * kjs/JSArray.cpp:
        * kjs/JSGlobalObject.cpp:
        * kjs/JSImmediate.cpp:
        * kjs/Shell.cpp:
        * kjs/internal.cpp:
        * kjs/nodes.cpp:
        * kjs/string_object.cpp:

2008-06-27  Oliver Hunt  <oliver@apple.com>

        Reviewed by Sam.

        Bug 18626: SQUIRRELFISH: support the "slow script" dialog <https://bugs.webkit.org/show_bug.cgi?id=18626>
        <rdar://problem/5973931> Slow script dialog needs to be reimplemented for squirrelfish

        Adds support for the slow script dialog in squirrelfish.  This requires the addition
        of three new op codes, op_loop, op_loop_if_true, and op_loop_if_less which have the
        same behaviour as their simple jump equivalents but have an additional time out check.

        Additional assertions were added to other jump instructions to prevent accidentally
        creating loops with jump types that do not support time out checks.

        Sunspider does not report a regression, however this appears very sensitive to code
        layout and hardware, so i would expect up to a 1% regression on other systems.

        Part of this required moving the old timeout logic from JSGlobalObject and into Machine
        which is the cause of a number of the larger diff blocks.

        * JavaScriptCore.exp:
        * VM/CodeBlock.cpp:
        (KJS::CodeBlock::dump):
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitJumpIfTrue):
        (KJS::CodeGenerator::emitJumpScopes):
        * VM/ExceptionHelpers.cpp:
        (KJS::InterruptedExecutionError::isWatchdogException):
        (KJS::createInterruptedExecutionException):
        * VM/ExceptionHelpers.h:
        * VM/LabelID.h:
        * VM/Machine.cpp:
        (KJS::Machine::Machine):
        (KJS::Machine::throwException):
        (KJS::Machine::resetTimeoutCheck):
        (KJS::getCurrentTime):
        (KJS::Machine::checkTimeout):
        (KJS::Machine::privateExecute):
        * VM/Machine.h:
        (KJS::Machine::setTimeoutTime):
        (KJS::Machine::startTimeoutCheck):
        (KJS::Machine::stopTimeoutCheck):
        (KJS::Machine::initTimeout):
        * VM/Opcode.cpp:
        (KJS::):
        * VM/Opcode.h:
        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::init):
        (KJS::JSGlobalObject::setTimeoutTime):
        (KJS::JSGlobalObject::startTimeoutCheck):
        * kjs/JSGlobalObject.h:
        * kjs/JSObject.h:
        * kjs/interpreter.cpp:
        (KJS::Interpreter::evaluate):

2008-06-27  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Gtk and Qt build fix: Remove RegisterFileStack from the build
        scripts.

        * GNUmakefile.am:
        * JavaScriptCore.pri:

2008-06-27  Adele Peterson  <adele@apple.com>

        Reviewed by Geoff.

        Build fixes. 

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * VM/RegisterFile.h:
        (KJS::RegisterFile::RegisterFile):
        * kjs/JSGlobalObject.cpp:
        * kjs/collector.cpp:

2008-06-27  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        One RegisterFile to rule them all!
        
        SunSpider reports a 0.2% speedup.

        This patch removes the RegisterFileStack abstraction and replaces it with
        a single register file that
        
        (a) allocates a fixed storage area, including a fixed area for global
        vars, so that no operation may cause the register file to reallocate
        
        and

        (b) swaps between global storage areas when executing code in different 
        global objects.
        
        This patch also changes the layout of the register file so that all call
        frames, including call frames for global code, get a header. This is
        required to support re-entrant global code. It also just makes things simpler.
        
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::addGlobalVar): New function. Differs from addVar in
        that
        
        (a) global vars don't contribute to a CodeBlock's numLocals count, since
        global storage is fixed and allocated at startup
        
        and
        
        (b) references to global vars get shifted to elide intermediate stack
        between "r" and the global storage area.
        
        * VM/Machine.cpp:
        (KJS::Machine::dumpRegisters): Updated this function to match the new
        register file layout, and added the ability to dump exact identifiers
        for the different parts of a call frame.
        
        (KJS::Machine::unwindCallFrame): Updated this function to match the new
        register file layout.
         
        (KJS::Machine::execute): Updated this function to initialize a call frame
        header for global code, and to swap global storage areas when switching
        to execution in a new global object.
        
        (KJS::Machine::privateExecute): Got rid of "safeForReentry" and re-reading
        of registerBase because the register file is always safe for reentry now,
        and registerBase never changes.
        
        * VM/Machine.h: Moved the call frame header enum from Machine to RegisterFile,
        to resolve a header dependency problem (a good sign that the enum belonged
        in RegisterFile all along!)

        * VM/RegisterFile.cpp:
        * VM/RegisterFile.h: Changed RegisterFile to mmap a fixed size register
        area. This allows us to avoid re-allocting the register file later on.
        Instead, we rely on the OS to allocate physical pages to the register
        file as necessary.

        * VM/RegisterFileStack.cpp: Removed. Tada!
        * VM/RegisterFileStack.h: Removed. Tada!

        * kjs/DebuggerCallFrame.cpp: Updated this class to match the new
        register file layout, greatly simplifying it in the process.

        * kjs/JSActivation.h:
        * kjs/JSActivation.cpp: Moved some of this logic up to JSVariableObject,
        since the global object now needs to be able to tear off its registers
        just like the activation object.

        * kjs/JSFunction.cpp: No need to fiddle with the register file anymore.

        * kjs/JSGlobalObject.h:
        * kjs/JSGlobalObject.cpp: Updated JSGlobalObject to support moving its
        global storage area into and out of the register file.

        * kjs/PropertySlot.cpp: No need to fiddle with the register file anymore.

        * kjs/collector.cpp: Renamed markStackObjectConservatively to
        markConservatively, since we don't just mark stack objects this way.
        
        Also, added code to mark the machine's register file.

        * kjs/config.h: Moved some platforms #defines from here...
        * wtf/Platform.h: ...to here, to support mmap/VirtualAlloc detection
        in RegisterFile.h.

2008-06-26  Mark Rowe  <mrowe@apple.com>

        Speculative fix for the Windows build.

        * kjs/JSImmediate.cpp:

2008-06-26  Mark Rowe  <mrowe@apple.com>

        Reviewed by Darin Adler and Geoff Garen.

        Fix the malloc zone introspection functions so that malloc_zone_statistics does not give
        bogus output in an application that uses JavaScriptCore.

        * kjs/CollectorHeapIntrospector.cpp:
        (KJS::CollectorHeapIntrospector::statistics): Return statistics about memory allocated by the collector.
        * kjs/CollectorHeapIntrospector.h:
        * wtf/FastMalloc.cpp: Zero out the statistics.  FastMalloc doesn't track this information at present.
        Returning zero for all values is preferable to returning bogus data.

2008-06-26  Darin Adler  <darin@apple.com>

        Reviewed by Geoff.

        - https://bugs.webkit.org/show_bug.cgi?id=19721
          speed up JavaScriptCore by not wrapping strings in objects just
          to call functions on them

        - optimize UString append and the replace function a bit

        SunSpider says 1.8% faster.

        * JavaScriptCore.exp: Updated.

        * VM/JSPropertyNameIterator.cpp: Added include of JSString.h, now needed
        because jsString returns a JSString*.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute): Removed the toObject call from native
        function calls. Also removed code to put the this value into a register.

        * kjs/BooleanObject.cpp:
        (KJS::booleanProtoFuncToString): Rewrite to handle false and true
        separately.

        * kjs/FunctionPrototype.cpp:
        (KJS::constructFunction): Use single-character append rather than building
        a string for each character.
        * kjs/JSFunction.cpp:
        (KJS::globalFuncUnescape): Ditto.

        * kjs/JSImmediate.cpp:
        (KJS::JSImmediate::prototype): Added. Gets the appropriate prototype for
        use with an immediate value. To be used instead of toObject when doing a
        get on an immediate value.
        * kjs/JSImmediate.h: Added prototype.

        * kjs/JSObject.cpp:
        (KJS::JSObject::toString): Tweaked formatting.

        * kjs/JSObject.h:
        (KJS::JSValue::get): Use prototype instead of toObject to avoid creating
        an object wrapper just to search for properties. This also saves an
        unnecessary hash table lookup since the object wrappers themselves don't
        have any properties.

        * kjs/JSString.h: Added toThisString and toThisJSString.

        * kjs/JSValue.cpp:
        (KJS::JSCell::toThisString): Added.
        (KJS::JSCell::toThisJSString): Added.
        (KJS::JSCell::getJSNumber): Added.
        (KJS::jsString): Changed return type to JSString*.
        (KJS::jsOwnedString): Ditto.

        * kjs/JSValue.h:
        (KJS::JSValue::toThisString): Added.
        (KJS::JSValue::toThisJSString): Added.
        (KJS::JSValue::getJSNumber): Added.

        * kjs/NumberObject.cpp:
        (KJS::NumberObject::getJSNumber): Added.
        (KJS::integer_part_noexp): Append C string directly rather than first
        turning it into a UString.
        (KJS::numberProtoFuncToString): Use getJSNumber to check if the value
        is a number rather than isObject(&NumberObject::info). This works for
        immediate numbers, number cells, and NumberObject instances.
        (KJS::numberProtoFuncToLocaleString): Ditto.
        (KJS::numberProtoFuncValueOf): Ditto.
        (KJS::numberProtoFuncToFixed): Ditto.
        (KJS::numberProtoFuncToExponential): Ditto.
        (KJS::numberProtoFuncToPrecision): Ditto.
        * kjs/NumberObject.h: Added getJSNumber.

        * kjs/PropertySlot.cpp: Tweaked comment.

        * kjs/internal.cpp:
        (KJS::JSString::toThisString): Added.
        (KJS::JSString::toThisJSString): Added.
        (KJS::JSString::getOwnPropertySlot): Changed code that searches the
        prototype chain to start with the string prototype and not create a
        string object.
        (KJS::JSNumberCell::toThisString): Added.
        (KJS::JSNumberCell::getJSNumber): Added.

        * kjs/lookup.cpp:
        (KJS::staticFunctionGetter): Moved here, because there's no point in
        having a function that's only used for a function pointer be inline.
        (KJS::setUpStaticFunctionSlot): New function for getStaticFunctionSlot.

        * kjs/lookup.h:
        (KJS::staticValueGetter): Don't mark this inline. It doesn't make sense
        to have a function that's only used for a function pointer be inline.
        (KJS::getStaticFunctionSlot): Changed to get properties from the parent
        first before doing any handling of functions. This is the fastest way
        to return the function once the initial setup is done.

        * kjs/string_object.cpp:
        (KJS::StringObject::getPropertyNames): Call value() instead of getString(),
        avoiding an unnecessary virtual function call (the call to the type()
        function in the implementation of the isString() function).
        (KJS::StringObject::toString): Added.
        (KJS::StringObject::toThisString): Added.
        (KJS::StringObject::toThisJSString): Added.
        (KJS::substituteBackreferences): Rewrote to use a appending algorithm
        instead of a the old one that tried to replace in place.
        (KJS::stringProtoFuncReplace): Merged this function and the replace function.
        Replaced the hand-rolled dynamic arrays for source ranges and replacements
        with Vector.
        (KJS::stringProtoFuncToString): Handle JSString as well as StringObject.
        Removed the separate valueOf implementation, since it can just share this.
        (KJS::stringProtoFuncCharAt): Use toThisString, which handles JSString as
        well as StringObject, and is slightly more efficient than the old code too.
        (KJS::stringProtoFuncCharCodeAt): Ditto.
        (KJS::stringProtoFuncConcat): Ditto.
        (KJS::stringProtoFuncIndexOf): Ditto.
        (KJS::stringProtoFuncLastIndexOf): Ditto.
        (KJS::stringProtoFuncMatch): Ditto.
        (KJS::stringProtoFuncSearch): Ditto.
        (KJS::stringProtoFuncSlice): Ditto.
        (KJS::stringProtoFuncSplit): Ditto.
        (KJS::stringProtoFuncSubstr): Ditto.
        (KJS::stringProtoFuncSubstring): Ditto.
        (KJS::stringProtoFuncToLowerCase): Use toThisJSString.
        (KJS::stringProtoFuncToUpperCase): Ditto.
        (KJS::stringProtoFuncToLocaleLowerCase): Ditto.
        (KJS::stringProtoFuncToLocaleUpperCase): Ditto.
        (KJS::stringProtoFuncLocaleCompare): Ditto.
        (KJS::stringProtoFuncBig): Use toThisString.
        (KJS::stringProtoFuncSmall): Ditto.
        (KJS::stringProtoFuncBlink): Ditto.
        (KJS::stringProtoFuncBold): Ditto.
        (KJS::stringProtoFuncFixed): Ditto.
        (KJS::stringProtoFuncItalics): Ditto.
        (KJS::stringProtoFuncStrike): Ditto.
        (KJS::stringProtoFuncSub): Ditto.
        (KJS::stringProtoFuncSup): Ditto.
        (KJS::stringProtoFuncFontcolor): Ditto.
        (KJS::stringProtoFuncFontsize): Ditto.
        (KJS::stringProtoFuncAnchor): Ditto.
        (KJS::stringProtoFuncLink): Ditto.

        * kjs/string_object.h: Added toString, toThisString, and toThisJSString.

        * kjs/ustring.cpp:
        (KJS::UString::append): Added a version that takes a character pointer and
        size, so we don't have to create a UString just to append to another UString.
        * kjs/ustring.h:

2008-06-26  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Maciej.

        Make JSGlobalData per-thread.

        No change on SunSpider total.

        * wtf/ThreadSpecific.h: Re-enabled the actual implementation.

        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::~JSGlobalObject): Re-added a JSLock-related assertion. We'll probably
        want to preserve these somehow to keep legacy behavior in working condition.
        (KJS::JSGlobalObject::init): Initialize globalData pointer earlier, so that it is ready
        when updating JSGlobalObject linked list.

        * kjs/JSGlobalObject.h: (KJS::JSGlobalObject::head): Changed head() to be non-static, and
        to use JSGlobalData associated with the current object.

        * kjs/InitializeThreading.cpp: (KJS::initializeThreadingOnce): Removed a no longer needed
        Heap::registerAsMainThread() call.

        * kjs/JSGlobalData.h: Removed a lying lie comment - parserObjectExtraRefCounts is not
        transient, and while newParserObjects may conceptually be such, there is still some node
        manipulation going on outside Parser::parse which touches it.

        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::~JSGlobalData): Delete recently added members.
        (KJS::JSGlobalData::sharedInstance): Actually use a separate instance.

        * kjs/collector.cpp:
        (KJS::Heap::Heap):
        (KJS::Heap::~Heap): Added a destructor, which unconditionally deletes everything.
        (KJS::Heap::sweep): Removed code related to "collect on main thread only" logic.
        (KJS::Heap::collect): Ditto.
        (KJS::Heap::globalObjectCount): Explicitly use per-thread instance of JSGlobalObject linked
        list now that JSGlobalObject::head() is not static. Curently, WebCoreStatistics methods only
        work with the main thread currently anyway.
        (KJS::Heap::protectedGlobalObjectCount): Ditto.

        * kjs/collector.h: Removed code related to "collect on main thread only" logic.

        * JavaScriptCore.exp: Removed Heap::collectOnMainThreadOnly.

2008-06-26  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        https://bugs.webkit.org/show_bug.cgi?id=19767
        REGRESSION: Crash in sort() when visiting http://www.onnyturf.com/subway/

        * kjs/JSArray.cpp: (KJS::AVLTreeAbstractorForArrayCompare::set_balance_factor):
        Made changing balance factor from -1 to +1 work correctly.

        * wtf/AVLTree.h: (KJS::AVLTreeDefaultBSet::operator[]): Added an assertion that catches
        this slightly earlier.

2008-06-25  Timothy Hatcher  <timothy@apple.com>

        Fixes an ASSERT in the profiler when starting multiple profiles
        with the same name inside the same function/program.

        Reviewed by Kevin McCullough.

        * profiler/Profile.cpp:
        (KJS::Profile::Profile): Initialize m_stoppedCallDepth to zero.
        (KJS::Profile::stopProfiling): Set the current node to the parent,
        because we are in a call that will not get a didExecute call.
        (KJS::Profile::removeProfile): Increment m_stoppedCallDepth to
        account for didExecute not being called for profile.
        (KJS::Profile::willExecute): Increment m_stoppedCallDepth if stopped.
        (KJS::Profile::didExecute): Decrement m_stoppedCallDepth if stopped and
        greater than zero, and return early.
        * profiler/Profile.h: Added stoppedProfiling().
        * profiler/Profiler.cpp:
        (KJS::Profiler::findProfile): Removed.
        (KJS::Profiler::startProfiling): Don't return early for stopped profiles.
        (KJS::Profiler::stopProfiling): Skipp stopped profiles.
        (KJS::Profiler::didFinishAllExecution): Code clean-up.
        * profiler/Profiler.h: Removed findProfile.

2008-06-25  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Alexey Proskuryakov.

        Attempt to fix Windows debug build. The compiler gives a warning when
        Structured Exception Handling and destructors are used in the same
        function. Using manual locking and unlocking instead of constructors
        and destructors should fix the warning.

        * kjs/Shell.cpp:
        (main):

2008-06-25  Alexey Proskuryakov  <ap@webkit.org>

        Forgot to address a review comment about better names for tracked objects, doing it now.

        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::JSGlobalData):
        * kjs/JSGlobalData.h:
        * kjs/nodes.cpp:
        (KJS::ParserRefCounted::ParserRefCounted):
        (KJS::ParserRefCounted::ref):
        (KJS::ParserRefCounted::deref):
        (KJS::ParserRefCounted::hasOneRef):
        (KJS::ParserRefCounted::deleteNewObjects):

2008-06-25  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff.

        Remove more threadInstance() calls.

        * kjs/JSFunction.cpp:
        (KJS::JSFunction::getParameterName):
        (KJS::IndexToNameMap::unMap):
        (KJS::Arguments::deleteProperty):
        * kjs/JSFunction.h:
        Access nullIdentifier without going to thread specific storage.

        * JavaScriptCore.exp:
        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::JSGlobalData):
        * kjs/JSGlobalData.h:
        * kjs/Parser.cpp:
        (KJS::Parser::parse):
        * kjs/Parser.h:
        (KJS::ParserRefCountedData::ParserRefCountedData):
        (KJS::Parser::parse):
        * kjs/grammar.y:
        * kjs/nodes.cpp:
        (KJS::ParserRefCounted::ParserRefCounted):
        (KJS::ParserRefCounted::ref):
        (KJS::ParserRefCounted::deref):
        (KJS::ParserRefCounted::hasOneRef):
        (KJS::ParserRefCounted::deleteNewObjects):
        (KJS::Node::Node):
        (KJS::StatementNode::StatementNode):
        (KJS::BreakpointCheckStatement::BreakpointCheckStatement):
        (KJS::ConstDeclNode::ConstDeclNode):
        (KJS::BlockNode::BlockNode):
        (KJS::ForInNode::ForInNode):
        (KJS::ScopeNode::ScopeNode):
        (KJS::ProgramNode::ProgramNode):
        (KJS::ProgramNode::create):
        (KJS::EvalNode::EvalNode):
        (KJS::EvalNode::create):
        (KJS::FunctionBodyNode::FunctionBodyNode):
        (KJS::FunctionBodyNode::create):
        * kjs/nodes.h:
        (KJS::ExpressionNode::):
        (KJS::NullNode::):
        (KJS::BooleanNode::):
        (KJS::NumberNode::):
        (KJS::ImmediateNumberNode::):
        (KJS::StringNode::):
        (KJS::RegExpNode::):
        (KJS::ThisNode::):
        (KJS::ResolveNode::):
        (KJS::ElementNode::):
        (KJS::ArrayNode::):
        (KJS::PropertyNode::):
        (KJS::PropertyListNode::):
        (KJS::ObjectLiteralNode::):
        (KJS::BracketAccessorNode::):
        (KJS::DotAccessorNode::):
        (KJS::ArgumentListNode::):
        (KJS::ArgumentsNode::):
        (KJS::NewExprNode::):
        (KJS::EvalFunctionCallNode::):
        (KJS::FunctionCallValueNode::):
        (KJS::FunctionCallResolveNode::):
        (KJS::FunctionCallBracketNode::):
        (KJS::FunctionCallDotNode::):
        (KJS::PrePostResolveNode::):
        (KJS::PostIncResolveNode::):
        (KJS::PostDecResolveNode::):
        (KJS::PostfixBracketNode::):
        (KJS::PostIncBracketNode::):
        (KJS::PostDecBracketNode::):
        (KJS::PostfixDotNode::):
        (KJS::PostIncDotNode::):
        (KJS::PostDecDotNode::):
        (KJS::PostfixErrorNode::):
        (KJS::DeleteResolveNode::):
        (KJS::DeleteBracketNode::):
        (KJS::DeleteDotNode::):
        (KJS::DeleteValueNode::):
        (KJS::VoidNode::):
        (KJS::TypeOfResolveNode::):
        (KJS::TypeOfValueNode::):
        (KJS::PreIncResolveNode::):
        (KJS::PreDecResolveNode::):
        (KJS::PrefixBracketNode::):
        (KJS::PreIncBracketNode::):
        (KJS::PreDecBracketNode::):
        (KJS::PrefixDotNode::):
        (KJS::PreIncDotNode::):
        (KJS::PreDecDotNode::):
        (KJS::PrefixErrorNode::):
        (KJS::UnaryOpNode::UnaryOpNode):
        (KJS::UnaryPlusNode::):
        (KJS::NegateNode::):
        (KJS::BitwiseNotNode::):
        (KJS::LogicalNotNode::):
        (KJS::BinaryOpNode::BinaryOpNode):
        (KJS::ReverseBinaryOpNode::ReverseBinaryOpNode):
        (KJS::MultNode::):
        (KJS::DivNode::):
        (KJS::ModNode::):
        (KJS::AddNode::):
        (KJS::SubNode::):
        (KJS::LeftShiftNode::):
        (KJS::RightShiftNode::):
        (KJS::UnsignedRightShiftNode::):
        (KJS::LessNode::):
        (KJS::GreaterNode::):
        (KJS::LessEqNode::):
        (KJS::GreaterEqNode::):
        (KJS::InstanceOfNode::):
        (KJS::InNode::):
        (KJS::EqualNode::):
        (KJS::NotEqualNode::):
        (KJS::StrictEqualNode::):
        (KJS::NotStrictEqualNode::):
        (KJS::BitAndNode::):
        (KJS::BitOrNode::):
        (KJS::BitXOrNode::):
        (KJS::LogicalAndNode::):
        (KJS::LogicalOrNode::):
        (KJS::ConditionalNode::):
        (KJS::ReadModifyResolveNode::):
        (KJS::AssignResolveNode::):
        (KJS::ReadModifyBracketNode::):
        (KJS::AssignBracketNode::):
        (KJS::AssignDotNode::):
        (KJS::ReadModifyDotNode::):
        (KJS::AssignErrorNode::):
        (KJS::CommaNode::):
        (KJS::VarDeclCommaNode::):
        (KJS::ConstStatementNode::):
        (KJS::SourceElements::SourceElements):
        (KJS::EmptyStatementNode::):
        (KJS::DebuggerStatementNode::):
        (KJS::ExprStatementNode::):
        (KJS::VarStatementNode::):
        (KJS::IfNode::):
        (KJS::IfElseNode::):
        (KJS::DoWhileNode::):
        (KJS::WhileNode::):
        (KJS::ForNode::):
        (KJS::ContinueNode::):
        (KJS::BreakNode::):
        (KJS::ReturnNode::):
        (KJS::WithNode::):
        (KJS::LabelNode::):
        (KJS::ThrowNode::):
        (KJS::TryNode::):
        (KJS::ParameterNode::):
        (KJS::FuncExprNode::):
        (KJS::FuncDeclNode::):
        (KJS::CaseClauseNode::):
        (KJS::ClauseListNode::):
        (KJS::CaseBlockNode::):
        (KJS::SwitchNode::):
        Changed ParserRefCounted to hold a JSGlobalData pointer, and used it to replace
        threadInstance calls.

2008-06-24  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Alexey Proskuryakov.

        Make the JavaScript shell collect the heap from main() instead of
        jscmain() to suppress leak messages in debug builds.

        * kjs/Shell.cpp:
        (main):
        (jscmain):

2008-06-24  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Make the conversion of the pair (less, jtrue) to jless use register
        reference counting information for safety instead of requiring callers
        to decide whether it is safe.

        No changes on SunSpider codegen.

        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitJumpIfTrue):
        * VM/CodeGenerator.h:
        * kjs/nodes.cpp:
        (KJS::DoWhileNode::emitCode):
        (KJS::WhileNode::emitCode):
        (KJS::ForNode::emitCode):
        (KJS::CaseBlockNode::emitCodeForBlock):

2008-06-24  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim.

        <rdar://problem/6031594> JSProfiler: Profiler goes into an infinite
        loop sometimes.
        <rdar://problem/6031603> JSProfiler: Profiler asserts in debug and
        give the wrong times in release

        Fixed two issues found by Tim in the same test.

        * profiler/Profile.cpp:
        (KJS::Profile::removeProfileStart): No longer take profile's time from
        all ancestors, but instead attribute it to its parent.  Also add an
        Assert to ensure we only delete the child we mean to.
        (KJS::Profile::removeProfileEnd): Ditto for profileEnd.
        (KJS::Profile::didExecute): Cleaned up the execution order and correctly
        attribute all of the parent's time to the new node.
        * profiler/ProfileNode.cpp: If this node does not have a startTime it
        should not get a giant total time, but instead be 0.
        (KJS::ProfileNode::endAndRecordCall):
        * profiler/ProfileNode.h:
        (KJS::ProfileNode::removeChild): Should reset the sibling pointers since
        one of them has been removed.

2008-06-24  Darin Adler  <darin@apple.com>

        Reviewed by Cameron.

        - fix https://bugs.webkit.org/show_bug.cgi?id=19739
          REGRESSION: fast/js/property-getters-and-setters.html fails

        * kjs/JSObject.cpp:
        (KJS::JSObject::put): Remove an untested optimization I checked in by accident.
        The two loops up the prototype chain both need to start from this; instead the
        second loop was starting where the first loop left off.

2008-06-24  Steve Falkenburg  <sfalken@apple.com>

        Build fix.

        * kjs/nodes.cpp:

2008-06-24  Joerg Bornemann  <joerg.bornemann@trolltech.com>

        Reviewed by Simon.

        For the Qt build on Windows don't depend on the presence of GNU CPP
        but use MSVC's preprocessor instead.
        dftables accepts a --preprocessor option which is set in pcre.pri for MSVC platforms.

        * pcre/dftables: Added support for specifying the preprocessor command
        to use via --preprocessor, similar to
        WebCore/bindings/scripts/generate-bindings.pl.
        * pcre/pcre.pri: Pass --preprocessor='cl /e' to dftables, or more
        generally speaking QMAKE_CC /E for the win32-msvc buildspecs.

2008-06-24  Simon Hausmann  <hausmann@webkit.org>

        Fix the Qt build, added missing include.

        * kjs/PropertySlot.cpp:

2008-06-24  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Cameron Zwarich.

        Make ParserRefCountedCounter actually perform a leak check.

        * kjs/nodes.cpp:
        (KJS::ParserRefCountedCounter::~ParserRefCountedCounter): Check for leaks in destructor,
        not in constructor.
        (KJS::ParserRefCountedCounter::increment):
        (KJS::ParserRefCountedCounter::decrement):
        (KJS::ParserRefCounted::ParserRefCounted):
        (KJS::ParserRefCounted::~ParserRefCounted):
        While at it, also made counting thread-safe.

2008-06-24  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Bug 19730: REGRESSION (r34497): Text in alerts in "Leisure suit Larry" is not wrapped
        <https://bugs.webkit.org/show_bug.cgi?id=19730>

        Do not convert the pair (less, jtrue) to jless when jtrue is a jump
        target. An example of this is when the condition of a while loop is a
        LogicalOrNode.

        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitLabel):

2008-06-20  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Adam Roben.

        Fix compile with MinGW.

        * kjs/Shell.cpp:
        * wtf/Threading.h:
        (WTF::atomicIncrement):
        (WTF::atomicDecrement):

2008-06-23  Mark Rowe  <mrowe@apple.com>

        Reviewed by Oliver Hunt.

        Prepration for returning memory to the OS on Windows.  Track whether a portion of a span of memory was returned to the OS.
        If it was, ask that it be recommitted before returning it to the application as an allocated region.

        * wtf/FastMalloc.cpp:
        (WTF::TCMalloc_PageHeap::New):  If the span was decommitted, ask that it be recommitted before returning it.
        (WTF::TCMalloc_PageHeap::AllocLarge):  Ditto.
        (WTF::TCMalloc_PageHeap::Carve):  When splitting a span, ensure that the decommitted state propogates to the two new spans.
        (WTF::TCMalloc_PageHeap::Delete):  When merging a span, ensure that the resulting span is marked as decommitted if any of the
        spans being merged were marked as decommitted.
        (WTF::TCMalloc_PageHeap::IncrementalScavenge):  Mark as decommitted after releasing the span.
        (WTF::TCMalloc_Central_FreeList::FetchFromSpans): Add an assertion to catch a decommitted span being returned to the application
        without first being recommitted.
        (WTF::TCMalloc_Central_FreeList::Populate): Ditto.
        * wtf/TCSystemAlloc.cpp: Stub out TCMalloc_SystemCommit.
        * wtf/TCSystemAlloc.h:

2008-06-23  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        Remove the sample member of Span when NO_TCMALLOC_SAMPLES is defined.

        * wtf/FastMalloc.cpp:
        (WTF::TCMalloc_PageHeap::Delete): Only update Span::sample if NO_TCMALLOC_SAMPLES is not defined.
        (WTF::TCMallocStats::do_free):  Ditto.

2008-06-23  Darin Adler  <darin@apple.com>

        Reviewed by Geoff.

        - work toward https://bugs.webkit.org/show_bug.cgi?id=19721

        More preparation toward making functions work on primitive types without
        creating wrapper objects. No speedup this time, but prepares for a future
        speedup without slowing things down.

        SunSpider reports no change.

        - Eliminated the implementsCall, callAsFunction and construct virtual
          functions from JSObject. Instead, the CallData and ConstructData for
          a native function includes a function pointer that the caller can use
          directly. Changed all call sites to use CallData and ConstructData.

        - Changed the "this" argument to native functions to be a JSValue rather
          than a JSObject. This prepares us for passing primitives into these
          functions. The conversion to an object now must be done inside the
          function. Critically, if it's a function that can be called on a DOM
          window object, then we have to be sure to call toThisObject on the
          argument before we use it for anything even if it's already an object.

        - Eliminated the practice of using constructor objects in the global
          object to make objects of the various basic types. Since these
          constructors can't be replaced by script, there's no reason to involve
          a constructor object at all. Added functions to do the construction
          directly.

        - Made some more class members private and protected, including virtual
          function overrides. This can catch code using unnecessarily slow virtual
          function code paths when the type of an object is known statically. If we
          later find a new reason use the members outside the class it's easy to
          make them public again.

        - Moved the declarations of the native implementations for functions out
          of header files. These can have internal linkage and be declared inside
          the source file.

        - Changed PrototypeFunction to take function pointers with the right
          arguments to be put directly into CallData. This eliminates the
          need to have a separate PrototypeReflexiveFunction, and reveals that the
          real purpose of that class included something else specific to eval --
          storage of a cached global object. So renamed PrototypeReflexiveFunction
          to GlobalEvalFunction.

        * API/JSCallbackConstructor.cpp:
        (KJS::constructJSCallback):
        (KJS::JSCallbackConstructor::getConstructData):
        * API/JSCallbackConstructor.h:
        * API/JSCallbackFunction.cpp:
        (KJS::JSCallbackFunction::implementsHasInstance):
        (KJS::JSCallbackFunction::call):
        (KJS::JSCallbackFunction::getCallData):
        * API/JSCallbackFunction.h:
        (KJS::JSCallbackFunction::classInfo):
        * API/JSCallbackObject.h:
        (KJS::JSCallbackObject::classRef):
        (KJS::JSCallbackObject::classInfo):
        * API/JSCallbackObjectFunctions.h:
        (KJS::::getConstructData):
        (KJS::::construct):
        (KJS::::getCallData):
        (KJS::::call):
        * API/JSObjectRef.cpp:
        (JSObjectMakeFunction):
        (JSObjectIsFunction):
        (JSObjectCallAsFunction):
        (JSObjectCallAsConstructor):
        * JavaScriptCore.exp:
        * VM/Machine.cpp:
        (KJS::jsTypeStringForValue):
        (KJS::Machine::privateExecute):
        * kjs/ArrayPrototype.cpp:
        (KJS::arrayProtoFuncToString):
        (KJS::arrayProtoFuncToLocaleString):
        (KJS::arrayProtoFuncJoin):
        (KJS::arrayProtoFuncConcat):
        (KJS::arrayProtoFuncPop):
        (KJS::arrayProtoFuncPush):
        (KJS::arrayProtoFuncReverse):
        (KJS::arrayProtoFuncShift):
        (KJS::arrayProtoFuncSlice):
        (KJS::arrayProtoFuncSort):
        (KJS::arrayProtoFuncSplice):
        (KJS::arrayProtoFuncUnShift):
        (KJS::arrayProtoFuncFilter):
        (KJS::arrayProtoFuncMap):
        (KJS::arrayProtoFuncEvery):
        (KJS::arrayProtoFuncForEach):
        (KJS::arrayProtoFuncSome):
        (KJS::arrayProtoFuncIndexOf):
        (KJS::arrayProtoFuncLastIndexOf):
        (KJS::ArrayConstructor::ArrayConstructor):
        (KJS::constructArrayWithSizeQuirk):
        (KJS::constructWithArrayConstructor):
        (KJS::ArrayConstructor::getConstructData):
        (KJS::callArrayConstructor):
        (KJS::ArrayConstructor::getCallData):
        * kjs/ArrayPrototype.h:
        * kjs/BooleanObject.cpp:
        (KJS::booleanProtoFuncToString):
        (KJS::booleanProtoFuncValueOf):
        (KJS::constructBoolean):
        (KJS::constructWithBooleanConstructor):
        (KJS::BooleanConstructor::getConstructData):
        (KJS::callBooleanConstructor):
        (KJS::BooleanConstructor::getCallData):
        (KJS::constructBooleanFromImmediateBoolean):
        * kjs/BooleanObject.h:
        * kjs/CallData.h:
        (KJS::):
        * kjs/ConstructData.h:
        (KJS::):
        * kjs/FunctionPrototype.cpp:
        (KJS::callFunctionPrototype):
        (KJS::FunctionPrototype::getCallData):
        (KJS::functionProtoFuncToString):
        (KJS::functionProtoFuncApply):
        (KJS::functionProtoFuncCall):
        (KJS::constructWithFunctionConstructor):
        (KJS::FunctionConstructor::getConstructData):
        (KJS::callFunctionConstructor):
        (KJS::FunctionConstructor::getCallData):
        (KJS::constructFunction):
        * kjs/FunctionPrototype.h:
        * kjs/JSArray.cpp:
        (KJS::AVLTreeAbstractorForArrayCompare::compare_key_key):
        (KJS::JSArray::sort):
        (KJS::constructEmptyArray):
        (KJS::constructArray):
        * kjs/JSArray.h:
        (KJS::JSArray::classInfo):
        * kjs/JSFunction.cpp:
        (KJS::JSFunction::call):
        (KJS::globalFuncEval):
        (KJS::globalFuncParseInt):
        (KJS::globalFuncParseFloat):
        (KJS::globalFuncIsNaN):
        (KJS::globalFuncIsFinite):
        (KJS::globalFuncDecodeURI):
        (KJS::globalFuncDecodeURIComponent):
        (KJS::globalFuncEncodeURI):
        (KJS::globalFuncEncodeURIComponent):
        (KJS::globalFuncEscape):
        (KJS::globalFuncUnescape):
        (KJS::globalFuncKJSPrint):
        (KJS::PrototypeFunction::PrototypeFunction):
        (KJS::PrototypeFunction::getCallData):
        (KJS::GlobalEvalFunction::GlobalEvalFunction):
        (KJS::GlobalEvalFunction::mark):
        * kjs/JSFunction.h:
        (KJS::InternalFunction::classInfo):
        (KJS::InternalFunction::functionName):
        (KJS::JSFunction::classInfo):
        (KJS::GlobalEvalFunction::cachedGlobalObject):
        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::reset):
        (KJS::JSGlobalObject::mark):
        * kjs/JSGlobalObject.h:
        (KJS::JSGlobalObject::JSGlobalObject):
        (KJS::JSGlobalObject::evalFunction):
        * kjs/JSImmediate.cpp:
        (KJS::JSImmediate::toObject):
        * kjs/JSNotAnObject.cpp:
        * kjs/JSNotAnObject.h:
        * kjs/JSObject.cpp:
        (KJS::JSObject::put):
        (KJS::callDefaultValueFunction):
        (KJS::JSObject::defaultValue):
        (KJS::JSObject::lookupGetter):
        (KJS::JSObject::lookupSetter):
        (KJS::JSObject::hasInstance):
        (KJS::JSObject::fillGetterPropertySlot):
        (KJS::Error::create):
        (KJS::constructEmptyObject):
        * kjs/JSObject.h:
        (KJS::GetterSetter::GetterSetter):
        (KJS::GetterSetter::getter):
        (KJS::GetterSetter::setGetter):
        (KJS::GetterSetter::setter):
        (KJS::GetterSetter::setSetter):
        * kjs/JSValue.cpp:
        (KJS::JSCell::deleteProperty):
        (KJS::call):
        (KJS::construct):
        * kjs/JSValue.h:
        * kjs/MathObject.cpp:
        (KJS::mathProtoFuncAbs):
        (KJS::mathProtoFuncACos):
        (KJS::mathProtoFuncASin):
        (KJS::mathProtoFuncATan):
        (KJS::mathProtoFuncATan2):
        (KJS::mathProtoFuncCeil):
        (KJS::mathProtoFuncCos):
        (KJS::mathProtoFuncExp):
        (KJS::mathProtoFuncFloor):
        (KJS::mathProtoFuncLog):
        (KJS::mathProtoFuncMax):
        (KJS::mathProtoFuncMin):
        (KJS::mathProtoFuncPow):
        (KJS::mathProtoFuncRandom):
        (KJS::mathProtoFuncRound):
        (KJS::mathProtoFuncSin):
        (KJS::mathProtoFuncSqrt):
        (KJS::mathProtoFuncTan):
        * kjs/MathObject.h:
        * kjs/NumberObject.cpp:
        (KJS::numberProtoFuncToString):
        (KJS::numberProtoFuncToLocaleString):
        (KJS::numberProtoFuncValueOf):
        (KJS::numberProtoFuncToFixed):
        (KJS::numberProtoFuncToExponential):
        (KJS::numberProtoFuncToPrecision):
        (KJS::NumberConstructor::NumberConstructor):
        (KJS::constructWithNumberConstructor):
        (KJS::NumberConstructor::getConstructData):
        (KJS::callNumberConstructor):
        (KJS::NumberConstructor::getCallData):
        (KJS::constructNumber):
        (KJS::constructNumberFromImmediateNumber):
        * kjs/NumberObject.h:
        (KJS::NumberObject::classInfo):
        (KJS::NumberConstructor::classInfo):
        * kjs/PropertySlot.cpp:
        (KJS::PropertySlot::functionGetter):
        * kjs/RegExpObject.cpp:
        (KJS::regExpProtoFuncTest):
        (KJS::regExpProtoFuncExec):
        (KJS::regExpProtoFuncCompile):
        (KJS::regExpProtoFuncToString):
        (KJS::callRegExpObject):
        (KJS::RegExpObject::getCallData):
        (KJS::constructRegExp):
        (KJS::constructWithRegExpConstructor):
        (KJS::RegExpConstructor::getConstructData):
        (KJS::callRegExpConstructor):
        (KJS::RegExpConstructor::getCallData):
        * kjs/RegExpObject.h:
        (KJS::RegExpConstructor::classInfo):
        * kjs/Shell.cpp:
        (GlobalObject::GlobalObject):
        (functionPrint):
        (functionDebug):
        (functionGC):
        (functionVersion):
        (functionRun):
        (functionLoad):
        (functionReadline):
        (functionQuit):
        * kjs/date_object.cpp:
        (KJS::gmtoffset):
        (KJS::formatLocaleDate):
        (KJS::fillStructuresUsingDateArgs):
        (KJS::DateInstance::getTime):
        (KJS::DateInstance::getUTCTime):
        (KJS::DateConstructor::DateConstructor):
        (KJS::constructDate):
        (KJS::DateConstructor::getConstructData):
        (KJS::callDate):
        (KJS::DateConstructor::getCallData):
        (KJS::dateParse):
        (KJS::dateNow):
        (KJS::dateUTC):
        (KJS::dateProtoFuncToString):
        (KJS::dateProtoFuncToUTCString):
        (KJS::dateProtoFuncToDateString):
        (KJS::dateProtoFuncToTimeString):
        (KJS::dateProtoFuncToLocaleString):
        (KJS::dateProtoFuncToLocaleDateString):
        (KJS::dateProtoFuncToLocaleTimeString):
        (KJS::dateProtoFuncValueOf):
        (KJS::dateProtoFuncGetTime):
        (KJS::dateProtoFuncGetFullYear):
        (KJS::dateProtoFuncGetUTCFullYear):
        (KJS::dateProtoFuncToGMTString):
        (KJS::dateProtoFuncGetMonth):
        (KJS::dateProtoFuncGetUTCMonth):
        (KJS::dateProtoFuncGetDate):
        (KJS::dateProtoFuncGetUTCDate):
        (KJS::dateProtoFuncGetDay):
        (KJS::dateProtoFuncGetUTCDay):
        (KJS::dateProtoFuncGetHours):
        (KJS::dateProtoFuncGetUTCHours):
        (KJS::dateProtoFuncGetMinutes):
        (KJS::dateProtoFuncGetUTCMinutes):
        (KJS::dateProtoFuncGetSeconds):
        (KJS::dateProtoFuncGetUTCSeconds):
        (KJS::dateProtoFuncGetMilliSeconds):
        (KJS::dateProtoFuncGetUTCMilliseconds):
        (KJS::dateProtoFuncGetTimezoneOffset):
        (KJS::dateProtoFuncSetTime):
        (KJS::setNewValueFromTimeArgs):
        (KJS::setNewValueFromDateArgs):
        (KJS::dateProtoFuncSetMilliSeconds):
        (KJS::dateProtoFuncSetUTCMilliseconds):
        (KJS::dateProtoFuncSetSeconds):
        (KJS::dateProtoFuncSetUTCSeconds):
        (KJS::dateProtoFuncSetMinutes):
        (KJS::dateProtoFuncSetUTCMinutes):
        (KJS::dateProtoFuncSetHours):
        (KJS::dateProtoFuncSetUTCHours):
        (KJS::dateProtoFuncSetDate):
        (KJS::dateProtoFuncSetUTCDate):
        (KJS::dateProtoFuncSetMonth):
        (KJS::dateProtoFuncSetUTCMonth):
        (KJS::dateProtoFuncSetFullYear):
        (KJS::dateProtoFuncSetUTCFullYear):
        (KJS::dateProtoFuncSetYear):
        (KJS::dateProtoFuncGetYear):
        * kjs/date_object.h:
        (KJS::DateInstance::internalNumber):
        (KJS::DateInstance::classInfo):
        * kjs/error_object.cpp:
        (KJS::errorProtoFuncToString):
        (KJS::constructError):
        (KJS::constructWithErrorConstructor):
        (KJS::ErrorConstructor::getConstructData):
        (KJS::callErrorConstructor):
        (KJS::ErrorConstructor::getCallData):
        (KJS::NativeErrorConstructor::construct):
        (KJS::constructWithNativeErrorConstructor):
        (KJS::NativeErrorConstructor::getConstructData):
        (KJS::callNativeErrorConstructor):
        (KJS::NativeErrorConstructor::getCallData):
        * kjs/error_object.h:
        (KJS::NativeErrorConstructor::classInfo):
        * kjs/internal.cpp:
        (KJS::JSNumberCell::toObject):
        (KJS::JSNumberCell::toThisObject):
        (KJS::GetterSetter::mark):
        (KJS::GetterSetter::toPrimitive):
        (KJS::GetterSetter::toBoolean):
        (KJS::GetterSetter::toNumber):
        (KJS::GetterSetter::toString):
        (KJS::GetterSetter::toObject):
        (KJS::InternalFunction::InternalFunction):
        (KJS::InternalFunction::implementsHasInstance):
        * kjs/lookup.h:
        (KJS::HashEntry::):
        * kjs/nodes.cpp:
        (KJS::FuncDeclNode::makeFunction):
        (KJS::FuncExprNode::makeFunction):
        * kjs/object_object.cpp:
        (KJS::objectProtoFuncValueOf):
        (KJS::objectProtoFuncHasOwnProperty):
        (KJS::objectProtoFuncIsPrototypeOf):
        (KJS::objectProtoFuncDefineGetter):
        (KJS::objectProtoFuncDefineSetter):
        (KJS::objectProtoFuncLookupGetter):
        (KJS::objectProtoFuncLookupSetter):
        (KJS::objectProtoFuncPropertyIsEnumerable):
        (KJS::objectProtoFuncToLocaleString):
        (KJS::objectProtoFuncToString):
        (KJS::ObjectConstructor::ObjectConstructor):
        (KJS::constructObject):
        (KJS::constructWithObjectConstructor):
        (KJS::ObjectConstructor::getConstructData):
        (KJS::callObjectConstructor):
        (KJS::ObjectConstructor::getCallData):
        * kjs/object_object.h:
        * kjs/string_object.cpp:
        (KJS::replace):
        (KJS::stringProtoFuncToString):
        (KJS::stringProtoFuncValueOf):
        (KJS::stringProtoFuncCharAt):
        (KJS::stringProtoFuncCharCodeAt):
        (KJS::stringProtoFuncConcat):
        (KJS::stringProtoFuncIndexOf):
        (KJS::stringProtoFuncLastIndexOf):
        (KJS::stringProtoFuncMatch):
        (KJS::stringProtoFuncSearch):
        (KJS::stringProtoFuncReplace):
        (KJS::stringProtoFuncSlice):
        (KJS::stringProtoFuncSplit):
        (KJS::stringProtoFuncSubstr):
        (KJS::stringProtoFuncSubstring):
        (KJS::stringProtoFuncToLowerCase):
        (KJS::stringProtoFuncToUpperCase):
        (KJS::stringProtoFuncToLocaleLowerCase):
        (KJS::stringProtoFuncToLocaleUpperCase):
        (KJS::stringProtoFuncLocaleCompare):
        (KJS::stringProtoFuncBig):
        (KJS::stringProtoFuncSmall):
        (KJS::stringProtoFuncBlink):
        (KJS::stringProtoFuncBold):
        (KJS::stringProtoFuncFixed):
        (KJS::stringProtoFuncItalics):
        (KJS::stringProtoFuncStrike):
        (KJS::stringProtoFuncSub):
        (KJS::stringProtoFuncSup):
        (KJS::stringProtoFuncFontcolor):
        (KJS::stringProtoFuncFontsize):
        (KJS::stringProtoFuncAnchor):
        (KJS::stringProtoFuncLink):
        (KJS::stringFromCharCode):
        (KJS::StringConstructor::StringConstructor):
        (KJS::constructWithStringConstructor):
        (KJS::StringConstructor::getConstructData):
        (KJS::callStringConstructor):
        (KJS::StringConstructor::getCallData):
        * kjs/string_object.h:

2008-06-23  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Bug 19716: REGRESSION (SquirrelFish): Reproducible crash after entering a username at mint.com
        <https://bugs.webkit.org/show_bug.cgi?id=19716>

        When unwinding callframes for exceptions, check whether the callframe
        was created by a reentrant native call to JavaScript after tearing off
        the local variables instead of before.

        * VM/Machine.cpp:
        (KJS::Machine::unwindCallFrame):

2008-06-23  Mark Rowe  <mrowe@apple.com>

        Reviewed by Oliver Hunt.

        Get testapi passing again in a debug build.

        * API/testapi.c:
        (main): Update the expected output of calling JSValueMakeString on a function object.

2008-06-21  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        Print a blank line when exiting the jsc interactive mode to ensure that the shell
        prompt will start on a new line.

        * kjs/Shell.cpp:
        (runInteractive):

2008-06-21  Mark Rowe  <mrowe@apple.com>

        Rubber-stamped by Sam Weinig.

        Tweak the paths of the items in the "tests" group to clean things up a little.

        * JavaScriptCore.xcodeproj/project.pbxproj:

2008-06-21  Mark Rowe  <mrowe@apple.com>

        Rubber-stamped by Sam Weinig.

        Fix jsc to link against libedit.dylib rather than libedit.2.dylib.

        * JavaScriptCore.xcodeproj/project.pbxproj:

2008-06-21  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        Copy the JavaScriptCore shell (jsc) into JavaScriptCore.framework so that it will
        be included in nightly builds.
        https://bugs.webkit.org/show_bug.cgi?id=19691

        * JavaScriptCore.xcodeproj/project.pbxproj:

2008-06-21  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Mark Rowe.

        Fix the build for non-Mac Darwin platforms by disabling their support
        for readline in the JavaScript shell.

        * kjs/config.h:

2008-06-20  Timothy Hatcher  <timothy@apple.com>

        Use member function pointers for the Profile::forEach function.
        Eliminating a few static functions and simplified things a little.

        Reviewed by Alexey Proskuryakov.

        * JavaScriptCore.exp: Change the symbol for forEach.
        * profiler/Profile.cpp:
        (KJS::Profile::forEach): Use a member function pointer.
        * profiler/Profile.h:
        (KJS::Profile::sortTotalTimeDescending): Pass a function pointer.
        (KJS::Profile::sortTotalTimeAscending): Ditto.
        (KJS::Profile::sortSelfTimeDescending): Ditto.
        (KJS::Profile::sortSelfTimeAscending): Ditto.
        (KJS::Profile::sortCallsDescending): Ditto.
        * profiler/ProfileNode.h:
        (KJS::ProfileNode::sortTotalTimeDescending): No longer static.
        (KJS::ProfileNode::sortTotalTimeAscending): Ditto.
        (KJS::ProfileNode::sortSelfTimeDescending): Ditto.
        (KJS::ProfileNode::sortSelfTimeAscending): Ditto.
        (KJS::ProfileNode::sortCallsDescending): Ditto.

2008-06-20  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Remove unused destructors.

        * kjs/nodes.cpp:
        * kjs/nodes.h:

2008-06-20  Timothy Hatcher  <timothy@apple.com>

        Fixed an ASSERT(m_actualSelfTime <= m_actualTotalTime) when starting
        and stopping a profile from the Develop menu. Also prevents
        inserting an incorrect parent node as the new head after profiling
        is stopped from the Develop menu.

        Reviewed by Dan Bernstein.

        * profiler/Profile.cpp:
        (KJS::Profile::stopProfiling): If the current node is already the head
        then there is no more need to record future nodes in didExecute.
        (KJS::Profile::didExecute): Move the code of setupCurrentNodeAsStopped
        into here since this was the only caller. When setting the total time
        keep any current total time while adding the self time of the head.
        (KJS::Profile::setupCurrentNodeAsStopped): Removed.
        * profiler/Profile.h: Removed setupCurrentNodeAsStopped.

2008-06-20  Kevin Ollivier  <kevino@theolliviers.com>

        !USE(MULTIPLE_THREADS) on Darwin build fix

        * kjs/InitializeThreading.cpp:
        (KJS::initializeThreading):
        * kjs/collector.h:

2008-06-20  Kevin McCullough  <kmccullough@apple.com>

        -Leopard Build Fix.

        * profiler/Profile.cpp:
        (KJS::Profile::removeProfileStart):
        (KJS::Profile::removeProfileEnd):

2008-06-20  Kevin McCullough  <kmccullough@apple.com>

        Just giving credit.

        * ChangeLog:

2008-06-20  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim and Dan.

        <rdar://problem/6024846> JSProfiler: ASSERT hit in Profiler.
        - Because InspectorController can call startProfiling() and
        stopProfiling() we cannot assert that console.profile() and
        console.profileEnd() will be in the profile tree.

        * profiler/Profile.cpp:
        (KJS::Profile::removeProfileStart):
        (KJS::Profile::removeProfileEnd):

2008-06-20  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim.

        <rdar://problem/5958770> JSProfiler: Time incorrectly given to (idle)
        if profiling is started and finished within the same function. (19230)
        - Now we profile one more stack frame up from the last frame to allocate
        the time spent in it, if it exists.

        * JavaScriptCore.exp:
        * VM/Machine.cpp: We need to let the profiler know when the JS program 
        has finished since that is what will actually stop the profiler instead
        of just calling stopProfiling().
        (KJS::Machine::execute):
        * profiler/Profile.cpp:
        (KJS::Profile::create): Moved from Profile.h since it was getting pretty
        long.
        (KJS::Profile::Profile): We now have a client, which is a listener who
        we will return this profile to, once it has actually finished.
        (KJS::Profile::stopProfiling): Instead of fully stopping the profiler
        here, we set the flag and keep it profiling in the background.
        (KJS::Profile::didFinishAllExecution): This is where the profiler
        actually finishes and creates the (idle) node if one should be made.
        (KJS::Profile::removeProfileStart): Don't use m_currentNode since it is
        needed by the profiler as it runs silently in the background.
        (KJS::Profile::removeProfileEnd): Ditto.
        (KJS::Profile::willExecute): Don't profile new functions if we have
        stopped profiling.
        (KJS::Profile::didExecute): Only record one more return as all the
        remaining time will be attributed to that function.
        (KJS::Profile::setupCurrentNodeAsStopped): Sets the current node's time.
        * profiler/Profile.h: Added functions and variables for the above
        changes.
        (KJS::Profile::client):
        * profiler/ProfileNode.h:
        (KJS::CallIdentifier::toString): Debug method.
        * profiler/Profiler.cpp: Added support for the ProfilerClient.
        (KJS::Profiler::startProfiling):
        (KJS::Profiler::stopProfiling): No longer return sthe profile.
        (KJS::Profiler::didFinishAllExecution): Now returns the profile to the
        client instead of stopProfiling.
        * profiler/Profiler.h:
        (KJS::ProfilerClient::~ProfilerClient): Clients will implement this
        interface.

2008-06-19  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Simon.

        Surpress compiler warning (int vs unsigned comparison).

        * wtf/unicode/qt4/UnicodeQt4.h:
        (WTF::Unicode::toLower):

2008-06-19  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Timothy Hatcher.

        Introduce compiler define for MinGW, to have COMPILER(MINGW).

        * wtf/Platform.h:

2008-06-19  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff.

        Make Machine per-JSGlobalData.

        * VM/CodeBlock.cpp:
        (KJS::CodeBlock::dump):
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitOpcode):
        * VM/Machine.cpp:
        (KJS::callEval):
        (KJS::Machine::unwindCallFrame):
        (KJS::Machine::throwException):
        (KJS::Machine::execute):
        (KJS::Machine::debug):
        * VM/Machine.h:
        * kjs/DebuggerCallFrame.cpp:
        (KJS::DebuggerCallFrame::evaluate):
        * kjs/DebuggerCallFrame.h:
        (KJS::DebuggerCallFrame::DebuggerCallFrame):
        * kjs/ExecState.cpp:
        (KJS::ExecState::ExecState):
        * kjs/ExecState.h:
        (KJS::ExecState::machine):
        * kjs/JSFunction.cpp:
        (KJS::JSFunction::callAsFunction):
        (KJS::JSFunction::argumentsGetter):
        (KJS::JSFunction::callerGetter):
        (KJS::JSFunction::construct):
        (KJS::globalFuncEval):
        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::JSGlobalData):
        * kjs/JSGlobalData.h:
        * kjs/interpreter.cpp:
        (KJS::Interpreter::evaluate):

2008-06-19  Alp Toker  <alp@nuanti.com>

        GTK+/autotools build fix. JSGlobalObject.cpp in now in
        AllInOneFile.cpp and shouldn't be built separately.

        * GNUmakefile.am:

2008-06-19  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        Get rid of some threadInstance calls.

        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::init):
        * kjs/Parser.cpp:
        (KJS::Parser::parse):
        * kjs/Shell.cpp:
        (jscmain):

2008-06-19  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Sam.

        Fix an assertion failure at startup.

        * kjs/JSObject.h: (KJS::JSObject::JSObject): Allow jsNull prototype in an assertion (I had
        it fixed in a wrong copy of the file, so I wasn't getting the failure).

2008-06-19  Alexey Proskuryakov  <ap@webkit.org>

        Build fix.

        * kjs/collector.cpp:
        (KJS::Heap::Heap):
        (KJS::allocateBlock):
        * kjs/collector.h:
        No, #if PLATFORM(UNIX) was not right. I've just moved the unsafe initialization back for now,
        as the platforms that use that code path do not use multiple threads yet.

2008-06-19  Alexey Proskuryakov  <ap@webkit.org>

        Windows and Qt build fixes.

        * kjs/collector.h: 
        * kjs/collector.cpp:
        (KJS::Heap::Heap):
        Wrapped m_pagesize in #if PLATFORM(UNIX), which should better match the sequence of #elifs
        in allocateBlock(). Changed MIN_ARRAY_SIZE to be explicitly size_t, as this type is different
        on different platforms.

2008-06-17  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        Prepare JavaScript heap for being per-thread.

        * kjs/ExecState.h: Shuffle includes, making it possible to include ExecState.h in JSValue.h.
        (KJS::ExecState::heap): Added an accessor.

        * API/JSBase.cpp: (JSGarbageCollect): Collect both shared and per-thread heaps.

        * API/JSContextRef.cpp: (JSGlobalContextCreate): When allocating JSGlobalObject, indicate
        that it belongs to a shared heap.

        * JavaScriptCore.xcodeproj/project.pbxproj:
        * kjs/AllInOneFile.cpp:
        Moved JSGlobalObject.cpp to AllInOneFile, as a build fix for inlineAllocate magic.

        * VM/CodeGenerator.h: (KJS::CodeGenerator::globalExec): Added an accessor (working via
        m_scopeChain).

        * VM/RegisterFile.h:
        (KJS::RegisterFile::mark):
        * VM/RegisterFileStack.h:
        (KJS::RegisterFileStack::mark):
        Made these pseudo-mark functions take Heap*.

        * kjs/InitializeThreading.cpp:
        (KJS::initializeThreading): Initialize heap introspector.

        * kjs/JSGlobalData.h: Added Heap to the structure.

        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::JSGlobalData): Initialize Heap.
        (KJS::JSGlobalData::sharedInstance): Added a method to access shared global data instance
        for legacy clients.

        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::~JSGlobalObject): Changed to work with per-thread head; fixed list
        maintenance logic.
        (KJS::JSGlobalObject::init): Changed to work with per-thread head.
        (KJS::JSGlobalObject::put): Assert that a cross-heap operation is not being attempted.
        (KJS::JSGlobalObject::reset): Pass ExecState* where now required.
        (KJS::JSGlobalObject::mark): Pass the current heap to RegisterFileStack::mark.
        (KJS::JSGlobalObject::operator new): Overload operator new to use per-thread or shared heap.
        * kjs/JSGlobalObject.h: Removed static s_head member.

        * kjs/PropertyMap.h: (KJS::PropertyMap::PropertyMap): Removed unused SavedProperty.

        * kjs/collector.h: Turned Collector into an actual object with its own data, renamed to Heap.
        (KJS::Heap::initializeHeapIntrospector): Added.
        (KJS::Heap::heap): Added a method to determine which heap a JSValue is in, if any.
        (KJS::Heap::allocate): Made non-static.
        (KJS::Heap::inlineAllocateNumber): Ditto.
        (KJS::Heap::markListSet): Ditto.
        (KJS::Heap::cellBlock): Ditto.
        (KJS::Heap::cellOffset): Ditto.
        (KJS::Heap::isCellMarked): Ditto.
        (KJS::Heap::markCell): Ditto.
        (KJS::Heap::reportExtraMemoryCost): Ditto.
        (KJS::CollectorBlock): Added a back-reference to Heap for Heap::heap() method.
        (KJS::SmallCellCollectorBlock): Ditto.

        * kjs/collector.cpp: Changed MIN_ARRAY_SIZE to a #define to avoid a PIC branch. Removed
        main thread related machinery.
        (KJS::Heap::Heap): Initialize the newly added data members.
        (KJS::allocateBlock): Marked NEVER_INLINE, as this is a rare case that uses a PIC branch.
        Moved static pagesize to the class to make it safely initialized.
        (KJS::Heap::heapAllocate): Initialize heap back reference after a new block is allocated.
        (KJS::Heap::registerThread): Removed introspector initialization, as it is now performed
        in InitializeThreading.cpp.
        (KJS::Heap::markOtherThreadConservatively): Assert that the "other thread" case only occurs
        for legacy clients using a shared heap.
        (KJS::Heap::markStackObjectsConservatively): Moved fastMallocForbid/Allow down here, since
        it doesn't need to be forbidden during other GC phases.

        * kjs/JSImmediate.h:
        (KJS::jsUndefined):
        (KJS::jsNull):
        (KJS::jsBoolean):
        Moved from JSvalue.h, to make these usable in files that cannot include JSValue.h (such
        as list.h).

        * API/JSCallbackObjectFunctions.h:
        (KJS::::staticFunctionGetter):
        * API/JSClassRef.cpp:
        (OpaqueJSClass::prototype):
        * API/JSObjectRef.cpp:
        (JSObjectMake):
        (JSObjectMakeFunctionWithCallback):
        (JSObjectMakeConstructor):
        (JSObjectMakeFunction):
        * API/JSValueRef.cpp:
        (JSValueMakeNumber):
        (JSValueMakeString):
        * JavaScriptCore.exp:
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitLoad):
        * VM/JSPropertyNameIterator.cpp:
        (KJS::JSPropertyNameIterator::create):
        (KJS::JSPropertyNameIterator::next):
        * VM/Machine.cpp:
        (KJS::jsAddSlowCase):
        (KJS::jsAdd):
        (KJS::jsTypeStringForValue):
        (KJS::scopeChainForCall):
        (KJS::Machine::throwException):
        (KJS::Machine::execute):
        (KJS::Machine::privateExecute):
        (KJS::Machine::retrieveArguments):
        * kjs/ArrayPrototype.cpp:
        (KJS::arrayProtoFuncToString):
        (KJS::arrayProtoFuncToLocaleString):
        (KJS::arrayProtoFuncJoin):
        (KJS::arrayProtoFuncConcat):
        (KJS::arrayProtoFuncPop):
        (KJS::arrayProtoFuncPush):
        (KJS::arrayProtoFuncShift):
        (KJS::arrayProtoFuncSlice):
        (KJS::arrayProtoFuncSplice):
        (KJS::arrayProtoFuncUnShift):
        (KJS::arrayProtoFuncFilter):
        (KJS::arrayProtoFuncMap):
        (KJS::arrayProtoFuncEvery):
        (KJS::arrayProtoFuncForEach):
        (KJS::arrayProtoFuncSome):
        (KJS::arrayProtoFuncIndexOf):
        (KJS::arrayProtoFuncLastIndexOf):
        (KJS::ArrayConstructor::ArrayConstructor):
        (KJS::ArrayConstructor::construct):
        (KJS::ArrayConstructor::callAsFunction):
        * kjs/BooleanObject.cpp:
        (KJS::BooleanPrototype::BooleanPrototype):
        (KJS::booleanProtoFuncToString):
        (KJS::BooleanConstructor::BooleanConstructor):
        (KJS::BooleanConstructor::construct):
        * kjs/FunctionPrototype.cpp:
        (KJS::FunctionPrototype::FunctionPrototype):
        (KJS::functionProtoFuncToString):
        (KJS::FunctionConstructor::FunctionConstructor):
        (KJS::FunctionConstructor::construct):
        * kjs/JSActivation.cpp:
        (KJS::JSActivation::createArgumentsObject):
        * kjs/JSArray.cpp:
        (KJS::JSArray::JSArray):
        (KJS::JSArray::lengthGetter):
        * kjs/JSFunction.cpp:
        (KJS::JSFunction::lengthGetter):
        (KJS::JSFunction::construct):
        (KJS::Arguments::Arguments):
        (KJS::encode):
        (KJS::decode):
        (KJS::globalFuncParseInt):
        (KJS::globalFuncParseFloat):
        (KJS::globalFuncEscape):
        (KJS::globalFuncUnescape):
        (KJS::PrototypeFunction::PrototypeFunction):
        (KJS::PrototypeReflexiveFunction::PrototypeReflexiveFunction):
        * kjs/JSImmediate.cpp:
        (KJS::JSImmediate::toObject):
        * kjs/JSLock.cpp:
        (KJS::JSLock::registerThread):
        * kjs/JSObject.cpp:
        (KJS::JSObject::put):
        (KJS::JSObject::defineGetter):
        (KJS::JSObject::defineSetter):
        (KJS::Error::create):
        * kjs/JSObject.h:
        (KJS::JSObject::putDirect):
        * kjs/JSString.h:
        (KJS::JSString::JSString):
        * kjs/JSValue.cpp:
        (KJS::JSCell::operator new):
        (KJS::jsString):
        (KJS::jsOwnedString):
        * kjs/JSValue.h:
        (KJS::JSNumberCell::operator new):
        (KJS::jsNumberCell):
        (KJS::jsNaN):
        (KJS::jsNumber):
        (KJS::JSCell::marked):
        (KJS::JSCell::mark):
        (KJS::JSValue::toJSNumber):
        * kjs/MathObject.cpp:
        (KJS::MathObject::getValueProperty):
        (KJS::mathProtoFuncAbs):
        (KJS::mathProtoFuncACos):
        (KJS::mathProtoFuncASin):
        (KJS::mathProtoFuncATan):
        (KJS::mathProtoFuncATan2):
        (KJS::mathProtoFuncCeil):
        (KJS::mathProtoFuncCos):
        (KJS::mathProtoFuncExp):
        (KJS::mathProtoFuncFloor):
        (KJS::mathProtoFuncLog):
        (KJS::mathProtoFuncMax):
        (KJS::mathProtoFuncMin):
        (KJS::mathProtoFuncPow):
        (KJS::mathProtoFuncRandom):
        (KJS::mathProtoFuncRound):
        (KJS::mathProtoFuncSin):
        (KJS::mathProtoFuncSqrt):
        (KJS::mathProtoFuncTan):
        * kjs/NumberObject.cpp:
        (KJS::NumberPrototype::NumberPrototype):
        (KJS::numberProtoFuncToString):
        (KJS::numberProtoFuncToLocaleString):
        (KJS::numberProtoFuncToFixed):
        (KJS::numberProtoFuncToExponential):
        (KJS::numberProtoFuncToPrecision):
        (KJS::NumberConstructor::NumberConstructor):
        (KJS::NumberConstructor::getValueProperty):
        (KJS::NumberConstructor::construct):
        (KJS::NumberConstructor::callAsFunction):
        * kjs/RegExpObject.cpp:
        (KJS::RegExpPrototype::RegExpPrototype):
        (KJS::regExpProtoFuncToString):
        (KJS::RegExpObject::getValueProperty):
        (KJS::RegExpConstructor::RegExpConstructor):
        (KJS::RegExpMatchesArray::fillArrayInstance):
        (KJS::RegExpConstructor::arrayOfMatches):
        (KJS::RegExpConstructor::getBackref):
        (KJS::RegExpConstructor::getLastParen):
        (KJS::RegExpConstructor::getLeftContext):
        (KJS::RegExpConstructor::getRightContext):
        (KJS::RegExpConstructor::getValueProperty):
        (KJS::RegExpConstructor::construct):
        * kjs/RegExpObject.h:
        * kjs/Shell.cpp:
        (GlobalObject::GlobalObject):
        (functionGC):
        (functionRun):
        (functionReadline):
        (jscmain):
        * kjs/date_object.cpp:
        (KJS::formatLocaleDate):
        (KJS::DatePrototype::DatePrototype):
        (KJS::DateConstructor::DateConstructor):
        (KJS::DateConstructor::construct):
        (KJS::DateConstructor::callAsFunction):
        (KJS::DateFunction::DateFunction):
        (KJS::DateFunction::callAsFunction):
        (KJS::dateProtoFuncToString):
        (KJS::dateProtoFuncToUTCString):
        (KJS::dateProtoFuncToDateString):
        (KJS::dateProtoFuncToTimeString):
        (KJS::dateProtoFuncToLocaleString):
        (KJS::dateProtoFuncToLocaleDateString):
        (KJS::dateProtoFuncToLocaleTimeString):
        (KJS::dateProtoFuncValueOf):
        (KJS::dateProtoFuncGetTime):
        (KJS::dateProtoFuncGetFullYear):
        (KJS::dateProtoFuncGetUTCFullYear):
        (KJS::dateProtoFuncToGMTString):
        (KJS::dateProtoFuncGetMonth):
        (KJS::dateProtoFuncGetUTCMonth):
        (KJS::dateProtoFuncGetDate):
        (KJS::dateProtoFuncGetUTCDate):
        (KJS::dateProtoFuncGetDay):
        (KJS::dateProtoFuncGetUTCDay):
        (KJS::dateProtoFuncGetHours):
        (KJS::dateProtoFuncGetUTCHours):
        (KJS::dateProtoFuncGetMinutes):
        (KJS::dateProtoFuncGetUTCMinutes):
        (KJS::dateProtoFuncGetSeconds):
        (KJS::dateProtoFuncGetUTCSeconds):
        (KJS::dateProtoFuncGetMilliSeconds):
        (KJS::dateProtoFuncGetUTCMilliseconds):
        (KJS::dateProtoFuncGetTimezoneOffset):
        (KJS::dateProtoFuncSetTime):
        (KJS::setNewValueFromTimeArgs):
        (KJS::setNewValueFromDateArgs):
        (KJS::dateProtoFuncSetYear):
        (KJS::dateProtoFuncGetYear):
        * kjs/error_object.cpp:
        (KJS::ErrorPrototype::ErrorPrototype):
        (KJS::errorProtoFuncToString):
        (KJS::ErrorConstructor::ErrorConstructor):
        (KJS::ErrorConstructor::construct):
        (KJS::NativeErrorPrototype::NativeErrorPrototype):
        (KJS::NativeErrorConstructor::NativeErrorConstructor):
        (KJS::NativeErrorConstructor::construct):
        * kjs/identifier.h:
        * kjs/internal.cpp:
        (KJS::StringObject::create):
        (KJS::JSString::lengthGetter):
        (KJS::JSString::indexGetter):
        (KJS::JSString::indexNumericPropertyGetter):
        * kjs/interpreter.cpp:
        * kjs/list.cpp:
        (KJS::ArgList::slowAppend):
        * kjs/list.h:
        * kjs/lookup.h:
        (KJS::staticFunctionGetter):
        (KJS::cacheGlobalObject):
        * kjs/nodes.cpp:
        (KJS::Node::emitThrowError):
        (KJS::StringNode::emitCode):
        (KJS::ArrayNode::emitCode):
        (KJS::FuncDeclNode::makeFunction):
        (KJS::FuncExprNode::makeFunction):
        * kjs/nodes.h:
        * kjs/object_object.cpp:
        (KJS::ObjectPrototype::ObjectPrototype):
        (KJS::objectProtoFuncToLocaleString):
        (KJS::objectProtoFuncToString):
        (KJS::ObjectConstructor::ObjectConstructor):
        (KJS::ObjectConstructor::construct):
        * kjs/protect.h:
        (KJS::gcProtect):
        (KJS::gcUnprotect):
        * kjs/string_object.cpp:
        (KJS::StringObject::StringObject):
        (KJS::StringPrototype::StringPrototype):
        (KJS::replace):
        (KJS::stringProtoFuncCharAt):
        (KJS::stringProtoFuncCharCodeAt):
        (KJS::stringProtoFuncConcat):
        (KJS::stringProtoFuncIndexOf):
        (KJS::stringProtoFuncLastIndexOf):
        (KJS::stringProtoFuncMatch):
        (KJS::stringProtoFuncSearch):
        (KJS::stringProtoFuncReplace):
        (KJS::stringProtoFuncSlice):
        (KJS::stringProtoFuncSplit):
        (KJS::stringProtoFuncSubstr):
        (KJS::stringProtoFuncSubstring):
        (KJS::stringProtoFuncToLowerCase):
        (KJS::stringProtoFuncToUpperCase):
        (KJS::stringProtoFuncToLocaleLowerCase):
        (KJS::stringProtoFuncToLocaleUpperCase):
        (KJS::stringProtoFuncLocaleCompare):
        (KJS::stringProtoFuncBig):
        (KJS::stringProtoFuncSmall):
        (KJS::stringProtoFuncBlink):
        (KJS::stringProtoFuncBold):
        (KJS::stringProtoFuncFixed):
        (KJS::stringProtoFuncItalics):
        (KJS::stringProtoFuncStrike):
        (KJS::stringProtoFuncSub):
        (KJS::stringProtoFuncSup):
        (KJS::stringProtoFuncFontcolor):
        (KJS::stringProtoFuncFontsize):
        (KJS::stringProtoFuncAnchor):
        (KJS::stringProtoFuncLink):
        (KJS::StringConstructor::StringConstructor):
        (KJS::StringConstructor::construct):
        (KJS::StringConstructor::callAsFunction):
        (KJS::StringConstructorFunction::StringConstructorFunction):
        (KJS::StringConstructorFunction::callAsFunction):
        * kjs/string_object.h:
        (KJS::StringObjectThatMasqueradesAsUndefined::StringObjectThatMasqueradesAsUndefined):
        * kjs/ustring.h:
        Updated for the above changes.

2008-06-17  Timothy Hatcher  <timothy@apple.com>

        Added a type to DebuggerCallFrame so the under interface can
        distinguish anonymous functions and program call frames.

        https://bugs.webkit.org/show_bug.cgi?id=19585

        Reviewed by Geoff Garen.

        * JavaScriptCore.exp: Export the DebuggerCallFrame::type symbol.
        * kjs/DebuggerCallFrame.cpp:
        (KJS::DebuggerCallFrame::type): Added.
        * kjs/DebuggerCallFrame.h:

2008-06-17  Eric Seidel  <eric@webkit.org>

        Reviewed by Tim H.
        
        Remove bogus ASSERT which tripped every time for those who use PAC files.

        * kjs/Parser.cpp:
        (KJS::Parser::parse):

2008-06-17  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geoff.

        <rdar://problem/5951534> JSProfiler: Don't profile console.profile()
        or console.profileEnd()

        * profiler/Profile.cpp:
        (KJS::Profile::stopProfiling): Moved the creation of the (idle) node to
        the Profile (not ProfileNode).  This makes sense since the Profile
        should be the one to modify the profile tree.  Also each stopProfiling()
        does not need to check if it's the head node anymore.  Also fixed an
        oddity where I was using willExecute to create the node.
        (KJS::Profile::removeProfileStart): Removes the call to console.profile
        that started this profile.
        (KJS::Profile::removeProfileEnd): Removes the call to console.profileEnd
        that ended this profile.
        * profiler/Profile.h:
        * profiler/ProfileNode.cpp: Moved the creation of the (idle) node to
        the Profile object.
        (KJS::ProfileNode::stopProfiling):
        * profiler/ProfileNode.h: Added some helper functions and whitespace to
        facilitate readability and the removal of profile() and profileEnd()
        from the Profile tree.
        (KJS::CallIdentifier::operator const char* ):
        (KJS::ProfileNode::firstChild):
        (KJS::ProfileNode::lastChild):
        (KJS::ProfileNode::removeChild):
        (KJS::ProfileNode::toString):

2008-06-17  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Rubber stamped by Adam Roben.

        Include JSGlobalObject.h to fix the build.

        * kjs/ScopeChain.cpp:

2008-06-17  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Reduce code duplication in emitReadModifyAssignment().

        * kjs/nodes.cpp:
        (KJS::emitReadModifyAssignment):

2008-06-17  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Sort includes alphabetically.

        * kjs/nodes.cpp:

2008-06-16  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Bug 19596: LEAK: Gmail leaks SegmentedVector<RegisterID>
        <https://bugs.webkit.org/show_bug.cgi?id=19596>

        When growing SegmentedVector, we start adding segments at the position
        of the last segment, overwriting it. The destructor frees allocated
        segments starting at the segment of index 1, because the segment of
        index 0 is assumed to be the initial inline segment. This causes a leak
        of the segment that is referenced by index 0. Modifying grow() so that
        it starts adding segments at the position after the last segment fixes
        the leak.

        Since the initial segment is a special case in the lookup code, this
        bug never manifested itself via incorrect results.

        * VM/SegmentedVector.h:
        (KJS::SegmentedVector::grow):

2008-06-16  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Alexey.
        
        - removed nearly unused types.h and LocalStorageEntry.h headers

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * kjs/ExecState.h:
        * kjs/LocalStorageEntry.h: Removed.
        * kjs/RegExpObject.cpp:
        * kjs/error_object.cpp:
        * kjs/grammar.y:
        * kjs/nodes.cpp:
        * kjs/types.h: Removed.

2008-06-16  Alp Toker  <alp@nuanti.com>

        Rubber-stamped by Geoff.

        Change c++ to c in minidom and testapi emacs mode line comments.

        * API/Node.h:
        * API/NodeList.c:
        * API/NodeList.h:
        * API/testapi.c:

2008-06-16  Alexey Proskuryakov  <ap@webkit.org>

        Trying to fix Windows build.

        * kjs/PropertyNameArray.h:
        * kjs/identifier.cpp:
        Include ExecState.h

2008-06-16  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Slight cleanup to the SymbolTableEntry class.
        
        Renamed isEmpty to isNull, since we usually use "empty" to mean "holds
        the valid, empty value", and "null" to mean "holds no value".
        
        Changed an "== 0" to a "!", to match our style guidelines.
        
        Added some ASSERTs to verify the (possibly questionable) assumption that
        all register indexes will have their high two bits set. Also clarified a
        comment to make that assumption clear.

2008-06-16  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        Initialize functionQueueMutex in a safe manner.

        * wtf/MainThread.cpp:
        (WTF::functionQueueMutex): Made it an AtomicallyInitializedStatic.

        (WTF::dispatchFunctionsFromMainThread):
        (WTF::setMainThreadCallbacksPaused):
        Assert that the current thread is main, meaning that the callbacksPaused static can be
        accessed.

2008-06-16  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff Garen.

        Make Identifier construction use an explicitly passed IdentifierTable.

        No change on SunSpider total.

        * API/JSCallbackObjectFunctions.h:
        (KJS::::getOwnPropertySlot):
        (KJS::::put):
        (KJS::::deleteProperty):
        (KJS::::getPropertyNames):
        * API/JSObjectRef.cpp:
        (JSObjectMakeFunctionWithCallback):
        (JSObjectMakeFunction):
        (JSObjectHasProperty):
        (JSObjectGetProperty):
        (JSObjectSetProperty):
        (JSObjectDeleteProperty):
        (OpaqueJSPropertyNameArray::OpaqueJSPropertyNameArray):
        (JSObjectCopyPropertyNames):
        * JavaScriptCore.exp:
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::CodeGenerator):
        (KJS::CodeGenerator::registerForLocal):
        (KJS::CodeGenerator::isLocal):
        (KJS::CodeGenerator::addConstant):
        (KJS::CodeGenerator::findScopedProperty):
        * VM/CodeGenerator.h:
        (KJS::CodeGenerator::globalData):
        (KJS::CodeGenerator::propertyNames):
        * VM/JSPropertyNameIterator.cpp:
        (KJS::JSPropertyNameIterator::create):
        * VM/Machine.cpp:
        (KJS::Machine::throwException):
        (KJS::Machine::privateExecute):
        * kjs/ArrayPrototype.cpp:
        (KJS::ArrayConstructor::ArrayConstructor):
        * kjs/BooleanObject.cpp:
        (KJS::BooleanConstructor::BooleanConstructor):
        * kjs/FunctionPrototype.cpp:
        (KJS::FunctionConstructor::FunctionConstructor):
        (KJS::FunctionConstructor::construct):
        * kjs/JSArray.cpp:
        (KJS::JSArray::inlineGetOwnPropertySlot):
        (KJS::JSArray::put):
        (KJS::JSArray::deleteProperty):
        (KJS::JSArray::getPropertyNames):
        * kjs/JSFunction.cpp:
        (KJS::Arguments::Arguments):
        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::JSGlobalData):
        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::reset):
        * kjs/JSObject.cpp:
        (KJS::JSObject::getOwnPropertySlot):
        (KJS::JSObject::put):
        (KJS::JSObject::putWithAttributes):
        (KJS::JSObject::deleteProperty):
        (KJS::JSObject::findPropertyHashEntry):
        (KJS::JSObject::getPropertyNames):
        (KJS::Error::create):
        * kjs/JSVariableObject.cpp:
        (KJS::JSVariableObject::getPropertyNames):
        * kjs/NumberObject.cpp:
        (KJS::NumberConstructor::NumberConstructor):
        * kjs/PropertyNameArray.cpp:
        (KJS::PropertyNameArray::add):
        * kjs/PropertyNameArray.h:
        (KJS::PropertyNameArray::PropertyNameArray):
        (KJS::PropertyNameArray::addKnownUnique):
        * kjs/PropertySlot.h:
        (KJS::PropertySlot::getValue):
        * kjs/RegExpObject.cpp:
        (KJS::RegExpConstructor::RegExpConstructor):
        * kjs/ScopeChain.cpp:
        (KJS::ScopeChainNode::print):
        * kjs/Shell.cpp:
        (GlobalObject::GlobalObject):
        * kjs/date_object.cpp:
        (KJS::DateConstructor::DateConstructor):
        * kjs/error_object.cpp:
        (KJS::ErrorConstructor::ErrorConstructor):
        (KJS::NativeErrorConstructor::NativeErrorConstructor):
        * kjs/grammar.y:
        * kjs/identifier.cpp:
        (KJS::Identifier::add):
        (KJS::Identifier::addSlowCase):
        * kjs/identifier.h:
        (KJS::Identifier::Identifier):
        (KJS::Identifier::from):
        (KJS::Identifier::equal):
        (KJS::Identifier::add):
        (KJS::operator==):
        (KJS::operator!=):
        * kjs/internal.cpp:
        (KJS::JSString::getOwnPropertySlot):
        * kjs/lexer.cpp:
        (KJS::Lexer::Lexer):
        (KJS::Lexer::lex):
        (KJS::Lexer::makeIdentifier):
        * kjs/lexer.h:
        * kjs/lookup.cpp:
        (KJS::HashTable::createTable):
        * kjs/lookup.h:
        (KJS::HashTable::initializeIfNeeded):
        (KJS::HashTable::entry):
        (KJS::getStaticPropertySlot):
        (KJS::getStaticFunctionSlot):
        (KJS::getStaticValueSlot):
        (KJS::lookupPut):
        * kjs/object_object.cpp:
        (KJS::objectProtoFuncHasOwnProperty):
        (KJS::objectProtoFuncDefineGetter):
        (KJS::objectProtoFuncDefineSetter):
        (KJS::objectProtoFuncLookupGetter):
        (KJS::objectProtoFuncLookupSetter):
        (KJS::objectProtoFuncPropertyIsEnumerable):
        (KJS::ObjectConstructor::ObjectConstructor):
        * kjs/string_object.cpp:
        (KJS::StringObject::getOwnPropertySlot):
        (KJS::StringObject::getPropertyNames):
        (KJS::StringConstructor::StringConstructor):
        Just pass ExecState or JSGlobalData everywhere. Identifier construction is now always
        explicit.

        * kjs/nodes.cpp: (KJS::RegExpNode::emitCode): Here, Identifier was created from a non-literal
        char*, which was incorrect, as that uses the pointer value as a key.

2008-06-16  Thiago Macieira  <tjmaciei@trolltech.com>

        Reviewed by Darin.

        https://bugs.webkit.org/show_bug.cgi?id=19577

        Fix compilation in C++ environments where C99 headers are not present

        The stdbool.h header is a C99 feature, defining the "_Bool" type as well as the
        "true" and "false" constants. But it's completely unnecessary in C++ as the
        language already defines the "bool" type and its two values.

        * API/JSBase.h:
        * API/JSContextRef.h:
        * API/JSObjectRef.h:
        * API/JSStringRef.h:
        * API/JSValueRef.h:

2008-06-16  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by John.

        <rdar://problem/6012509> JSProfiler: %s are incorrect if you exclude a
        top level node like (idle)

        * profiler/Profile.cpp:
        (KJS::Profile::focus):
        (KJS::Profile::exclude): Subtract the selfTime from the totalTime of the
        head since its self time will only be non-zero when one of its children
        were excluded. Since the head's totalTime is used to calculate %s when
        its totalTime is the same as the sum of all its visible childrens' times
        their %s will sum to 100%.

2008-06-16  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/5969992> JSProfiler: Remove the recursion limit in the profiler.

        * profiler/Profile.cpp:
        (KJS::Profile::willExecute):

2008-06-16  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Sam.

        <rdar://problem/5969992> JSProfiler: Remove the recursion limit in the
        profiler.
        - Remove the last of the uses of recursion in the profiler.

        * JavaScriptCore.exp: Export the new function's signature.
        * profiler/Profile.cpp: 
        (KJS::calculateVisibleTotalTime): Added a new static method for
        recalculating the visibleTotalTime of methods after focus has changed
        which are visible.
        (KJS::stopProfiling): 
        (KJS::Profile::focus): Implemented focus without recursion.
        * profiler/Profile.h: Moved implementation into the definition file.
        * profiler/ProfileNode.cpp:
        (KJS::ProfileNode::traverseNextNodePreOrder): Added an argument for
        whether or not to process the children nodes, this allows focus to skip
        sub trees which have been set as not visible.
        (KJS::ProfileNode::calculateVisibleTotalTime): This function set's a
        node's total visible time to the sum of its self time and its children's
        total times.
        (KJS::ProfileNode::focus): Implemented focus without recursion.
        * profiler/ProfileNode.h:
        (KJS::CallIdentifier::operator!= ):
        (KJS::ProfileNode::setActualTotalTime): Expanded setting the total time
        so that focus could modify only the visible total time.
        (KJS::ProfileNode::setVisibleTotalTime):

2008-06-16  Christian Dywan  <christian@twotoasts.de>

        Reviewed by Sam.

        https://bugs.webkit.org/show_bug.cgi?id=19552
        JavaScriptCore headers use C++ style comments

        Replace all C++ style comments with C style multiline
        comments and remove all "mode" lines.

        * API/JSBase.h:
        * API/JSClassRef.h:
        * API/JSContextRef.h:
        * API/JSObjectRef.h:
        * API/JSStringRef.h:
        * API/JSStringRefBSTR.h:
        * API/JSStringRefCF.h:
        * API/JSValueRef.h:
        * API/JavaScript.h:
        * API/JavaScriptCore.h:

2008-06-16  Christian Dywan  <christian@twotoasts.de>

        Reviewed by Sam.

        https://bugs.webkit.org/show_bug.cgi?id=19557
        (JavaScriptCore) minidom uses C++ style comments

        Use only C style comments in minidom sources

        * API/JSNode.c:
        (JSNode_appendChild):
        (JSNode_removeChild):
        * API/JSNode.h:
        * API/JSNodeList.c:
        (JSNodeList_getProperty):
        * API/JSNodeList.h:
        * API/Node.c:
        * API/Node.h:
        * API/NodeList.c:
        (NodeList_new):
        (NodeList_item):
        * API/NodeList.h:
        * API/minidom.c:
        (createStringWithContentsOfFile):
        * wtf/Assertions.h:
        * wtf/UnusedParam.h:

2008-06-16  Adriaan de Groot  <groot@kde.org>

        Reviewed by Simon.

        Fix compilation on Solaris

        On some systems, munmap takes a char* instead of a void* (contrary to POSIX and
        Single Unix Specification). Since you can always convert from char* to void*
        but not vice-versa, do the casting to char*.

        * kjs/collector.cpp:
        (KJS::allocateBlock):
        (KJS::freeBlock):

2008-06-16  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Make a UnaryOpNode class to reduce boilerplate code for UnaryPlusNode,
        NegateNode, BitwiseNotNode, and LogicalNotNode.

        * VM/CodeGenerator.h:
        (KJS::CodeGenerator::emitToJSNumber):
        * kjs/nodes.cpp:
        (KJS::UnaryOpNode::emitCode):
        * kjs/nodes.h:
        (KJS::UnaryOpNode::UnaryOpNode):
        (KJS::UnaryPlusNode::):
        (KJS::NegateNode::):
        (KJS::NegateNode::precedence):
        (KJS::BitwiseNotNode::):
        (KJS::BitwiseNotNode::precedence):
        (KJS::LogicalNotNode::):
        (KJS::LogicalNotNode::precedence):

2008-06-16  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Gtk build fix

        * GNUmakefile.am:

2008-06-15  Darin Adler  <darin@apple.com>

        - rename KJS::List to KJS::ArgList

        * API/JSCallbackConstructor.cpp:
        (KJS::JSCallbackConstructor::construct):
        * API/JSCallbackConstructor.h:
        * API/JSCallbackFunction.cpp:
        (KJS::JSCallbackFunction::callAsFunction):
        * API/JSCallbackFunction.h:
        * API/JSCallbackObject.h:
        * API/JSCallbackObjectFunctions.h:
        (KJS::::construct):
        (KJS::::callAsFunction):
        * API/JSObjectRef.cpp:
        (JSObjectMakeFunction):
        (JSObjectCallAsFunction):
        (JSObjectCallAsConstructor):
        * JavaScriptCore.exp:
        * VM/Machine.cpp:
        (KJS::Machine::execute):
        (KJS::Machine::privateExecute):
        * VM/Machine.h:
        * kjs/ArrayPrototype.cpp:
        (KJS::arrayProtoFuncToString):
        (KJS::arrayProtoFuncToLocaleString):
        (KJS::arrayProtoFuncJoin):
        (KJS::arrayProtoFuncConcat):
        (KJS::arrayProtoFuncPop):
        (KJS::arrayProtoFuncPush):
        (KJS::arrayProtoFuncReverse):
        (KJS::arrayProtoFuncShift):
        (KJS::arrayProtoFuncSlice):
        (KJS::arrayProtoFuncSort):
        (KJS::arrayProtoFuncSplice):
        (KJS::arrayProtoFuncUnShift):
        (KJS::arrayProtoFuncFilter):
        (KJS::arrayProtoFuncMap):
        (KJS::arrayProtoFuncEvery):
        (KJS::arrayProtoFuncForEach):
        (KJS::arrayProtoFuncSome):
        (KJS::arrayProtoFuncIndexOf):
        (KJS::arrayProtoFuncLastIndexOf):
        (KJS::ArrayConstructor::construct):
        (KJS::ArrayConstructor::callAsFunction):
        * kjs/ArrayPrototype.h:
        * kjs/BooleanObject.cpp:
        (KJS::booleanProtoFuncToString):
        (KJS::booleanProtoFuncValueOf):
        (KJS::BooleanConstructor::construct):
        (KJS::BooleanConstructor::callAsFunction):
        * kjs/BooleanObject.h:
        * kjs/CommonIdentifiers.h:
        * kjs/ExecState.h:
        (KJS::ExecState::emptyList):
        * kjs/FunctionPrototype.cpp:
        (KJS::FunctionPrototype::callAsFunction):
        (KJS::functionProtoFuncToString):
        (KJS::functionProtoFuncApply):
        (KJS::functionProtoFuncCall):
        (KJS::FunctionConstructor::construct):
        (KJS::FunctionConstructor::callAsFunction):
        * kjs/FunctionPrototype.h:
        * kjs/JSActivation.cpp:
        (KJS::JSActivation::createArgumentsObject):
        * kjs/JSArray.cpp:
        (KJS::JSArray::JSArray):
        (KJS::AVLTreeAbstractorForArrayCompare::compare_key_key):
        * kjs/JSArray.h:
        * kjs/JSFunction.cpp:
        (KJS::JSFunction::callAsFunction):
        (KJS::JSFunction::construct):
        (KJS::IndexToNameMap::IndexToNameMap):
        (KJS::Arguments::Arguments):
        (KJS::encode):
        (KJS::decode):
        (KJS::globalFuncEval):
        (KJS::globalFuncParseInt):
        (KJS::globalFuncParseFloat):
        (KJS::globalFuncIsNaN):
        (KJS::globalFuncIsFinite):
        (KJS::globalFuncDecodeURI):
        (KJS::globalFuncDecodeURIComponent):
        (KJS::globalFuncEncodeURI):
        (KJS::globalFuncEncodeURIComponent):
        (KJS::globalFuncEscape):
        (KJS::globalFuncUnescape):
        (KJS::globalFuncKJSPrint):
        (KJS::PrototypeFunction::callAsFunction):
        (KJS::PrototypeReflexiveFunction::callAsFunction):
        * kjs/JSFunction.h:
        * kjs/JSGlobalData.h:
        * kjs/JSImmediate.cpp:
        (KJS::JSImmediate::toObject):
        * kjs/JSNotAnObject.cpp:
        (KJS::JSNotAnObject::construct):
        (KJS::JSNotAnObject::callAsFunction):
        * kjs/JSNotAnObject.h:
        * kjs/JSObject.cpp:
        (KJS::JSObject::put):
        (KJS::JSObject::construct):
        (KJS::JSObject::callAsFunction):
        (KJS::Error::create):
        * kjs/JSObject.h:
        * kjs/MathObject.cpp:
        (KJS::mathProtoFuncAbs):
        (KJS::mathProtoFuncACos):
        (KJS::mathProtoFuncASin):
        (KJS::mathProtoFuncATan):
        (KJS::mathProtoFuncATan2):
        (KJS::mathProtoFuncCeil):
        (KJS::mathProtoFuncCos):
        (KJS::mathProtoFuncExp):
        (KJS::mathProtoFuncFloor):
        (KJS::mathProtoFuncLog):
        (KJS::mathProtoFuncMax):
        (KJS::mathProtoFuncMin):
        (KJS::mathProtoFuncPow):
        (KJS::mathProtoFuncRandom):
        (KJS::mathProtoFuncRound):
        (KJS::mathProtoFuncSin):
        (KJS::mathProtoFuncSqrt):
        (KJS::mathProtoFuncTan):
        * kjs/MathObject.h:
        * kjs/NumberObject.cpp:
        (KJS::numberProtoFuncToString):
        (KJS::numberProtoFuncToLocaleString):
        (KJS::numberProtoFuncValueOf):
        (KJS::numberProtoFuncToFixed):
        (KJS::numberProtoFuncToExponential):
        (KJS::numberProtoFuncToPrecision):
        (KJS::NumberConstructor::construct):
        (KJS::NumberConstructor::callAsFunction):
        * kjs/NumberObject.h:
        * kjs/RegExpObject.cpp:
        (KJS::regExpProtoFuncTest):
        (KJS::regExpProtoFuncExec):
        (KJS::regExpProtoFuncCompile):
        (KJS::regExpProtoFuncToString):
        (KJS::RegExpObject::match):
        (KJS::RegExpObject::test):
        (KJS::RegExpObject::exec):
        (KJS::RegExpObject::callAsFunction):
        (KJS::RegExpConstructor::construct):
        (KJS::RegExpConstructor::callAsFunction):
        * kjs/RegExpObject.h:
        * kjs/Shell.cpp:
        (functionPrint):
        (functionDebug):
        (functionGC):
        (functionVersion):
        (functionRun):
        (functionLoad):
        (functionReadline):
        (functionQuit):
        * kjs/collector.cpp:
        (KJS::Collector::collect):
        * kjs/collector.h:
        (KJS::Collector::markListSet):
        * kjs/date_object.cpp:
        (KJS::formatLocaleDate):
        (KJS::fillStructuresUsingTimeArgs):
        (KJS::fillStructuresUsingDateArgs):
        (KJS::DateConstructor::construct):
        (KJS::DateConstructor::callAsFunction):
        (KJS::DateFunction::callAsFunction):
        (KJS::dateProtoFuncToString):
        (KJS::dateProtoFuncToUTCString):
        (KJS::dateProtoFuncToDateString):
        (KJS::dateProtoFuncToTimeString):
        (KJS::dateProtoFuncToLocaleString):
        (KJS::dateProtoFuncToLocaleDateString):
        (KJS::dateProtoFuncToLocaleTimeString):
        (KJS::dateProtoFuncValueOf):
        (KJS::dateProtoFuncGetTime):
        (KJS::dateProtoFuncGetFullYear):
        (KJS::dateProtoFuncGetUTCFullYear):
        (KJS::dateProtoFuncToGMTString):
        (KJS::dateProtoFuncGetMonth):
        (KJS::dateProtoFuncGetUTCMonth):
        (KJS::dateProtoFuncGetDate):
        (KJS::dateProtoFuncGetUTCDate):
        (KJS::dateProtoFuncGetDay):
        (KJS::dateProtoFuncGetUTCDay):
        (KJS::dateProtoFuncGetHours):
        (KJS::dateProtoFuncGetUTCHours):
        (KJS::dateProtoFuncGetMinutes):
        (KJS::dateProtoFuncGetUTCMinutes):
        (KJS::dateProtoFuncGetSeconds):
        (KJS::dateProtoFuncGetUTCSeconds):
        (KJS::dateProtoFuncGetMilliSeconds):
        (KJS::dateProtoFuncGetUTCMilliseconds):
        (KJS::dateProtoFuncGetTimezoneOffset):
        (KJS::dateProtoFuncSetTime):
        (KJS::setNewValueFromTimeArgs):
        (KJS::setNewValueFromDateArgs):
        (KJS::dateProtoFuncSetMilliSeconds):
        (KJS::dateProtoFuncSetUTCMilliseconds):
        (KJS::dateProtoFuncSetSeconds):
        (KJS::dateProtoFuncSetUTCSeconds):
        (KJS::dateProtoFuncSetMinutes):
        (KJS::dateProtoFuncSetUTCMinutes):
        (KJS::dateProtoFuncSetHours):
        (KJS::dateProtoFuncSetUTCHours):
        (KJS::dateProtoFuncSetDate):
        (KJS::dateProtoFuncSetUTCDate):
        (KJS::dateProtoFuncSetMonth):
        (KJS::dateProtoFuncSetUTCMonth):
        (KJS::dateProtoFuncSetFullYear):
        (KJS::dateProtoFuncSetUTCFullYear):
        (KJS::dateProtoFuncSetYear):
        (KJS::dateProtoFuncGetYear):
        * kjs/date_object.h:
        * kjs/debugger.h:
        * kjs/error_object.cpp:
        (KJS::errorProtoFuncToString):
        (KJS::ErrorConstructor::construct):
        (KJS::ErrorConstructor::callAsFunction):
        (KJS::NativeErrorConstructor::construct):
        (KJS::NativeErrorConstructor::callAsFunction):
        * kjs/error_object.h:
        * kjs/internal.cpp:
        (KJS::JSNumberCell::toObject):
        (KJS::JSNumberCell::toThisObject):
        * kjs/list.cpp:
        (KJS::ArgList::getSlice):
        (KJS::ArgList::markLists):
        (KJS::ArgList::slowAppend):
        * kjs/list.h:
        (KJS::ArgList::ArgList):
        (KJS::ArgList::~ArgList):
        * kjs/object_object.cpp:
        (KJS::objectProtoFuncValueOf):
        (KJS::objectProtoFuncHasOwnProperty):
        (KJS::objectProtoFuncIsPrototypeOf):
        (KJS::objectProtoFuncDefineGetter):
        (KJS::objectProtoFuncDefineSetter):
        (KJS::objectProtoFuncLookupGetter):
        (KJS::objectProtoFuncLookupSetter):
        (KJS::objectProtoFuncPropertyIsEnumerable):
        (KJS::objectProtoFuncToLocaleString):
        (KJS::objectProtoFuncToString):
        (KJS::ObjectConstructor::construct):
        (KJS::ObjectConstructor::callAsFunction):
        * kjs/object_object.h:
        * kjs/string_object.cpp:
        (KJS::replace):
        (KJS::stringProtoFuncToString):
        (KJS::stringProtoFuncValueOf):
        (KJS::stringProtoFuncCharAt):
        (KJS::stringProtoFuncCharCodeAt):
        (KJS::stringProtoFuncConcat):
        (KJS::stringProtoFuncIndexOf):
        (KJS::stringProtoFuncLastIndexOf):
        (KJS::stringProtoFuncMatch):
        (KJS::stringProtoFuncSearch):
        (KJS::stringProtoFuncReplace):
        (KJS::stringProtoFuncSlice):
        (KJS::stringProtoFuncSplit):
        (KJS::stringProtoFuncSubstr):
        (KJS::stringProtoFuncSubstring):
        (KJS::stringProtoFuncToLowerCase):
        (KJS::stringProtoFuncToUpperCase):
        (KJS::stringProtoFuncToLocaleLowerCase):
        (KJS::stringProtoFuncToLocaleUpperCase):
        (KJS::stringProtoFuncLocaleCompare):
        (KJS::stringProtoFuncBig):
        (KJS::stringProtoFuncSmall):
        (KJS::stringProtoFuncBlink):
        (KJS::stringProtoFuncBold):
        (KJS::stringProtoFuncFixed):
        (KJS::stringProtoFuncItalics):
        (KJS::stringProtoFuncStrike):
        (KJS::stringProtoFuncSub):
        (KJS::stringProtoFuncSup):
        (KJS::stringProtoFuncFontcolor):
        (KJS::stringProtoFuncFontsize):
        (KJS::stringProtoFuncAnchor):
        (KJS::stringProtoFuncLink):
        (KJS::StringConstructor::construct):
        (KJS::StringConstructor::callAsFunction):
        (KJS::StringConstructorFunction::callAsFunction):
        * kjs/string_object.h:

2008-06-15  Darin Adler  <darin@apple.com>

        - new names for more JavaScriptCore files

        * API/JSCallbackFunction.cpp:
        * API/JSObjectRef.cpp:
        * DerivedSources.make:
        * GNUmakefile.am:
        * JavaScriptCore.exp:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * VM/Machine.cpp:
        * kjs/AllInOneFile.cpp:
        * kjs/ArrayPrototype.cpp: Copied from JavaScriptCore/kjs/array_object.cpp.
        * kjs/ArrayPrototype.h: Copied from JavaScriptCore/kjs/array_object.h.
        * kjs/BooleanObject.cpp: Copied from JavaScriptCore/kjs/bool_object.cpp.
        * kjs/BooleanObject.h: Copied from JavaScriptCore/kjs/bool_object.h.
        * kjs/ExecState.cpp:
        * kjs/ExecState.h:
        * kjs/FunctionPrototype.cpp: Copied from JavaScriptCore/kjs/function_object.cpp.
        * kjs/FunctionPrototype.h: Copied from JavaScriptCore/kjs/function_object.h.
        * kjs/JSArray.cpp: Copied from JavaScriptCore/kjs/array_instance.cpp.
        * kjs/JSArray.h: Copied from JavaScriptCore/kjs/array_instance.h.
        * kjs/JSFunction.cpp:
        * kjs/JSFunction.h:
        * kjs/JSGlobalObject.cpp:
        * kjs/JSImmediate.cpp:
        * kjs/JSObject.h:
        * kjs/JSString.h:
        * kjs/JSValue.h:
        * kjs/JSVariableObject.cpp:
        * kjs/MathObject.cpp: Copied from JavaScriptCore/kjs/math_object.cpp.
        * kjs/MathObject.h: Copied from JavaScriptCore/kjs/math_object.h.
        * kjs/NumberObject.cpp: Copied from JavaScriptCore/kjs/number_object.cpp.
        * kjs/NumberObject.h: Copied from JavaScriptCore/kjs/number_object.h.
        * kjs/PropertyMap.cpp: Copied from JavaScriptCore/kjs/property_map.cpp.
        * kjs/PropertyMap.h: Copied from JavaScriptCore/kjs/property_map.h.
        * kjs/PropertySlot.cpp: Copied from JavaScriptCore/kjs/property_slot.cpp.
        * kjs/PropertySlot.h: Copied from JavaScriptCore/kjs/property_slot.h.
        * kjs/RegExpObject.cpp: Copied from JavaScriptCore/kjs/regexp_object.cpp.
        * kjs/RegExpObject.h: Copied from JavaScriptCore/kjs/regexp_object.h.
        * kjs/ScopeChain.cpp: Copied from JavaScriptCore/kjs/scope_chain.cpp.
        * kjs/ScopeChain.h: Copied from JavaScriptCore/kjs/scope_chain.h.
        * kjs/ScopeChainMark.h: Copied from JavaScriptCore/kjs/scope_chain_mark.h.
        * kjs/Shell.cpp:
        * kjs/array_instance.cpp: Removed.
        * kjs/array_instance.h: Removed.
        * kjs/array_object.cpp: Removed.
        * kjs/array_object.h: Removed.
        * kjs/bool_object.cpp: Removed.
        * kjs/bool_object.h: Removed.
        * kjs/error_object.h:
        * kjs/function_object.cpp: Removed.
        * kjs/function_object.h: Removed.
        * kjs/internal.cpp:
        * kjs/math_object.cpp: Removed.
        * kjs/math_object.h: Removed.
        * kjs/nodes.cpp:
        * kjs/number_object.cpp: Removed.
        * kjs/number_object.h: Removed.
        * kjs/object_object.cpp:
        * kjs/property_map.cpp: Removed.
        * kjs/property_map.h: Removed.
        * kjs/property_slot.cpp: Removed.
        * kjs/property_slot.h: Removed.
        * kjs/regexp_object.cpp: Removed.
        * kjs/regexp_object.h: Removed.
        * kjs/scope_chain.cpp: Removed.
        * kjs/scope_chain.h: Removed.
        * kjs/scope_chain_mark.h: Removed.
        * kjs/string_object.cpp:
        * kjs/string_object.h:

2008-06-15  Darin Adler  <darin@apple.com>

        - new names for a few key JavaScriptCore files

        * API/JSBase.cpp:
        * API/JSCallbackConstructor.h:
        * API/JSCallbackFunction.cpp:
        * API/JSCallbackFunction.h:
        * API/JSCallbackObject.h:
        * API/JSCallbackObjectFunctions.h:
        * API/JSClassRef.h:
        * API/JSContextRef.cpp:
        * API/JSObjectRef.cpp:
        * API/JSStringRef.cpp:
        * API/JSStringRefCF.cpp:
        * API/JSValueRef.cpp:
        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * JavaScriptCoreSources.bkl:
        * VM/CodeBlock.cpp:
        * VM/CodeGenerator.cpp:
        * VM/ExceptionHelpers.cpp:
        * VM/ExceptionHelpers.h:
        * VM/JSPropertyNameIterator.cpp:
        * VM/JSPropertyNameIterator.h:
        * VM/Machine.cpp:
        * kjs/AllInOneFile.cpp:
        * kjs/DateMath.cpp:
        * kjs/DebuggerCallFrame.cpp:
        * kjs/ExecState.cpp:
        * kjs/JSActivation.cpp:
        * kjs/JSFunction.cpp: Copied from JavaScriptCore/kjs/function.cpp.
        * kjs/JSFunction.h: Copied from JavaScriptCore/kjs/function.h.
        * kjs/JSImmediate.cpp:
        * kjs/JSNotAnObject.h:
        * kjs/JSObject.cpp: Copied from JavaScriptCore/kjs/object.cpp.
        * kjs/JSObject.h: Copied from JavaScriptCore/kjs/object.h.
        * kjs/JSString.h: Copied from JavaScriptCore/kjs/internal.h.
        * kjs/JSValue.cpp: Copied from JavaScriptCore/kjs/value.cpp.
        * kjs/JSValue.h: Copied from JavaScriptCore/kjs/value.h.
        * kjs/JSVariableObject.h:
        * kjs/JSWrapperObject.h:
        * kjs/Shell.cpp:
        * kjs/SymbolTable.h:
        * kjs/array_instance.h:
        * kjs/collector.cpp:
        * kjs/date_object.cpp:
        * kjs/date_object.h:
        * kjs/error_object.cpp:
        * kjs/function.cpp: Removed.
        * kjs/function.h: Removed.
        * kjs/function_object.cpp:
        * kjs/function_object.h:
        * kjs/grammar.y:
        * kjs/internal.cpp:
        * kjs/internal.h: Removed.
        * kjs/lexer.cpp:
        * kjs/list.h:
        * kjs/lookup.h:
        * kjs/nodes.h:
        * kjs/object.cpp: Removed.
        * kjs/object.h: Removed.
        * kjs/object_object.h:
        * kjs/operations.cpp:
        * kjs/property_map.cpp:
        * kjs/property_slot.cpp:
        * kjs/property_slot.h:
        * kjs/protect.h:
        * kjs/regexp_object.cpp:
        * kjs/scope_chain.cpp:
        * kjs/string_object.h:
        * kjs/ustring.cpp:
        * kjs/value.cpp: Removed.
        * kjs/value.h: Removed.
        * profiler/Profile.cpp:
        * profiler/Profiler.cpp:

2008-06-15  Darin Adler  <darin@apple.com>

        Rubber stamped by Sam.

        - cut down on confusing uses of "Object" and "Imp" in
          JavaScriptCore class names

        * API/JSCallbackFunction.cpp:
        (KJS::JSCallbackFunction::JSCallbackFunction):
        * API/JSCallbackFunction.h:
        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):
        * kjs/ExecState.h:
        (KJS::ExecState::regExpTable):
        (KJS::ExecState::regExpConstructorTable):
        * kjs/JSGlobalData.cpp:
        (KJS::JSGlobalData::JSGlobalData):
        (KJS::JSGlobalData::~JSGlobalData):
        * kjs/JSGlobalData.h:
        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::reset):
        * kjs/JSGlobalObject.h:
        (KJS::JSGlobalObject::objectConstructor):
        (KJS::JSGlobalObject::functionConstructor):
        (KJS::JSGlobalObject::arrayConstructor):
        (KJS::JSGlobalObject::booleanConstructor):
        (KJS::JSGlobalObject::stringConstructor):
        (KJS::JSGlobalObject::numberConstructor):
        (KJS::JSGlobalObject::dateConstructor):
        (KJS::JSGlobalObject::regExpConstructor):
        (KJS::JSGlobalObject::errorConstructor):
        (KJS::JSGlobalObject::evalErrorConstructor):
        (KJS::JSGlobalObject::rangeErrorConstructor):
        (KJS::JSGlobalObject::referenceErrorConstructor):
        (KJS::JSGlobalObject::syntaxErrorConstructor):
        (KJS::JSGlobalObject::typeErrorConstructor):
        (KJS::JSGlobalObject::URIErrorConstructor):
        * kjs/array_object.cpp:
        (KJS::ArrayConstructor::ArrayConstructor):
        (KJS::ArrayConstructor::getConstructData):
        (KJS::ArrayConstructor::construct):
        (KJS::ArrayConstructor::callAsFunction):
        * kjs/array_object.h:
        * kjs/bool_object.cpp:
        (KJS::BooleanObject::BooleanObject):
        (KJS::BooleanPrototype::BooleanPrototype):
        (KJS::booleanProtoFuncToString):
        (KJS::booleanProtoFuncValueOf):
        (KJS::BooleanConstructor::BooleanConstructor):
        (KJS::BooleanConstructor::getConstructData):
        (KJS::BooleanConstructor::construct):
        (KJS::BooleanConstructor::callAsFunction):
        * kjs/bool_object.h:
        * kjs/date_object.cpp:
        (KJS::DatePrototype::DatePrototype):
        (KJS::DateConstructor::DateConstructor):
        (KJS::DateConstructor::getConstructData):
        (KJS::DateConstructor::construct):
        (KJS::DateConstructor::callAsFunction):
        (KJS::DateFunction::DateFunction):
        (KJS::DateFunction::callAsFunction):
        * kjs/date_object.h:
        * kjs/error_object.cpp:
        (KJS::ErrorPrototype::ErrorPrototype):
        (KJS::ErrorConstructor::ErrorConstructor):
        (KJS::ErrorConstructor::getConstructData):
        (KJS::ErrorConstructor::construct):
        (KJS::ErrorConstructor::callAsFunction):
        (KJS::NativeErrorConstructor::NativeErrorConstructor):
        (KJS::NativeErrorConstructor::getConstructData):
        (KJS::NativeErrorConstructor::construct):
        (KJS::NativeErrorConstructor::callAsFunction):
        (KJS::NativeErrorConstructor::mark):
        * kjs/error_object.h:
        * kjs/function.cpp:
        (KJS::JSFunction::JSFunction):
        (KJS::JSFunction::mark):
        (KJS::JSFunction::getOwnPropertySlot):
        (KJS::JSFunction::put):
        (KJS::JSFunction::deleteProperty):
        (KJS::PrototypeFunction::PrototypeFunction):
        (KJS::PrototypeReflexiveFunction::PrototypeReflexiveFunction):
        (KJS::PrototypeReflexiveFunction::mark):
        * kjs/function.h:
        * kjs/function_object.cpp:
        (KJS::functionProtoFuncToString):
        (KJS::FunctionConstructor::FunctionConstructor):
        (KJS::FunctionConstructor::getConstructData):
        (KJS::FunctionConstructor::construct):
        (KJS::FunctionConstructor::callAsFunction):
        * kjs/function_object.h:
        * kjs/internal.cpp:
        (KJS::StringObject::create):
        (KJS::JSString::toObject):
        (KJS::JSString::toThisObject):
        (KJS::JSString::getOwnPropertySlot):
        (KJS::InternalFunction::InternalFunction):
        (KJS::InternalFunction::getCallData):
        (KJS::InternalFunction::implementsHasInstance):
        * kjs/math_object.cpp:
        (KJS::MathObject::MathObject):
        (KJS::MathObject::getOwnPropertySlot):
        (KJS::MathObject::getValueProperty):
        * kjs/math_object.h:
        * kjs/number_object.cpp:
        (KJS::NumberObject::NumberObject):
        (KJS::NumberPrototype::NumberPrototype):
        (KJS::numberProtoFuncToString):
        (KJS::numberProtoFuncToLocaleString):
        (KJS::numberProtoFuncValueOf):
        (KJS::numberProtoFuncToFixed):
        (KJS::numberProtoFuncToExponential):
        (KJS::numberProtoFuncToPrecision):
        (KJS::NumberConstructor::NumberConstructor):
        (KJS::NumberConstructor::getOwnPropertySlot):
        (KJS::NumberConstructor::getValueProperty):
        (KJS::NumberConstructor::getConstructData):
        (KJS::NumberConstructor::construct):
        (KJS::NumberConstructor::callAsFunction):
        * kjs/number_object.h:
        * kjs/object.cpp:
        (KJS::JSObject::putDirectFunction):
        * kjs/object.h:
        * kjs/object_object.cpp:
        (KJS::ObjectConstructor::ObjectConstructor):
        (KJS::ObjectConstructor::getConstructData):
        (KJS::ObjectConstructor::construct):
        (KJS::ObjectConstructor::callAsFunction):
        * kjs/object_object.h:
        * kjs/regexp.cpp:
        (KJS::RegExp::RegExp):
        * kjs/regexp_object.cpp:
        (KJS::regExpProtoFuncTest):
        (KJS::regExpProtoFuncExec):
        (KJS::regExpProtoFuncCompile):
        (KJS::regExpProtoFuncToString):
        (KJS::RegExpObject::RegExpObject):
        (KJS::RegExpObject::~RegExpObject):
        (KJS::RegExpObject::getOwnPropertySlot):
        (KJS::RegExpObject::getValueProperty):
        (KJS::RegExpObject::put):
        (KJS::RegExpObject::putValueProperty):
        (KJS::RegExpObject::match):
        (KJS::RegExpObject::test):
        (KJS::RegExpObject::exec):
        (KJS::RegExpObject::getCallData):
        (KJS::RegExpObject::callAsFunction):
        (KJS::RegExpConstructorPrivate::RegExpConstructorPrivate):
        (KJS::RegExpConstructor::RegExpConstructor):
        (KJS::RegExpConstructor::performMatch):
        (KJS::RegExpMatchesArray::RegExpMatchesArray):
        (KJS::RegExpMatchesArray::~RegExpMatchesArray):
        (KJS::RegExpMatchesArray::fillArrayInstance):
        (KJS::RegExpConstructor::arrayOfMatches):
        (KJS::RegExpConstructor::getBackref):
        (KJS::RegExpConstructor::getLastParen):
        (KJS::RegExpConstructor::getLeftContext):
        (KJS::RegExpConstructor::getRightContext):
        (KJS::RegExpConstructor::getOwnPropertySlot):
        (KJS::RegExpConstructor::getValueProperty):
        (KJS::RegExpConstructor::put):
        (KJS::RegExpConstructor::putValueProperty):
        (KJS::RegExpConstructor::getConstructData):
        (KJS::RegExpConstructor::construct):
        (KJS::RegExpConstructor::callAsFunction):
        (KJS::RegExpConstructor::input):
        * kjs/regexp_object.h:
        * kjs/string_object.cpp:
        (KJS::StringObject::StringObject):
        (KJS::StringObject::getOwnPropertySlot):
        (KJS::StringObject::put):
        (KJS::StringObject::deleteProperty):
        (KJS::StringObject::getPropertyNames):
        (KJS::StringPrototype::StringPrototype):
        (KJS::StringPrototype::getOwnPropertySlot):
        (KJS::replace):
        (KJS::stringProtoFuncToString):
        (KJS::stringProtoFuncValueOf):
        (KJS::stringProtoFuncCharAt):
        (KJS::stringProtoFuncCharCodeAt):
        (KJS::stringProtoFuncConcat):
        (KJS::stringProtoFuncIndexOf):
        (KJS::stringProtoFuncLastIndexOf):
        (KJS::stringProtoFuncMatch):
        (KJS::stringProtoFuncSearch):
        (KJS::stringProtoFuncReplace):
        (KJS::stringProtoFuncSlice):
        (KJS::stringProtoFuncSplit):
        (KJS::stringProtoFuncSubstr):
        (KJS::stringProtoFuncSubstring):
        (KJS::stringProtoFuncToLowerCase):
        (KJS::stringProtoFuncToUpperCase):
        (KJS::stringProtoFuncToLocaleLowerCase):
        (KJS::stringProtoFuncToLocaleUpperCase):
        (KJS::stringProtoFuncLocaleCompare):
        (KJS::stringProtoFuncBig):
        (KJS::stringProtoFuncSmall):
        (KJS::stringProtoFuncBlink):
        (KJS::stringProtoFuncBold):
        (KJS::stringProtoFuncFixed):
        (KJS::stringProtoFuncItalics):
        (KJS::stringProtoFuncStrike):
        (KJS::stringProtoFuncSub):
        (KJS::stringProtoFuncSup):
        (KJS::stringProtoFuncFontcolor):
        (KJS::stringProtoFuncFontsize):
        (KJS::stringProtoFuncAnchor):
        (KJS::stringProtoFuncLink):
        (KJS::StringConstructor::StringConstructor):
        (KJS::StringConstructor::getConstructData):
        (KJS::StringConstructor::construct):
        (KJS::StringConstructor::callAsFunction):
        (KJS::StringConstructorFunction::StringConstructorFunction):
        (KJS::StringConstructorFunction::callAsFunction):
        * kjs/string_object.h:
        (KJS::StringObjectThatMasqueradesAsUndefined::StringObjectThatMasqueradesAsUndefined):
        * profiler/Profiler.cpp:
        (KJS::createCallIdentifier):

2008-06-15  Darin Adler  <darin@apple.com>

        Rubber stamped by Sam.

        - use JS prefix and simpler names for basic JavaScriptCore types,
          to complement JSValue and JSObject

        * JavaScriptCore.exp:
        * VM/Machine.cpp:
        (KJS::jsLess):
        (KJS::jsLessEq):
        (KJS::jsAdd):
        (KJS::callEval):
        (KJS::Machine::execute):
        (KJS::Machine::retrieveArguments):
        (KJS::Machine::retrieveCaller):
        (KJS::Machine::getCallFrame):
        (KJS::Machine::getFunctionAndArguments):
        * VM/Machine.h:
        * VM/Register.h:
        * kjs/DebuggerCallFrame.cpp:
        (KJS::DebuggerCallFrame::functionName):
        * kjs/ExecState.h:
        * kjs/JSActivation.cpp:
        (KJS::JSActivation::createArgumentsObject):
        * kjs/array_instance.cpp:
        (KJS::JSArray::checkConsistency):
        (KJS::JSArray::JSArray):
        (KJS::JSArray::~JSArray):
        (KJS::JSArray::getItem):
        (KJS::JSArray::lengthGetter):
        (KJS::JSArray::inlineGetOwnPropertySlot):
        (KJS::JSArray::getOwnPropertySlot):
        (KJS::JSArray::put):
        (KJS::JSArray::deleteProperty):
        (KJS::JSArray::getPropertyNames):
        (KJS::JSArray::increaseVectorLength):
        (KJS::JSArray::setLength):
        (KJS::JSArray::mark):
        (KJS::JSArray::sort):
        (KJS::JSArray::compactForSorting):
        (KJS::JSArray::lazyCreationData):
        (KJS::JSArray::setLazyCreationData):
        * kjs/array_instance.h:
        * kjs/array_object.cpp:
        (KJS::ArrayPrototype::ArrayPrototype):
        (KJS::ArrayPrototype::getOwnPropertySlot):
        (KJS::arrayProtoFuncToString):
        (KJS::arrayProtoFuncToLocaleString):
        (KJS::arrayProtoFuncConcat):
        (KJS::arrayProtoFuncSort):
        (KJS::ArrayObjectImp::construct):
        * kjs/array_object.h:
        * kjs/completion.h:
        * kjs/function.cpp:
        (KJS::JSFunction::JSFunction):
        (KJS::JSFunction::mark):
        (KJS::JSFunction::getCallData):
        (KJS::JSFunction::callAsFunction):
        (KJS::JSFunction::argumentsGetter):
        (KJS::JSFunction::callerGetter):
        (KJS::JSFunction::lengthGetter):
        (KJS::JSFunction::getOwnPropertySlot):
        (KJS::JSFunction::put):
        (KJS::JSFunction::deleteProperty):
        (KJS::JSFunction::getParameterName):
        (KJS::JSFunction::getConstructData):
        (KJS::JSFunction::construct):
        (KJS::IndexToNameMap::IndexToNameMap):
        (KJS::Arguments::Arguments):
        * kjs/function.h:
        * kjs/function_object.cpp:
        (KJS::functionProtoFuncToString):
        (KJS::functionProtoFuncApply):
        (KJS::FunctionObjectImp::construct):
        * kjs/internal.cpp:
        (KJS::JSString::toPrimitive):
        (KJS::JSString::getPrimitiveNumber):
        (KJS::JSString::toBoolean):
        (KJS::JSString::toNumber):
        (KJS::JSString::toString):
        (KJS::StringInstance::create):
        (KJS::JSString::toObject):
        (KJS::JSString::toThisObject):
        (KJS::JSString::lengthGetter):
        (KJS::JSString::indexGetter):
        (KJS::JSString::indexNumericPropertyGetter):
        (KJS::JSString::getOwnPropertySlot):
        (KJS::JSNumberCell::type):
        (KJS::JSNumberCell::toPrimitive):
        (KJS::JSNumberCell::getPrimitiveNumber):
        (KJS::JSNumberCell::toBoolean):
        (KJS::JSNumberCell::toNumber):
        (KJS::JSNumberCell::toString):
        (KJS::JSNumberCell::toObject):
        (KJS::JSNumberCell::toThisObject):
        (KJS::JSNumberCell::getUInt32):
        (KJS::JSNumberCell::getTruncatedInt32):
        (KJS::JSNumberCell::getTruncatedUInt32):
        (KJS::GetterSetter::mark):
        (KJS::GetterSetter::toPrimitive):
        (KJS::GetterSetter::getPrimitiveNumber):
        (KJS::GetterSetter::toBoolean):
        (KJS::GetterSetter::toNumber):
        (KJS::GetterSetter::toString):
        (KJS::GetterSetter::toObject):
        (KJS::GetterSetter::getOwnPropertySlot):
        (KJS::GetterSetter::put):
        (KJS::GetterSetter::toThisObject):
        * kjs/internal.h:
        (KJS::JSString::JSString):
        (KJS::JSString::getStringPropertySlot):
        * kjs/nodes.cpp:
        (KJS::FuncDeclNode::makeFunction):
        (KJS::FuncExprNode::makeFunction):
        * kjs/nodes.h:
        * kjs/object.cpp:
        (KJS::JSObject::put):
        (KJS::JSObject::deleteProperty):
        (KJS::JSObject::defineGetter):
        (KJS::JSObject::defineSetter):
        (KJS::JSObject::lookupGetter):
        (KJS::JSObject::lookupSetter):
        (KJS::JSObject::fillGetterPropertySlot):
        * kjs/object.h:
        (KJS::GetterSetter::GetterSetter):
        * kjs/operations.cpp:
        (KJS::equal):
        (KJS::strictEqual):
        * kjs/property_map.cpp:
        (KJS::PropertyMap::containsGettersOrSetters):
        * kjs/regexp_object.cpp:
        (KJS::RegExpMatchesArray::getOwnPropertySlot):
        (KJS::RegExpMatchesArray::put):
        (KJS::RegExpMatchesArray::deleteProperty):
        (KJS::RegExpMatchesArray::getPropertyNames):
        (KJS::RegExpMatchesArray::RegExpMatchesArray):
        (KJS::RegExpMatchesArray::fillArrayInstance):
        * kjs/string_object.cpp:
        (KJS::StringInstance::StringInstance):
        (KJS::replace):
        (KJS::stringProtoFuncReplace):
        (KJS::stringProtoFuncToLowerCase):
        (KJS::stringProtoFuncToUpperCase):
        (KJS::stringProtoFuncToLocaleLowerCase):
        (KJS::stringProtoFuncToLocaleUpperCase):
        * kjs/string_object.h:
        (KJS::StringInstance::internalValue):
        * kjs/value.cpp:
        (KJS::JSCell::getNumber):
        (KJS::JSCell::getString):
        (KJS::JSCell::getObject):
        (KJS::jsString):
        (KJS::jsOwnedString):
        * kjs/value.h:
        (KJS::JSNumberCell::JSNumberCell):
        (KJS::jsNumberCell):
        (KJS::JSValue::uncheckedGetNumber):
        * profiler/Profiler.cpp:
        (KJS::createCallIdentifier):
        (KJS::createCallIdentifierFromFunctionImp):

2008-06-15  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Alexey.
        
        - add emitUnaryOp, emitNullaryOp and emitUnaryOpNoDst; use them
        
        This removes some boilerplate code and also reduces the number of
        places that will need to be changed to do on-demand emit of
        loads (and thus support k operands).

        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitUnaryOp):
        (KJS::CodeGenerator::emitNullaryOp):
        (KJS::CodeGenerator::emitUnaryOpNoDst):
        (KJS::CodeGenerator::emitPushScope):
        * VM/CodeGenerator.h:
        (KJS::CodeGenerator::emitNewObject):
        (KJS::CodeGenerator::emitNewArray):
        (KJS::CodeGenerator::emitNot):
        (KJS::CodeGenerator::emitBitNot):
        (KJS::CodeGenerator::emitToJSNumber):
        (KJS::CodeGenerator::emitNegate):
        (KJS::CodeGenerator::emitInstanceOf):
        (KJS::CodeGenerator::emitTypeOf):
        (KJS::CodeGenerator::emitIn):
        (KJS::CodeGenerator::emitReturn):
        (KJS::CodeGenerator::emitEnd):
        (KJS::CodeGenerator::emitGetPropertyNames):

2008-06-15  Alp Toker  <alp@nuanti.com>

        Rubber-stamped by Maciej.

        Install 'jsc' application by default.

        * GNUmakefile.am:

2008-06-15  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Oliver.
        
        - rename testkjs to jsc

        * GNUmakefile.am:
        * JavaScriptCore.vcproj/JavaScriptCore.sln:
        * JavaScriptCore.vcproj/jsc: Added.
        * JavaScriptCore.vcproj/jsc/jsc.vcproj: Copied from JavaScriptCore.vcproj/testkjs/testkjs.vcproj.
        * JavaScriptCore.vcproj/testkjs: Removed.
        * JavaScriptCore.vcproj/testkjs/testkjs.vcproj: Removed.
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * jscore.bkl:
        * kjs/Shell.cpp: Copied from kjs/testkjs.cpp.
        (main):
        (printUsageStatement):
        (jscmain):
        * kjs/jsc.pro: Copied from kjs/testkjs.pro.
        * kjs/testkjs.cpp: Removed.
        * kjs/testkjs.pro: Removed.
        * tests/mozilla/expected.html:
        * tests/mozilla/js1_2/Array/tostring_1.js:
        * tests/mozilla/js1_2/Array/tostring_2.js:
        * tests/mozilla/jsDriver.pl:

2008-06-15  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Mac build fix.

        * JavaScriptCore.xcodeproj/project.pbxproj:
        * kjs/nodes.h:

2008-06-15  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Change the spelling of PrecMultiplicitave to PrecMultiplicative.

        * kjs/nodes.h:
        (KJS::MultNode::precedence):
        (KJS::DivNode::precedence):
        (KJS::ModNode::precedence):

2008-06-15  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Remove unused preprocessor macros related to exceptions in the old
        interpreter.

        * kjs/nodes.cpp:

2008-06-15  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Bug 19484: More instructions needs to use temporary registers
        <https://bugs.webkit.org/show_bug.cgi?id=19484>

        Fix codegen for all binary operations so that temporaries are used if
        necessary. This was done by making BinaryOpNode and ReverseBinaryOpNode
        subclasses of ExpressionNode, and eliminating the custom emitCode()
        methods for the individual node classes.

        This only adds 3 new instructions to SunSpider code, and there is no
        difference in SunSpider execution time.

        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitBitNot):
        (KJS::CodeGenerator::emitBinaryOp):
        * VM/CodeGenerator.h:
        * kjs/grammar.y:
        * kjs/nodes.cpp:
        (KJS::PreIncResolveNode::emitCode):
        (KJS::PreDecResolveNode::emitCode):
        (KJS::BinaryOpNode::emitCode):
        (KJS::ReverseBinaryOpNode::emitCode):
        (KJS::emitReadModifyAssignment):
        (KJS::CaseBlockNode::emitCodeForBlock):
        * kjs/nodes.h:
        (KJS::BinaryOpNode::BinaryOpNode):
        (KJS::ReverseBinaryOpNode::ReverseBinaryOpNode):
        (KJS::MultNode::):
        (KJS::DivNode::):
        (KJS::DivNode::precedence):
        (KJS::ModNode::):
        (KJS::ModNode::precedence):
        (KJS::AddNode::):
        (KJS::AddNode::precedence):
        (KJS::SubNode::):
        (KJS::SubNode::precedence):
        (KJS::LeftShiftNode::):
        (KJS::LeftShiftNode::precedence):
        (KJS::RightShiftNode::):
        (KJS::RightShiftNode::precedence):
        (KJS::UnsignedRightShiftNode::):
        (KJS::UnsignedRightShiftNode::precedence):
        (KJS::LessNode::):
        (KJS::LessNode::precedence):
        (KJS::GreaterNode::):
        (KJS::GreaterNode::precedence):
        (KJS::LessEqNode::):
        (KJS::LessEqNode::precedence):
        (KJS::GreaterEqNode::):
        (KJS::GreaterEqNode::precedence):
        (KJS::InstanceOfNode::):
        (KJS::InstanceOfNode::precedence):
        (KJS::InNode::):
        (KJS::InNode::precedence):
        (KJS::EqualNode::):
        (KJS::EqualNode::precedence):
        (KJS::NotEqualNode::):
        (KJS::NotEqualNode::precedence):
        (KJS::StrictEqualNode::):
        (KJS::StrictEqualNode::precedence):
        (KJS::NotStrictEqualNode::):
        (KJS::NotStrictEqualNode::precedence):
        (KJS::BitAndNode::):
        (KJS::BitAndNode::precedence):
        (KJS::BitOrNode::):
        (KJS::BitOrNode::precedence):
        (KJS::BitXOrNode::):
        (KJS::BitXOrNode::precedence):
        * kjs/nodes2string.cpp:
        (KJS::LessNode::streamTo):
        (KJS::GreaterNode::streamTo):
        (KJS::LessEqNode::streamTo):
        (KJS::GreaterEqNode::streamTo):
        (KJS::InstanceOfNode::streamTo):
        (KJS::InNode::streamTo):
        (KJS::EqualNode::streamTo):
        (KJS::NotEqualNode::streamTo):
        (KJS::StrictEqualNode::streamTo):
        (KJS::NotStrictEqualNode::streamTo):
        (KJS::BitAndNode::streamTo):
        (KJS::BitXOrNode::streamTo):
        (KJS::BitOrNode::streamTo):

2008-06-14  Darin Adler  <darin@apple.com>

        Rubber stamped by Sam.

        - rename a bunch of local symbols within the regular expression code to
          follow our usual coding style, and do a few other name tweaks

        * pcre/pcre_compile.cpp:
        (CompileData::CompileData):
        (checkEscape):
        (readRepeatCounts):
        (compileBranch):
        (compileBracket):
        (calculateCompiledPatternLength):
        (returnError):
        (jsRegExpCompile):
        * pcre/pcre_exec.cpp:
        (MatchStack::MatchStack):
        (MatchStack::canUseStackBufferForNextFrame):
        (MatchStack::popCurrentFrame):
        (match):
        (tryFirstByteOptimization):
        (tryRequiredByteOptimization):
        (jsRegExpExecute):
        * pcre/pcre_internal.h:

2008-06-14  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Darin.

        Remove redundant uses of get().

        * kjs/nodes.cpp:
        (KJS::BracketAccessorNode::emitCode):
        (KJS::AddNode::emitCode):
        (KJS::SubNode::emitCode):
        (KJS::ReadModifyResolveNode::emitCode):
        (KJS::AssignDotNode::emitCode):
        (KJS::ReadModifyDotNode::emitCode):
        (KJS::AssignBracketNode::emitCode):
        (KJS::ReadModifyBracketNode::emitCode):

2008-06-14  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Make code generation not use a temporary for the left-hand side of an
        expression if the right-hand side is a local variable.

        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::isLocal):
        * VM/CodeGenerator.h:
        (KJS::CodeGenerator::leftHandSideNeedsCopy):
        (KJS::CodeGenerator::emitNodeForLeftHandSide):
        * kjs/nodes.cpp:
        (KJS::ResolveNode::isPure):
        (KJS::BracketAccessorNode::emitCode):
        (KJS::AddNode::emitCode):
        (KJS::SubNode::emitCode):
        (KJS::ReadModifyResolveNode::emitCode):
        (KJS::AssignDotNode::emitCode):
        (KJS::ReadModifyDotNode::emitCode):
        (KJS::AssignBracketNode::emitCode):
        (KJS::ReadModifyBracketNode::emitCode):
        * kjs/nodes.h:
        (KJS::ExpressionNode::):
        (KJS::BooleanNode::):
        (KJS::NumberNode::):
        (KJS::StringNode::):

2008-06-14  Darin Adler  <darin@apple.com>

        Reviewed by Sam.

        - more of https://bugs.webkit.org/show_bug.cgi?id=17257
          start ref counts at 1 instead of 0 for speed

        * kjs/nodes.cpp:
        (KJS::ParserRefCounted::hasOneRef): Added. Replaces refcount.
        * kjs/nodes.h: Replaced refcount with hasOneRef.

        * wtf/ListRefPtr.h:
        (WTF::ListRefPtr::~ListRefPtr): Changed to use hasOneRef instead of
        refcount, so this class can be used with the RefCounted template.

        * wtf/RefCounted.h:
        (WTF::RefCounted::hasOneRef): Made const, since there's no reason for
        it to be non-const.

2008-06-14  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Oliver.
        
        - initialize local vars as side effect of call instead of in bytecode
        1.004x speedup on SunSpider.

        This removes just the dispatch overhead for these loads - in the
        future, dead store elimination might be able to eliminate them
        entirely.
        
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::CodeGenerator): For function blocks, don't
        emit loads of undefined for var initialization.
        * VM/Machine.cpp:
        (KJS::slideRegisterWindowForCall): Instead, initialize locals
        as part of the call.

2008-06-14  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Remove helper functions in the parser that are no longer needed.

        * kjs/grammar.y:

2008-06-14  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Bug 19484: More instructions needs to use temporary registers
        <https://bugs.webkit.org/show_bug.cgi?id=19484>

        Make code generation for AddNode and SubNode use temporaries when
        necessary.

        * kjs/grammar.y:
        * kjs/nodes.cpp:
        (KJS::AddNode::emitCode):
        (KJS::SubNode::emitCode):
        * kjs/nodes.h:
        (KJS::AddNode::):
        (KJS::SubNode::):

2008-06-13  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Combine TrueNode and FalseNode to make BooleanNode, and remove the
        unused class PlaceholderTrueNode.

        * kjs/grammar.y:
        * kjs/nodes.cpp:
        (KJS::BooleanNode::emitCode):
        * kjs/nodes.h:
        (KJS::BooleanNode::):
        (KJS::BooleanNode::precedence):
        * kjs/nodes2string.cpp:
        (KJS::BooleanNode::streamTo):

2008-06-13  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Eliminate the use of temporaries to store the left hand side of an
        expression when the right hand side is a constant. This slightly
        improves the generated bytecode for a few SunSpider tests, but it is
        mostly in preparation for fixing

        Bug 19484: More instructions needs to use temporary registers
        <https://bugs.webkit.org/show_bug.cgi?id=19484>

        * VM/CodeGenerator.h:
        (KJS::CodeGenerator::leftHandSideNeedsCopy):
        (KJS::CodeGenerator::emitNodeForLeftHandSide):
        * kjs/nodes.cpp:
        (KJS::BracketAccessorNode::emitCode):
        (KJS::ReadModifyResolveNode::emitCode):
        (KJS::AssignDotNode::emitCode):
        (KJS::ReadModifyDotNode::emitCode):
        (KJS::AssignBracketNode::emitCode):
        (KJS::ReadModifyBracketNode::emitCode):
        * kjs/nodes.h:
        (KJS::ExpressionNode::):
        (KJS::FalseNode::):
        (KJS::TrueNode::):
        (KJS::NumberNode::):
        (KJS::StringNode::):

2008-06-13  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Oliver.
        
        - prettify opcode stats output
        
        I changed things to be a bit more aligned, also there is a new
        section listing most common opcodes and most common sequences that
        include them.

        * VM/Opcode.cpp:
        (KJS::OpcodeStats::~OpcodeStats):
        * VM/Opcode.h:

2008-06-13  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geoff.

        <rdar://problem/5969992> JSProfiler: Remove the recursion limit in the
        profiler.
        - Remove recursion from exclude().  This leaves only focus() to fix.

        * JavaScriptCore.exp: Change the signatures of the exported functions.
        * profiler/Profile.cpp:
        (KJS::Profile::forEach): I added a traverseNextNodePreOrder() function
        and so needed to distinguish the other function by labeling it
        traverseNextNodePostOrder().
        (KJS::Profile::exclude): All new exclude that iteratively walks the tree
        * profiler/Profile.h:
        (KJS::Profile::focus): Add a null check for m_head.
        * profiler/ProfileNode.cpp:
        (KJS::ProfileNode::traverseNextNodePostOrder): Renamed
        (KJS::ProfileNode::traverseNextNodePreOrder): Walks the tree in pre-
        order, where the parent is processed before the children.
        (KJS::ProfileNode::setTreeVisible): Iterate over the sub-tree and set
        all of the nodes visible value.  This changes another function that used
        recursion.
        (KJS::ProfileNode::exclude): Remove recursion from this function.
        Because we now check for m_visible and we are walking the tree in pre-
        order we do not need to check if an excluded node is in an excluded
        sub-tree.
        * profiler/ProfileNode.h: Added specific selfTime functions to
        facilitate exclude().
        (KJS::ProfileNode::setSelfTime):
        (KJS::ProfileNode::setActualSelfTime):
        (KJS::ProfileNode::setVisibleSelfTime):

2008-06-12  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - https://bugs.webkit.org/show_bug.cgi?id=19434
          speed up SunSpider by avoiding some string boxing

        Speeds up SunSpider by 1.1%.

        Optimized code path for getting built-in properties from strings -- avoid
        boxing with a string object in that case. We can make further changes to avoid
        even more boxing, but this change alone is a win.

        * API/JSCallbackObjectFunctions.h:
        (KJS::JSCallbackObject::staticValueGetter): Use isObject instead of inherits
        in asssert, since the type of slotBase() is now JSValue, not JSObject.
        (KJS::JSCallbackObject::staticFunctionGetter): Ditto.
        (KJS::JSCallbackObject::callbackGetter): Ditto.

        * kjs/internal.cpp:
        (KJS::StringImp::getPrimitiveNumber): Updated for change of data member name.
        (KJS::StringImp::toBoolean): Ditto.
        (KJS::StringImp::toNumber): Ditto.
        (KJS::StringImp::toString): Ditto.
        (KJS::StringInstance::create): Added; avoids a bit of cut and paste code.
        (KJS::StringImp::toObject): Use StringInstance::create.
        (KJS::StringImp::toThisObject): Ditto.
        (KJS::StringImp::lengthGetter): Added. Replaces the getter that used to live in
        the StringInstance class.
        (KJS::StringImp::indexGetter): Ditto.
        (KJS::StringImp::indexNumericPropertyGetter): Ditto.
        (KJS::StringImp::getOwnPropertySlot): Added. Deals with built in properties of
        the string class without creating a StringInstance.

        * kjs/internal.h:
        (KJS::StringImp::getStringPropertySlot): Added. To be used by both the string
        and string object getOwnPropertySlot function.

        * kjs/lookup.h:
        (KJS::staticFunctionGetter): Updated since slotBase() is now a JSValue rather
        than a JSObject.

        * kjs/object.h: Removed PropertySlot::slotBase() function, which can now move
        back into property_slot.h where it belongs since it doesn't have to cast to
        JSObject*.

        * kjs/property_slot.cpp:
        (KJS::PropertySlot::functionGetter): Updated since slot.slotBase() is now a JSValue*
        instead of JSObject*. setGetterSlot still guarantees the base is a JSObject*.
        * kjs/property_slot.h:
        (KJS::PropertySlot::PropertySlot): Changed base to JSValue* intead of JSCell*.
        (KJS::PropertySlot::setStaticEntry): Ditto.
        (KJS::PropertySlot::setCustom): Ditto.
        (KJS::PropertySlot::setCustomIndex): Ditto.
        (KJS::PropertySlot::setCustomNumeric): Ditto.
        (KJS::PropertySlot::slotBase): Moved inline here since it no longer involves a
        downcast to JSObject*.
        (KJS::PropertySlot::setBase): Changed to JSValue*.

        * kjs/string_object.cpp:
        (KJS::StringInstance::getOwnPropertySlot): Changed to use getStringPropertySlot
        instead of coding the properties here. This allows sharing the code with StringImp.

        * kjs/string_object.h: Removed inlineGetOwnPropertySlot, lengthGetter, and indexGetter.
        Made one of the constructors protected.

        * kjs/value.h: Made getOwnPropertySlot private in the JSCell class -- this is better
        since it's not the real JSObject getOwnPropertySlot semantic and most callers shouldn't
        use it.

2008-06-12  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Maciej.

        Preparation to making JavaScript heap per-thread.

        * kjs/collector.cpp:
        (KJS::Collector::collect):
        * kjs/collector.h:
        (KJS::Collector::markListSet):
        The collector now holds the list of protected lists itself, to be made per-instance.

        * kjs/list.h: Changed to hold a pointer to a mark set this list is in, if any.
        (KJS::List::List): Explicitly initialize m_size with zero, as m_vector.size() is
        guaranteed to be such anyway.
        (KJS::List::append): Changed the fast case to only be executed as long as inline buffer
        is used, because otherwise, we now do more expensive checks.

        * kjs/list.cpp:
        (KJS::List::markLists): Renamed from markProtectedListsSlowCase, made it take the list set
        as a parameter.
        (KJS::List::slowAppend): If a non-immediate value is appended, the list needs to be added
        to an appropriate Heap's protected list. For now, a static Collector::markListSet() is
        used, but the code is layed out in preparation to making the switch to multiple heaps.

        * JavaScriptCore.exp: Updated export list.

2008-06-12  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Bug 19510: CodeBlock::needsFullScopeChain not always set for global code
        <https://bugs.webkit.org/show_bug.cgi?id=19510>

        This fixes the symptoms by using CodeGenerator::m_codeType to determine
        when to use temporaries instead of CodeBlock::needsFullScopeChain, but
        it does not fix the problem itself.

        * VM/CodeGenerator.h:
        (KJS::CodeGenerator::leftHandSideNeedsCopy):

2008-06-11  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Bug 19498: REGRESSION (r34497): crash while loading GMail
        <https://bugs.webkit.org/show_bug.cgi?id=19498>

        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::emitJumpIfTrueMayCombine):
        (KJS::CodeGenerator::emitJumpIfTrue):
        * VM/CodeGenerator.h:
        * kjs/nodes.cpp:
        (KJS::DoWhileNode::emitCode):
        (KJS::WhileNode::emitCode):
        (KJS::ForNode::emitCode):
        (KJS::CaseBlockNode::emitCodeForBlock):

2008-06-11  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - a little bit of cleanup and prep for some upcoming optimizations

        * JavaScriptCore.exp: Re-sorted this file (with sort command line tool).
        * VM/CodeBlock.cpp:
        (KJS::CodeBlock::dump): Fixed printf to avoid warnings -- to use %lu we
        need to make sure the type is unsigned long.
        * kjs/object.cpp:
        (KJS::Error::create): Eliminated unused error names array, and also put
        the strings into the code since there was already a switch statment.
        This also avoids having to contemplate a hypothetical access past the
        end of the array.
        * kjs/object.h: Got rid of errorNames.
        * kjs/property_slot.cpp: Deleted unused ungettableGetter.
        * kjs/property_slot.h: Ditto.
        * wtf/AlwaysInline.h: Added LIKELY alongside UNLIKELY.

2008-06-11  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Darin.

        Bug 19457: Create fused opcodes for tests and conditional jumps
        <https://bugs.webkit.org/show_bug.cgi?id=19457>

        Add a new jless instruction, and modify the code generator to emit it
        instead of the pair (less, jtrue).

        Gives a 3.6% improvement on SunSpider.

        * VM/CodeBlock.cpp:
        (KJS::CodeBlock::dump):
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::CodeGenerator):
        (KJS::CodeGenerator::emitOpcode):
        (KJS::CodeGenerator::retrieveLastBinaryOp):
        (KJS::CodeGenerator::rewindBinaryOp):
        (KJS::CodeGenerator::emitJump):
        (KJS::CodeGenerator::emitJumpIfTrue):
        (KJS::CodeGenerator::emitJumpIfFalse):
        (KJS::CodeGenerator::emitMove):
        (KJS::CodeGenerator::emitNot):
        (KJS::CodeGenerator::emitEqual):
        (KJS::CodeGenerator::emitNotEqual):
        (KJS::CodeGenerator::emitStrictEqual):
        (KJS::CodeGenerator::emitNotStrictEqual):
        (KJS::CodeGenerator::emitLess):
        (KJS::CodeGenerator::emitLessEq):
        (KJS::CodeGenerator::emitPreInc):
        (KJS::CodeGenerator::emitPreDec):
        (KJS::CodeGenerator::emitPostInc):
        (KJS::CodeGenerator::emitPostDec):
        (KJS::CodeGenerator::emitToJSNumber):
        (KJS::CodeGenerator::emitNegate):
        (KJS::CodeGenerator::emitAdd):
        (KJS::CodeGenerator::emitMul):
        (KJS::CodeGenerator::emitDiv):
        (KJS::CodeGenerator::emitMod):
        (KJS::CodeGenerator::emitSub):
        (KJS::CodeGenerator::emitLeftShift):
        (KJS::CodeGenerator::emitRightShift):
        (KJS::CodeGenerator::emitUnsignedRightShift):
        (KJS::CodeGenerator::emitBitAnd):
        (KJS::CodeGenerator::emitBitXOr):
        (KJS::CodeGenerator::emitBitOr):
        (KJS::CodeGenerator::emitBitNot):
        (KJS::CodeGenerator::emitInstanceOf):
        (KJS::CodeGenerator::emitTypeOf):
        (KJS::CodeGenerator::emitIn):
        (KJS::CodeGenerator::emitLoad):
        (KJS::CodeGenerator::emitNewObject):
        (KJS::CodeGenerator::emitNewArray):
        (KJS::CodeGenerator::emitResolve):
        (KJS::CodeGenerator::emitGetScopedVar):
        (KJS::CodeGenerator::emitPutScopedVar):
        (KJS::CodeGenerator::emitResolveBase):
        (KJS::CodeGenerator::emitResolveWithBase):
        (KJS::CodeGenerator::emitResolveFunction):
        (KJS::CodeGenerator::emitGetById):
        (KJS::CodeGenerator::emitPutById):
        (KJS::CodeGenerator::emitPutGetter):
        (KJS::CodeGenerator::emitPutSetter):
        (KJS::CodeGenerator::emitDeleteById):
        (KJS::CodeGenerator::emitGetByVal):
        (KJS::CodeGenerator::emitPutByVal):
        (KJS::CodeGenerator::emitDeleteByVal):
        (KJS::CodeGenerator::emitPutByIndex):
        (KJS::CodeGenerator::emitNewFunction):
        (KJS::CodeGenerator::emitNewRegExp):
        (KJS::CodeGenerator::emitNewFunctionExpression):
        (KJS::CodeGenerator::emitCall):
        (KJS::CodeGenerator::emitReturn):
        (KJS::CodeGenerator::emitEnd):
        (KJS::CodeGenerator::emitConstruct):
        (KJS::CodeGenerator::emitPushScope):
        (KJS::CodeGenerator::emitPopScope):
        (KJS::CodeGenerator::emitDebugHook):
        (KJS::CodeGenerator::emitComplexJumpScopes):
        (KJS::CodeGenerator::emitJumpScopes):
        (KJS::CodeGenerator::emitNextPropertyName):
        (KJS::CodeGenerator::emitGetPropertyNames):
        (KJS::CodeGenerator::emitCatch):
        (KJS::CodeGenerator::emitThrow):
        (KJS::CodeGenerator::emitNewError):
        (KJS::CodeGenerator::emitJumpSubroutine):
        (KJS::CodeGenerator::emitSubroutineReturn):
        * VM/CodeGenerator.h:
        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):
        * VM/Opcode.cpp:
        * VM/Opcode.h:

2008-06-11  Darin Adler  <darin@apple.com>

        Reviewed by Alexey.

        - fix https://bugs.webkit.org/show_bug.cgi?id=19442
          JavaScript array implementation doesn't maintain m_numValuesInVector when sorting

        * kjs/array_instance.cpp:
        (KJS::ArrayInstance::checkConsistency): Added. Empty inline version for when
        consistency checks are turned off.
        (KJS::ArrayInstance::ArrayInstance): Check consistency after construction.
        (KJS::ArrayInstance::~ArrayInstance): Check consistency before destruction.
        (KJS::ArrayInstance::put): Check consistency before and after.
        (KJS::ArrayInstance::deleteProperty): Ditto.
        (KJS::ArrayInstance::setLength): Ditto.
        (KJS::compareByStringPairForQSort): Use typedef for clarity.
        (KJS::ArrayInstance::sort): Check consistency before and after. Also broke the loop
        to set up sorting into two separate passes. Added FIXMEs about various exception
        safety issues. Added code to set m_numValuesInVector after sorting.
        (KJS::ArrayInstance::compactForSorting): Ditto.

        * kjs/array_instance.h: Added a definition of an enum for the types of consistency
        check and a declaration of the consistency checking function.

2008-06-10  Kevin Ollivier  <kevino@theolliviers.com>

        wx build fix. Link against libedit on Mac since HAVE(READLINE) is defined there.

        * jscore.bkl:

2008-06-10  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        https://bugs.webkit.org/show_bug.cgi?id=16503
        match limit takes at least 13% of the time on the SunSpider regexp-dna test

        Make the limit test slightly more efficient. It is not clear how much of a win it is,
        as the improvement on regexp-dna varies from 2.3% to 0.6% depending on what revision I
        apply the patch to. Today, the win on regexp-dna was minimal, but the total win was whopping
        0.5%, due to random code generation changes.

        * pcre/pcre_exec.cpp: (match): Avoid loading a constant on each iteration.

2008-06-09  Alp Toker  <alp@nuanti.com>

        gcc3/autotools build fix. Add explicit -O2 -fno-strict-aliasing to
        each of the tools since these are no longer set globally.

        * GNUmakefile.am:

2008-06-09  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Sam.

        Add an include for readline/history.h to fix the build for Darwin users
        with the GNU readline library installed. Also, clean up the style of
        the HAVE(READLINE) check.

        * kjs/testkjs.cpp:
        (runInteractive):

2008-06-09  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Darin.

        Bug 17531: Add interactive mode to testkjs
        <https://bugs.webkit.org/show_bug.cgi?id=17531>

        This is a cleaned up version of Sam's earlier patch to add an
        interactive mode to testkjs.

        Readline support is only enabled on Darwin platforms for now, but
        other ports can enable it by defining HAVE_READLINE in kjs/config.h.

        * JavaScriptCore.xcodeproj/project.pbxproj:
        * kjs/config.h:
        * kjs/testkjs.cpp:
        (Options::Options):
        (runWithScripts):
        (runInteractive):
        (printUsageStatement):
        (parseArguments):
        (kjsmain):

2008-06-08  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Darin.

        Bug 19346: REGRESSION: Mootools 1.2 Class inheritance broken in post-SquirrelFish merge
        <https://bugs.webkit.org/show_bug.cgi?id=19346>

        A check for whether a function's caller is eval code accidentally included
        the case where the caller's caller is native code. Add a CodeType field to
        CodeBlock and use this for the eval caller test instead.

        * VM/CodeBlock.h:
        (KJS::CodeBlock::CodeBlock):
        (KJS::ProgramCodeBlock::ProgramCodeBlock):
        (KJS::EvalCodeBlock::EvalCodeBlock):
        * VM/Machine.cpp:
        (KJS::getCallerFunctionOffset):
        * kjs/nodes.cpp:
        (KJS::FunctionBodyNode::generateCode):
        (KJS::ProgramNode::generateCode):

2008-06-07  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Dan Bernstein.

        Bug 17928: testkjs shouldn't require "-f"
        <https://bugs.webkit.org/show_bug.cgi?id=17928>

        * kjs/testkjs.cpp:
        (printUsageStatement):
        (parseArguments):

2008-06-07  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Eric.

        Bug 17548: JavaScriptCore print(a, b) differs from Spidermonkey Behavior
        <https://bugs.webkit.org/show_bug.cgi?id=17548>

        * kjs/testkjs.cpp:
        (functionPrint):

2008-06-07  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Sam.

        Bug 17547: JavaScriptCore print() differs from Spidermonkey Behavior
        <https://bugs.webkit.org/show_bug.cgi?id=17547>

        * kjs/testkjs.cpp:
        (functionPrint):

2008-06-07  Alexey Proskuryakov  <ap@webkit.org>

        More build fixes.

        * kjs/JSGlobalData.cpp: Fixed an included file name for case-sensitive file systems, fixed
        JSGlobalData::threadInstance() for non-multithreaded builds.

2008-06-07  Alexey Proskuryakov  <ap@webkit.org>

        Build fix - actually adding JSGlobalData.cpp to non-Mac builds!

        * GNUmakefile.am:
        * JavaScriptCore.pri:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCoreSources.bkl:

2008-06-07  Alexey Proskuryakov  <ap@webkit.org>

        Try to fix Gtk/gcc 4.3 build.

        * kjs/JSGlobalData.h: Include ustring.h instead of forward-declaring UString::Rep.

2008-06-06  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        Combine per-thread objects into one, to make it easier to support legacy clients (for
        which they shouldn't be really per-thread).

        No change on SunSpider total.

        * JavaScriptCore.xcodeproj/project.pbxproj: Added JSGlobalData.{h,cpp}

        * kjs/JSGlobalData.cpp: Added.
        (KJS::JSGlobalData::JSGlobalData):
        (KJS::JSGlobalData::~JSGlobalData):
        (KJS::JSGlobalData::threadInstance):
        * kjs/JSGlobalData.h: Added.
        This class encapsulates all data that should be per-thread (or shared between legacy clients).
        It will also keep a Heap pointer, but right now, Heap (Collector) methods are all static.

        * kjs/identifier.h:
        (KJS::Identifier::Identifier):
        Added a constructor explicitly taking JSGlobalData to access IdentifierTable. Actually,
        all of them should, but this will be a separate patch.

        * kjs/identifier.cpp:
        (KJS::IdentifierTable::literalTable):
        (KJS::createIdentifierTable):
        (KJS::deleteIdentifierTable):
        (KJS::Identifier::add):
        (KJS::Identifier::addSlowCase):
        Combined IdentifierTable and LiteralIdentifierTable into a single class for simplicity.

        * kjs/grammar.y: kjsyyparse now takes JSGlobalData, not just a Lexer.

        * kjs/nodes.cpp:
        (KJS::Node::Node):
        (KJS::EvalFunctionCallNode::emitCode):
        (KJS::ScopeNode::ScopeNode):
        Changed to access Lexer and Parser via JSGlobalData::threadInstance(). This is also a
        temporary measure, they will need to use JSGlobalData explicitly.

        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::CodeGenerator):
        * VM/CodeGenerator.h:
        * VM/Machine.cpp:
        (KJS::callEval):
        * kjs/CommonIdentifiers.cpp:
        (KJS::CommonIdentifiers::CommonIdentifiers):
        * kjs/CommonIdentifiers.h:
        * kjs/DebuggerCallFrame.cpp:
        (KJS::DebuggerCallFrame::evaluate):
        * kjs/ExecState.cpp:
        (KJS::ExecState::ExecState):
        * kjs/ExecState.h:
        (KJS::ExecState::globalData):
        (KJS::ExecState::identifierTable):
        (KJS::ExecState::propertyNames):
        (KJS::ExecState::emptyList):
        (KJS::ExecState::lexer):
        (KJS::ExecState::parser):
        (KJS::ExecState::arrayTable):
        (KJS::ExecState::dateTable):
        (KJS::ExecState::mathTable):
        (KJS::ExecState::numberTable):
        (KJS::ExecState::RegExpImpTable):
        (KJS::ExecState::RegExpObjectImpTable):
        (KJS::ExecState::stringTable):
        * kjs/InitializeThreading.cpp:
        (KJS::initializeThreadingOnce):
        * kjs/JSGlobalObject.cpp:
        (KJS::JSGlobalObject::init):
        * kjs/JSGlobalObject.h:
        (KJS::JSGlobalObject::JSGlobalObjectData::JSGlobalObjectData):
        (KJS::JSGlobalObject::head):
        (KJS::JSGlobalObject::globalData):
        * kjs/Parser.cpp:
        (KJS::Parser::parse):
        * kjs/Parser.h:
        * kjs/function.cpp:
        (KJS::FunctionImp::getParameterName):
        (KJS::IndexToNameMap::unMap):
        (KJS::globalFuncEval):
        * kjs/function_object.cpp:
        (KJS::FunctionObjectImp::construct):
        * kjs/interpreter.cpp:
        (KJS::Interpreter::checkSyntax):
        (KJS::Interpreter::evaluate):
        * kjs/lexer.cpp:
        (kjsyylex):
        * kjs/lexer.h:
        * kjs/testkjs.cpp:
        (prettyPrintScript):
        Updated for the above changes. Most of threadInstance uses here will need to be replaced with
        explicitly passed pointers to support legacy JSC clients.

        * JavaScriptCore.exp: Removed KJS::parser().

2008-06-06  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Bug 19424: Add support for logging opcode pair counts
        <https://bugs.webkit.org/show_bug.cgi?id=19424>

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):
        * VM/Opcode.cpp:
        (KJS::OpcodeStats::OpcodeStats):
        (KJS::compareOpcodeIndices):
        (KJS::compareOpcodePairIndices):
        (KJS::OpcodeStats::~OpcodeStats):
        (KJS::OpcodeStats::recordInstruction):
        (KJS::OpcodeStats::resetLastInstruction):
        * VM/Opcode.h:

2008-06-06  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Adam.

        <rdar://problem/5969992> JSProfiler: Remove the recursion limit in the
        profiler.
        - Change the remaining functions that do not take arguments, from using
        recursion to using iteration.

        * JavaScriptCore.exp:
        * profiler/Profile.cpp:
        (KJS::stopProfiling):
        (KJS::restoreAll):
        (KJS::Profile::stopProfiling): Use foreach instead of recursion.
        (KJS::Profile::restoreAll): Ditto.
        * profiler/Profile.h:
        * profiler/ProfileNode.cpp: Remove recursion.
        (KJS::ProfileNode::stopProfiling):
        (KJS::ProfileNode::restore):
        * profiler/ProfileNode.h:

2008-06-05  Oliver Hunt  <oliver@apple.com>

        Reviewed by Alexey.

        Fix Greater and GreaterEq nodes to emit code for the left
        and right sub-expressions in the correct order.

        * kjs/nodes.cpp:
        (KJS::GreaterNode::emitCode):
        (KJS::GreaterEqNode::emitCode):

2008-06-05  Antti Koivisto  <antti@apple.com>

        Reviewed by Alp Toker.
        
        Fix whitespaces.

        * kjs/collector.cpp:
        (KJS::getPlatformThreadRegisters):

2008-06-05  Antti Koivisto  <antti@apple.com>

        Reviewed by Darin.
        
        Support compiling JavaScriptCore for ARM.

        * kjs/collector.cpp:
        (KJS::getPlatformThreadRegisters):
        (KJS::otherThreadStackPointer):

2008-06-05  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Jon.

        - Name changes.

        * JavaScriptCore.exp:
        * profiler/Profile.cpp:
        (KJS::Profile::Profile):
        (KJS::Profile::stopProfiling):
        (KJS::Profile::didExecute):
        (KJS::Profile::forEach):
        (KJS::Profile::debugPrintData):
        (KJS::Profile::debugPrintDataSampleStyle):
        * profiler/Profile.h:
        (KJS::Profile::callTree):
        (KJS::Profile::totalTime):
        (KJS::Profile::sortTotalTimeDescending):
        (KJS::Profile::sortTotalTimeAscending):
        (KJS::Profile::sortSelfTimeDescending):
        (KJS::Profile::sortSelfTimeAscending):
        (KJS::Profile::sortCallsDescending):
        (KJS::Profile::sortCallsAscending):
        (KJS::Profile::sortFunctionNameDescending):
        (KJS::Profile::sortFunctionNameAscending):
        (KJS::Profile::focus):
        (KJS::Profile::exclude):
        (KJS::Profile::restoreAll):

2008-06-05  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Stephanie Lewis.

        Added the -fno-move-loop-invariants flag to the pcre_exec.cpp build, to
        tell GCC not to perform loop invariant motion, since GCC's loop
        invariant motion doesn't do very well with computed goto code.
        
        SunSpider reports no change.

2008-06-05  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Stephanie Lewis.
        
        Added the -fno-tree-pre flag to the Machine.cpp build, to tell GCC not
        to perform Partial Redundancy Elimination (PRE) on trees in Machine.cpp,
        since GCC's PRE doesn't do very well with computed goto code.
        
        SunSpider reports a .7% speedup.
        
2008-06-05  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Stephanie Lewis (or maybe the other way around).
        
        Minor change to PCRE to help out certain compilers.
        
        SunSpider reports no change, maybe a small speedup.

        * pcre/pcre_exec.cpp:
        (match): Use instructionPtr++ a little less, to avoid confusing the
        optimizer.

2008-06-05  Alexey Proskuryakov  <ap@webkit.org>

        Re-landing an independent part of a previously rolled out threading patch.

        * wtf/ThreadSpecific.h: Make sure to initialize POD thread-specific varaibles, too
        (replaced "new T" with "new T()").

2008-06-05  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Hyatt.
        
        - force inlining of a template function that only has one call site per specialization
        1.3% speedup on SunSpider

        * kjs/collector.cpp:
        (KJS::Collector::heapAllocate): This template function is only
        called from allocate() and allocateNumber() (once per
        specialization) and the extra call overhead for GC allocation
        shows up, so force inlining.

2008-06-05  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Alexey and Oliver.
        
        - remove profiler fetch hack
        I measure an 0.5% progression from this, others show a wash. It seems not needed any more.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):

2008-06-05  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Bug 19400: subscript operator does not protect base when necessary
        <https://bugs.webkit.org/show_bug.cgi?id=19400>

        Use a temporary for the base in BracketAccessorNode if the subscript
        might possibly modify it.

        * kjs/grammar.y:
        * kjs/nodes.cpp:
        (KJS::BracketAccessorNode::emitCode):
        * kjs/nodes.h:
        (KJS::BracketAccessorNode::):

2008-06-04  Sam Weinig  <sam@webkit.org>

        Reviewed by Maciej Stachowiak.

        Big cleanup of formatting and whitespace.

2008-06-04  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Oliver.

        Add an option to dump statistics on executed instructions.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):
        * VM/Opcode.cpp:
        (KJS::OpcodeStats::~OpcodeStats):
        (KJS::OpcodeStats::recordInstruction):
        * VM/Opcode.h:

2008-06-04  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geoff.

        <rdar://problem/5969992> JSProfiler: Remove the recursion limit in the
        profiler.
        - This patch removes the use of recursion for the sort functions.

        * JavaScriptCore.exp: Change the signatures of the functions being
        exported.
        * profiler/Profile.cpp:
        (KJS::Profile::sort): This generic function will accept any of the
        static sort functions and apply them to the whole tree.
        * profiler/Profile.h: All of the sorting functions now call the new
        sort() function.
        (KJS::Profile::sortTotalTimeDescending):
        (KJS::Profile::sortTotalTimeAscending):
        (KJS::Profile::sortSelfTimeDescending):
        (KJS::Profile::sortSelfTimeAscending):
        (KJS::Profile::sortCallsDescending):
        (KJS::Profile::sortCallsAscending):
        (KJS::Profile::sortFunctionNameDescending):
        (KJS::Profile::sortFunctionNameAscending):
        * profiler/ProfileNode.cpp:
        (KJS::ProfileNode::ProfileNode): m_head used to point to the head node
        if this was the head node.  It now points to null to make iteration easy
        (KJS::ProfileNode::willExecute): Now must check if m_head is null, this
        check used to happend in the constructor.
        (KJS::ProfileNode::stopProfiling): Again the check is slightly different
        to determine if this is the head.
        (KJS::ProfileNode::traverseNextNode): This function returns the next
        node in post order.
        (KJS::ProfileNode::sort): This generic function will sort according to
        the comparator passed in, then reset the children pointers to macth the
        new order.
        * profiler/ProfileNode.h: The sorting function were removed from the
        definition file and instead use the new generic sort() function
        (KJS::ProfileNode::totalPercent): because the head can now be empty we
        need to check here too for the head node.
        (KJS::ProfileNode::selfPercent): Ditto
        (KJS::ProfileNode::firstChild): This function is necessary for the 
        iterative algorithm in Profile.cpp.
        (KJS::ProfileNode::sortTotalTimeDescending):
        (KJS::ProfileNode::sortTotalTimeAscending):
        (KJS::ProfileNode::sortSelfTimeDescending):
        (KJS::ProfileNode::sortSelfTimeAscending):
        (KJS::ProfileNode::sortCallsDescending):
        (KJS::ProfileNode::sortCallsAscending):
        (KJS::ProfileNode::sortFunctionNameDescending):
        (KJS::ProfileNode::sortFunctionNameAscending):
        (KJS::ProfileNode::childrenBegin):
        (KJS::ProfileNode::childrenEnd):
        (KJS::ProfileNode::totalTimeDescendingComparator):
        (KJS::ProfileNode::totalTimeAscendingComparator):
        (KJS::ProfileNode::selfTimeDescendingComparator):
        (KJS::ProfileNode::selfTimeAscendingComparator):
        (KJS::ProfileNode::callsDescendingComparator):
        (KJS::ProfileNode::callsAscendingComparator):
        (KJS::ProfileNode::functionNameDescendingComparator):
        (KJS::ProfileNode::functionNameAscendingComparator):

2008-06-04  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        Fix JSClassCreate to work with old JSCore API threading model.

        No change on SunSpider.

        * API/JSClassRef.cpp: (OpaqueJSClass::OpaqueJSClass): Since JSClass is constructed without
        a context, there is no way for it to create Identifiers.
        Also, added initializeThreading(), just for good measure.

        * API/JSCallbackObjectFunctions.h: (KJS::::getPropertyNames): Make an Identifier out of the
        string here, because propertyNames.add() needs that.

        * kjs/identifier.cpp:
        * kjs/identifier.h:
        (KJS::Identifier::equal):
        * kjs/ustring.cpp:
        (KJS::equal):
        Moved equal() from identifier.h to ustring.h, because it's not really about Identifiers,
        and to make it possible to use it from StrHash.
        Include StrHash.h from ustring.h to avoid having the behavior depend on headers that happen
        to be included.

        * wtf/StrHash.h: Removed.
        * kjs/ustring.h: Made RefPtr<UString::Rep> use the same default hash as UString::Rep* (it
        used to default to pointer equality). Moved the whole StrHash header into ustring.h.

        * JavaScriptCore.exp: Export equal() for WebCore use (this StrHash is used in c_class.cpp,
        jni_class.cpp, and npruntime.cpp).

2008-06-04  Alexey Proskuryakov  <ap@webkit.org>

        Rubber-stamped by Darin.

        Fix spacing in collector.{h,cpp}.

        * kjs/collector.cpp:
        * kjs/collector.h:

2008-06-03  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Maciej.

        Build fix. The cleanup in r34355 missed a method.

        * kjs/nodes.cpp:
        * kjs/nodes.h:

2008-06-03  Darin Adler  <darin@apple.com>

        Reviewed by Geoff.

        - https://bugs.webkit.org/show_bug.cgi?id=19269
          speed up SunSpider by eliminating the toObject call for most get/put/delete

        Makes standalone SunSpider 1.025x as fast as before.

        The getOwnPropertySlot virtual function now takes care of the toObject call
        for get. Similarly, the put function (and later deleteProperty) does the
        same for those operations. To do this, the virtual functions were moved from
        the JSObject class to the JSCell class. Also, since the caller no longer knows
        the identity of the "original object", which is used by JavaScript-function
        based getters, changed the PropertySlot class so the original object is
        already stored in the slot when getOwnPropertySlot is called, if the caller
        intends to call getValue.

        This affected the old interpreter code enough that the easiest thing for me
        was to just delete it. While I am not certain the mysterious slowdown is not
        still occurring, the net change is definitely a significant speedup.

        * JavaScriptCore.exp: Updated.

        * VM/Machine.cpp: Moved the UNLIKELY macro into AlwaysInline.h.
        (KJS::resolve): Set up the originalObject in the PropertySlot before
        calling getPropertySlot. Also removed the originalObject argument from
        getValue.
        (KJS::resolve_skip): Ditto.
        (KJS::resolveBaseAndProperty): Ditto.
        (KJS::resolveBaseAndFunc): Ditto.
        (KJS::Machine::privateExecute): Removed the toObject calls from the get and
        put functions where possible, instead calling directly with JSValue and letting
        the JSValue and JSCell calls handle toObject. Same for toThisObject.

        * kjs/ExecState.h: Removed OldInterpreterExecState.

        * API/JSBase.cpp: Updated includes.

        * kjs/LocalStorageEntry.h: Removed contents. Later we can remove the file too.

        * kjs/array_instance.cpp:
        (KJS::ArrayInstance::lengthGetter): Removed originalObject argumet.
        (KJS::ArrayInstance::inlineGetOwnPropertySlot): Don't pass a base value to
        setValueSlot. Also use UNLIKELY around the "getting elements past the end of
        the array" code path; less common than successfully getting an element.

        * kjs/array_object.cpp:
        (KJS::getProperty): Initialize the PropertySlot with the original object.
        Don't pass the original object to the get function.
        (KJS::arrayProtoFuncFilter): Ditto.
        (KJS::arrayProtoFuncMap): Ditto.
        (KJS::arrayProtoFuncEvery): Ditto.
        (KJS::arrayProtoFuncForEach): Ditto.
        (KJS::arrayProtoFuncSome): Ditto.

        * kjs/function_object.cpp:
        (KJS::FunctionObjectImp::construct): Removed an obsolete comment.

        * kjs/grammar.y: Eliminated support for some of the node types that were
        used to optimize executing from the syntax tree.

        * kjs/internal.cpp:
        (KJS::StringImp::toThisObject): Added. Same as toObject.
        (KJS::NumberImp::toThisObject): Ditto.
        (KJS::GetterSetterImp::getOwnPropertySlot): Added. Not reached.
        (KJS::GetterSetterImp::put): Ditto.
        (KJS::GetterSetterImp::toThisObject): Ditto.

        * kjs/internal.h: Added toThisObject to NumberImp for speed.

        * kjs/lexer.cpp:
        (KJS::Lexer::shift): Changed shift to just do a single character, to unroll
        the loop and especially to make the one character case faster.
        (KJS::Lexer::setCode): Call shift multiple times instead of passing a number.
        (KJS::Lexer::lex): Ditto.
        (KJS::Lexer::matchPunctuator): Ditto. Also removed unneeded elses after returns.
        (KJS::Lexer::scanRegExp): Ditto.
        * kjs/lexer.h: Removed the count argument from shift.

        * kjs/math_object.cpp:
        (KJS::mathProtoFuncPow): Call jsNaN instead of jsNumber(NaN).

        * kjs/nodes.cpp: Removed some of the things needed only for the pre-SquirrelFish
        execution model.
        (KJS::ForNode::emitCode): Handle cases where some expressions are missing by
        not emitting any code at all. The old way was to emit code for "true", but
        this is an unnecessary remnant of the old way of doing things.

        * kjs/nodes.h: Removed some of the things needed only for the pre-SquirrelFish
        execution model.

        * kjs/object.cpp:
        (KJS::JSObject::fillGetterPropertySlot): Changed to only pass in the getter
        function. The old code passed in a base, but it was never used when
        actually getting the property; the toThisObject call was pointless. Also
        changed to not pass a base for setUndefined.

        * kjs/object.h: Added the new JSCell operations to GetterSetterImp.
        Never called.
        (KJS::JSObject::get): Initialize the object in the PropertySlot and don't
        pass it in getValue.
        (KJS::JSObject::getOwnPropertySlotForWrite): Removed the base argument
        in calls to setValueSlot.
        (KJS::JSObject::getOwnPropertySlot): Ditto.
        (KJS::JSValue::get): Added. Here because it calls through to JSObject.
        A version of JSObject::get that also handles the other types of JSValue
        by creating the appropriate wrapper. Saves the virtual call to toObject.
        (KJS::JSValue::put): Ditto.
        (KJS::JSValue::deleteProperty): Ditto.

        * kjs/property_slot.cpp:
        (KJS::PropertySlot::undefinedGetter): Removed the originalObject argument.
        (KJS::PropertySlot::ungettableGetter): Ditto.
        (KJS::PropertySlot::functionGetter): Ditto. Use the value in the base
        as the "this" object, which will be set to the original object by the new
        PropertySlot initialization code. Also call toThisObject. The old code did
        not do this, but needed to so we can properly handle the activation object
        like the other similar code paths.

        * kjs/property_slot.h:
        (KJS::PropertySlot::PropertySlot): Added a constructor that takes a base
        object. In debug builds, set the base to 0 if you don't pass one.
        (KJS::PropertySlot::getValue): Don't take or pass the originalObject.
        (KJS::PropertySlot::setValueSlot): Don't take a base object, and clear the
        base object in debug builds.
        (KJS::PropertySlot::setGetterSlot): Ditto.
        (KJS::PropertySlot::setUndefined): Ditto.
        (KJS::PropertySlot::setUngettable): Ditto.
        (KJS::PropertySlot::slotBase): Assert that a base object is present.
        This will fire if someone actually calls the get function without having
        passed in a base object and the getter needs it.
        (KJS::PropertySlot::setBase): Added. Used by the code that implements
        toObject so it can supply the original object after the fact.
        (KJS::PropertySlot::clearBase): Added. Clears the base, but is debug-only
        code because it's an error to fetch the base if you don't have a guarantee
        it was set.

        * API/JSCallbackObject.h:
        * API/JSCallbackObjectFunctions.h:
        (KJS::JSCallbackObject::cachedValueGetter):
        (KJS::JSCallbackObject::staticValueGetter):
        (KJS::JSCallbackObject::staticFunctionGetter):
        (KJS::JSCallbackObject::callbackGetter):
        * kjs/JSActivation.cpp:
        (KJS::JSActivation::getOwnPropertySlot):
        (KJS::JSActivation::argumentsGetter):
        * kjs/JSActivation.h:
        * kjs/JSVariableObject.h:
        (KJS::JSVariableObject::symbolTableGet):
        * kjs/array_instance.h:
        * kjs/function.cpp:
        (KJS::FunctionImp::argumentsGetter):
        (KJS::FunctionImp::callerGetter):
        (KJS::FunctionImp::lengthGetter):
        (KJS::Arguments::mappedIndexGetter):
        * kjs/function.h:
        * kjs/lookup.h:
        (KJS::staticFunctionGetter):
        (KJS::staticValueGetter):
        * kjs/string_object.cpp:
        (KJS::StringInstance::lengthGetter):
        (KJS::StringInstance::indexGetter):
        (KJS::stringInstanceNumericPropertyGetter):
        * kjs/string_object.h:
        Removed originalObject arguments from getters. Don't pass base values to
        the various PropertySlot functions that no longer take them.

        * kjs/value.cpp:
        (KJS::JSCell::getOwnPropertySlot): Added. Calls toObject and then sets the slot.
        This function has to always return true, because the caller can't walk the prototype
        chain. Because of that, we do a getPropertySlot, not getOwnPropertySlot, which works
        for the caller. This is private, only called by getOwnPropertySlotInternal.
        (KJS::JSCell::put): Added. Calls toObject and then put.
        (KJS::JSCell::toThisObject): Added. Calls toObject.

        * kjs/value.h: Added get, put, and toThisObject to both JSValue
        and JSCell. These take care of the toObject operation without an additional virtual
        function call, and so make the common "already an object" case faster.

        * wtf/AlwaysInline.h: Moved the UNLIKELY macro here for now. Maybe we can find a
        better place later, or rename this header.

2008-06-03  Oliver Hunt  <oliver@apple.com>

        Reviewed by Tim.

        Bug 12983: Web Inspector break on the debugger keyword
        <https://bugs.webkit.org/show_bug.cgi?id=12983>

        Added a DebuggerStatementNode to handle codegen, and added a new
        DidReachBreakPoint debug event (which will hopefully be useful
        if we ever move breakpoint management into JSC proper).  Also
        added didReachBreakpoint to Debugger to allow us to actually respond
        to this event.

        * VM/CodeBlock.cpp:
        (KJS::debugHookName):
        * VM/Machine.cpp:
        (KJS::Machine::debug):
        * VM/Machine.h:
        * kjs/debugger.h:
        * kjs/grammar.y:
        * kjs/nodes.cpp:
        (KJS::DebuggerStatementNode::emitCode):
        (KJS::DebuggerStatementNode::execute):
        * kjs/nodes.h:
        (KJS::DebuggerStatementNode::):
        * kjs/nodes2string.cpp:
        (KJS::DebuggerStatementNode::streamTo):

2008-06-03  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Oliver.
        
        - document remaining opcodes.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute): Document call, call_eval,
        construct, ret and end opcodes.

2008-06-03  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Oliver.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute): Document throw and catch opcodes.

2008-06-02  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Alexey Proskuryakov.

        Removed JSObject::call, since it just called JSObject::callAsFunction.

        SunSpider reports no change.

2008-06-02  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.
        
        A little cleanup in the CodeGenerator.

        * VM/CodeGenerator.cpp: A few changes here.

        (1) Removed remaining cases of the old hack of putting "this" into the
        symbol table; replaced with explicit tracking of m_thisRegister.

        (2) Made m_thisRegister behave the same for function, eval, and program
        code, removing the static programCodeThis() function.

        (3) Added a feature to nix a ScopeNode's declaration stacks when done
        compiling, to save memory.

        (4) Removed code that copied eval declarations into special vectors: we
        just use the originals in the ScopeNode now.
        
        * VM/CodeGenerator.h: Removed unneded parameters from the CodeGenerator
        constructor: we just use get that data from the ScopeNode now.

        * VM/Machine.cpp:
        (KJS::Machine::execute): When executing an eval node, don't iterate a
        special copy of its declarations; iterate the originals, instead.

        * kjs/nodes.cpp: Moved responsibility for knowing what AST data to throw
        away into the CodeGenerator. Nodes no longer call shrinkCapacity on
        their data directly.
        
        * kjs/nodes.h: Changed FunctionStack to ref its contents, so declaration
        data stays around even after we've thrown away the AST, unless we explicitly
        throw away the declaration data, too. This is useful for eval code, which
        needs to reference its declaration data at execution time. (Soon, it will
        be useful for program code, too, since program code should do the same.)

2008-06-02  Adam Roben  <aroben@apple.com>

        Build fix for non-AllInOne builds

        * kjs/array_object.cpp: Added a missing #include.

2008-06-02  Kevin McCullough  <kmccullough@apple.com>

        Took out accidental confilct lines I checked in.

        * ChangeLog:

2008-06-02  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        <rdar://problem/5969992> JSProfiler: Remove the recursion limit in the
        profiler
        Implement Next Sibling pointers as groundwork for removing the recursion
        limit in the profiler.

        * profiler/ProfileNode.cpp: Also I renamed parentNode and headNode since
        'node' is redundant.
        (KJS::ProfileNode::ProfileNode): Initialize the nextSibling.
        (KJS::ProfileNode::willExecute): If there are already children then the
        new child needs to be the nextSibling of the last child.
        (KJS::ProfileNode::didExecute):
        (KJS::ProfileNode::addChild): Ditto.
        (KJS::ProfileNode::stopProfiling):
        (KJS::ProfileNode::sortTotalTimeDescending): For all of the sorting
        algorithms once the children are sorted their nextSibling pointers need
        to be reset to reflect the new order.
        (KJS::ProfileNode::sortTotalTimeAscending):
        (KJS::ProfileNode::sortSelfTimeDescending):
        (KJS::ProfileNode::sortSelfTimeAscending):
        (KJS::ProfileNode::sortCallsDescending):
        (KJS::ProfileNode::sortCallsAscending):
        (KJS::ProfileNode::sortFunctionNameDescending):
        (KJS::ProfileNode::sortFunctionNameAscending):
        (KJS::ProfileNode::resetChildrensSiblings): This new function simply
        loops over all of the children and sets their nextSibling pointers to
        the next child in the Vector
        (KJS::ProfileNode::debugPrintData):
        * profiler/ProfileNode.h:
        (KJS::ProfileNode::parent):
        (KJS::ProfileNode::setParent):
        (KJS::ProfileNode::nextSibling):
        (KJS::ProfileNode::setNextSibling):
        (KJS::ProfileNode::totalPercent):
        (KJS::ProfileNode::selfPercent):

2008-06-02  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Maciej Stachowiak.

        Removed the recursion limit from JSObject::call, since the VM does
        recursion checking now.

        This should allow us to remove JSObject::call entirely, netting a small
        speedup.

        * kjs/object.cpp:
        (KJS::JSObject::call):

2008-06-02  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Adele Peterson.

        Added a specific affordance for avoiding stack overflow when converting
        recursive arrays to string, in preparation for removing generic stack
        overflow checking from JSObject::call.
        
        Tested by fast/js/toString-stack-overflow.html.

2008-06-02  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Alice Liu.
        
        Refactored some hand-rolled code to call ScopeChain::globalObject instead.

2008-06-02  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.
        
        Fixed ASSERT due to execution continuing after an exception is thrown
        during array sort.

        * kjs/array_instance.cpp:
        (KJS::AVLTreeAbstractorForArrayCompare::compare_key_key): Don't call the
        custom comparator function if an exception has been thrown. Just return
        1 for everything, so the sort completes quickly. (The result will be
        thrown away.)

2008-05-30  Timothy Hatcher  <timothy@apple.com>

        Made the starting line number of scripts be 1-based throughout the engine.
        This cleans up script line numbers so they are all consistent now and fixes
        some cases where script execution was shown as off by one line in the debugger.

        No change in SunSpider.

        Reviewed by Oliver Hunt.

        * API/minidom.c:
        (main): Pass a line number of 1 instead of 0 to parser().parse().
        * API/testapi.c:
        (main): Ditto. And removes a FIXME and changed an assertEqualsAsNumber
        to use 1 instead of 2 for the line number.
        * VM/Machine.cpp:
        (KJS::callEval): Pass a line number of 1 instead of 0.
        (KJS::Machine::debug): Use firstLine for WillExecuteProgram instead of
        lastLine. Use lastLine for DidExecuteProgram instead of firstLine.
        * kjs/DebuggerCallFrame.cpp:
        (KJS::DebuggerCallFrame::evaluate): Pass a line number of 1 instead of
        0 to parser().parse().
        * kjs/Parser.cpp:
        (KJS::Parser::parse): ASSERT startingLineNumber is greatter than 0. Change
        the startingLineNumber to be 1 if it was less than or equal to 0. This is needed
        for release builds to maintain compatibility with the JavaScriptCore API.
        * kjs/function.cpp:
        (KJS::globalFuncEval): Pass a line number of 1 instead of 0 to parser().parse().
        * kjs/function_object.cpp:
        (FunctionObjectImp::construct): Pass a line number of 1 instead of 0 to construct().
        * kjs/lexer.cpp:
        (Lexer::setCode): Made yylineno = startingLineNumber instead of adding 1.
        * kjs/testkjs.cpp:
        (functionRun): Pass a line number of 1 instead of 0 to Interpreter::evaluate().
        (functionLoad): Ditto.
        (prettyPrintScript): Ditto.
        (runWithScripts): Ditto.
        * profiler/Profiler.cpp:
        (WebCore::createCallIdentifier): Removed a plus 1 of startingLineNumber.

2008-05-30  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        https://bugs.webkit.org/show_bug.cgi?id=19180
        speed up SunSpider by optimizing immediate number cases

        Also fixed a JavaScriptCore regression seen on PowerPC - we didn't clip left shift
        parameter to 0...31.

        0.5% improvement on SunSpider overall, although a 8.5 regression on bitops-3bit-bits-in-byte.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):

        * kjs/JSImmediate.h:
        (KJS::JSImmediate::toTruncatedUInt32): Added. Same as getTruncatedInt32, but casts the result
        to unsigned.

2008-05-30  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Oliver Hunt.

        https://bugs.webkit.org/show_bug.cgi?id=19180
        speed up SunSpider by optimizing immediate number cases

        Also fixed two JavaScriptCore regressions seen on PowerPC - we didn't clip right shift
        parameter to 0...31.

        1.6% improvement on SunSpider, without significant regressions on any tests.

        * VM/Machine.cpp:
        (KJS::Machine::privateExecute):
        Added fast paths for >>, ==, ===, !=, !==. Changed order of memory accesses in many
        cases, making them less dependent on gcc's ability to properly assign registers. With this,
        I could move exception checks back into slow code paths, and saw less randomness in general.

        * kjs/JSImmediate.h:
        (KJS::JSImmediate::rightShiftImmediateNumbers):
        Added.

2008-05-29  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Oliver.

        - fixed <rdar://problem/5972943> REGRESSION(r33979): Flash clips do not play on cnn.com
        
        Finally blocks could clobber registers that had to remain live
        until they returned. This patch takes a conservative approach and
        makes sure that finally blocks do not reuse any registers that
        were previously allocated for the function. In the future this
        could probably be tightened up to be less profligate with the
        register allocation.
        
        * VM/CodeGenerator.cpp:
        (KJS::CodeGenerator::highestUsedRegister):
        * VM/CodeGenerator.h:
        * kjs/nodes.cpp:
        (KJS::TryNode::emitCode):

2008-05-29  Steve Falkenburg  <sfalken@apple.com>

        Build fix.

        * kjs/array_instance.cpp:

2008-05-29  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

